import math

a = int(input())
b = int(input())

sqrs = []
for i in range(math.floor(a ** 0.5), math.ceil(b ** 0.5) + 1):
    if len(sqrs) == 0:
        t = i ** 2
    else:
        t += 2 * i - 1

    if str(t)[0] not in ['2', '3', '7', '8'] and t % 10 != 0:
        sqrs.append(t)

cnt = 0
for sqr in sqrs:
    rev = int(str(sqr)[::-1])

    if rev < a or rev > b:
        continue

    l = 0
    r = len(sqrs)

    while r - l > 1:
        m = (l + r) // 2

        if sqrs[m] > rev:
            r = m
        else:
            l = m

    if sqrs[l] != rev:
        continue

    cnt += 1

print(cnt)
