#include <bits/stdc++.h>
using namespace std;

#define endl      '\n'
#define sz(x)     int((x).size())
#define all(x)    (x).begin(), (x).end()
#define rall(x)   (x).rbegin(), (x).rend()
#define fi        first
#define se        second
#define pb        push_back
using ll = long long;
using pii = pair<int, int>;

int32_t main(){
	ios::sync_with_stdio(0), cin.tie(0);

	int n, m;
	cin >> n >> m;
	vector<int> cost(n);
	vector<int> g[n];

	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		g[u - 1].push_back(v - 1);
		g[v - 1].push_back(u - 1);
	}

	long long x; cin >> x;

	for (int i = 0; i < n; i++) {
		cin >> cost[i];
	}

	vector<long long> d(n, -1);
	vector<char> used(n, 0);
	priority_queue<pair<long long, int>> q;

	if (cost[0] >= x) {
		q.push({x/2, 0});
		d[0] = x/2;
	} else {
		q.push({x, 0});
		d[0] = x;
	}

	while (!q.empty()) {
		int v = q.top().second; q.pop();
		if (used[v]) continue;
		used[v] = 1;
		for (auto u : g[v]) {
			if (d[v] > cost[u]) {
				if (d[v] > d[u]) {
					d[u] = d[v];
					q.push({d[u], u});
				}
			} else {
				if (d[v]/2 > d[u]) {
					d[u] = d[v]/2;
					q.push({d[u], u});
				}
			}
		}
	}

	cout << d[n-1] << '\n';

	return 0;
}
