#include <fstream>
#include <iostream>
#include <vector>
#include <unordered_map>
#include <set>
#include <algorithm>
#include <cassert>
#include <functional>
#include <cstdlib>
#include <string>
using namespace std;

typedef pair <int, int> ii;
typedef long long ll;

vector <ll> pref;

ll getSum(int l, int r) {
    if (l > r) return 0;
    return pref[r + 1] - pref[l];
}

int main() {

//    ifstream cin("input.txt");
  //  ofstream cout("output.txt");

    int n; cin >> n;
    set <ii> t;
    vector <ll> val;
    pref.resize(n + 1);

    for (int i = 0; i < n; i++)
        for (int j = i; j >= 0; j--) {
            if (t.find({ j, i }) == t.end()) {
                cout << "? " << j + 1 << ' ' << i + 1 << endl;
                ll s, a, b; cin >> s >> a >> b;
                t.insert({ a - 1, b - 1 });
                val.push_back(s - getSum(j, i - 1));
                pref[i + 1] = val.back() + pref[i];
                break;
            }
        }

    cout << '!' << endl;
    for (int i = 0; i < n; i++)
        cout << val[i] << ' ';

   // system("pause");

}