#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("O3")
#pragma GCC target ("avx2")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define pb push_back

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set =
tree<T, null_type, less<T>, rb_tree_tag, 
tree_order_statistics_node_update>;

typedef long long ll;
#define int long long

signed main() {
  	ios_base::sync_with_stdio(0);
  	cin.tie(0); cout.tie(0);
  	int n, m, x1, x2;
  	cin >> n >> m;
  	ll dp[n][m + 1], dp2[n][m + 1];
  	memset(dp, 0, sizeof dp);
  	for (int i = 0; i < n; ++i) dp2[i][0] = 0;
  	for (int i = 0; i < n; ++i) for (int j = 1; j <= m; ++j) dp2[i][j] = LLONG_MAX;
  	pair<ll, ll> v[m + 1];
  	for (int i = 1; i <= m; ++i) {
  		cin >> x1 >> x2;
  		v[i] = {x1 - 1, x2 - 1};
  	}
  	for (int j = 1; j <= m; ++j) {
  		ll k = v[j].second - v[j].first + 1;
  		for (int i = 0; i < n - k + 1; ++i) {
  			dp[i][j] = dp2[i][j - 1] + abs(v[j].first - i);
  		}
  		for (int i = 0; i < n - k + 1; ++i) {
  			for (int ii = i; ii < i + k; ++ii) {
  				dp2[ii][j] = min(dp2[ii][j], dp[i][j]); 
  			}
  		}
  		for (int i = n - 1; i >= k - 1; --i) {
  			dp[i][j] = dp2[i][j - 1] + abs(v[j].second - i);
  		}
  		for (int i = n - 1; i >= k - 1; --i) {
  			for (int ii = i; ii > i - k; --ii) {
  				dp2[ii][j] = min(dp2[ii][j], dp[i][j]); 
  			}
  		}
  	}
  	/*for (int i = 0; i < n; ++i) {
  		for (int j = 0; j <= m; ++j) {
  			cout << dp[i][j] << " ";
  		}
  		cout << "\n";
  	} */
  	
  	ll ans = LLONG_MAX;
  	for (int i = 0; i < n; ++i) {
  		ans = min(ans, dp2[i][m]);
  	}
  	cout << ans;                            	
  	return 0;                    
}
