#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("O3")
#pragma GCC target ("avx2")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define pb push_back

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set =
tree<T, null_type, less<T>, rb_tree_tag, 
tree_order_statistics_node_update>;

typedef long long ll;

const int N = 3e5;

int n, m, x, a[N], d[N];
vector<int> adj[N];

void go() {
	d[1] = (x > a[1] ? x : x / 2);
	queue<int> q;
	q.push(1);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto to : adj[v]) {
			if (d[v] > a[to]) {
				if (d[v] > d[to]) {
					d[to] = d[v];
					q.push(to);
				}
			}
			else {
				if (d[v] / 2 > d[to]) {
					d[to] = d[v] / 2;
					q.push(to);
				}	
			}
		}
	}
}

int main() {
  	ios_base::sync_with_stdio(0);
  	cin.tie(0); cout.tie(0);
  	//freopen(".in", "r", stdin);
  	//freopen(".out", "w", stdout);
  	cin >> n >> m;
  	while (m--) {
  		int u, v;
  		cin >> u >> v;
  		adj[u].pb(v);
  		adj[v].pb(u);
  	}
  	cin >> x;
  	for (int i = 1; i <= n; i++) cin >> a[i];
  	go();
  	cout << d[n];
  	return 0;
}
