﻿#include <ctime>
#include <random>
#include <cassert>
#include <cmath>
#include <algorithm>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <bitset>
#include <queue>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;


signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); cout.precision(30);
	ll a, b;
	cin >> a >> b;
	bool c1 = (a < 0), c2 = (b < 0);
	a = abs(a);
	b = abs(b);
	int type = 2;
	if (a > b) {
		type = 1;
		swap(a, b);
	}
	vector <pair <int, int>> order;
	while (a != 0) {
		order.push_back({ type, -(b / a) });
		type = 3 - type;
		b %= a;
		swap(a, b);
	}
	cout << order.size() << "\n";
	for (auto p : order) {
		type = p.first, a = p.second;
		if (c2 && c1 || !c2 && !c1) {
			cout << type << " " << a << "\n";
			continue;
		}
		else {
			cout << type << " " << -a << "\n";
		}
	}
	return 0;
}