#include <bits/stdc++.h>
using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < n; ++i) {
        int v, u;
        cin >> v >> u; --v; --u;
        g[v].push_back({u, 0});
        g[u].push_back({v, 0});
    }
    int x;
    cin >> x;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < (int)g[i].size(); ++j) {
            g[i][j].second = a[g[i][j].first];
        }
    }
    vector<bool> vis(n, false);
    vector<int> rest(n, 0);
    rest[0] = x;
    if (a[0] >= x) {
        rest[0] /= 2;
    }
    priority_queue<pair<int, int>> q;
    q.push({rest[0], 0});
    while (!q.empty()) {
        int v = q.top().second; q.pop();
        if (vis[v]) { continue; }
        vis[v] = true;
        for (const auto& [u, price] : g[v]) {
            int new_rest = rest[v];
            if (price >= rest[v]) {
                new_rest /= 2;
            }
            if (new_rest > rest[u]) {
                rest[u] = new_rest;
                q.push({new_rest, u});
            }
        }
    }
    cout << rest[n - 1] << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
