#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <math.h>
#include <functional>
#include <string>
using namespace std;
#define all(o) (o).begin(), (o).end()
#define rall(o) (o).rbegin(), (o).rend()
using ll = long long;
#if LOCAL
#define dbg(o) {cout << #o << " = " << (o) << "\n"; o;}
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &out, vector<T> v) {
    for (T e : v) {
        out << e << " ";
    }
    return out;
}
template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &e : v) {
        in >> e;
    }
    return in;
}

void solve() {
    int n, l, r;
    cin >> n >> l >> r;
    vector<int> a(n);
    vector<int> b(n);
    vector<int> p(n);
    cin >> a >> b;
    iota(all(p), 0);
    sort(all(p), [&](int li, int ri) {
        return (a[li] - b[li] > a[ri] - b[ri]);
    });
    dbg(p);
    vector<char> result(n);
    ll sum = 0;
    for (int k = 0; k < l; ++k) {
        int i = p[k];
        result[i] = 'T';
        sum += a[i];
    }

    for (int k = n - r; k < n; ++k) {
        int i = p[k];
        result[i] = 'P';
        sum += b[i];
    }

    for (int k = l; k < n - r; ++k) {
        int i = p[k];
        if (a[i] > b[i]) {
            result[i] = 'T';
            sum += a[i];
        } else {
            result[i] = 'P';
            sum += b[i];
        }
    }

    cout << sum << "\n";
    for (int i = 0; i < n; ++i) {
        cout << result[i] << " ";
    }
    cout << "\n";
}

int main() {
    cout.precision(16);
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#if LOCAL
    freopen("../A.in", "r", stdin);
    // freopen("../A.out", "w", stdout);
#endif
    solve();
    return 0;
}
