#include <bits/stdc++.h>
#define x first
#define y second
#define int long long
using namespace std;

struct rat{
    int p, q;
    rat(){
        p = 0;
        q = 1;
    }
    rat(int x){
        p = x;
        q = 1;
    }
    rat(int _p, int _q){
        p = _p;
        q = _q;
    }
    rat operator+(const rat& b) const{
        return rat(p*b.q+b.p*q, q*b.q).norm();
    }
    rat operator*(const rat& b) const{
        return rat(p*b.p, q*b.q).norm();
    }
    rat operator-(const rat& b) const{
        return rat(p*b.q-b.p*q, q*b.q).norm();
    }
    rat operator/(const rat& b) const{
        return rat(p*b.q, q*b.p).norm();
    }
    rat norm(){
        return rat(p/__gcd(p, q), q/__gcd(p, q));
    }
   bool operator==(const rat& b) const{
        rat dif = *this-b;
        if(dif.p==0)
            return 1;
        return 0;
    }
    bool operator<(const rat& b) const{
        rat dif = *this-b;
        if(dif.p*dif.q<0)
            return 1;
        return 0;
    }
};

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    rat v[n], s[n];
    for(int i = 0; i<n; i++){
        int v1, v2;
        cin >> v1 >> v2;
        s[i] = rat(v1);
        v[i] = rat(v2);
    }
    int ans = 0;
    for(int a = 0; a<n; a++){
        vector<pair<rat, rat>> all;
        for(int b = 0; b<n; b++){
            rat sb = s[b]-s[a];
            rat b0 = rat(b)-rat(a);
            for(int c = b+1; c<n; c++){
                if(b==a || c==a)
                    continue;
                rat vb = v[b]-v[a];
                rat vc = v[c]-v[a];
                rat sc = s[c]-s[a];
                rat c0 = rat(c)-rat(a);
                if((vb*c0-vc*b0)==rat(0)){
                    continue;
                }
                rat t = (sc*b0-sb*c0)/(vb*c0-vc*b0);
                rat k = (vb*t+sb)/b0;
                all.push_back({t, k});
            }
            if(b!=a)
                all.push_back({rat(0), sb/b0});
        }
        for(auto z:all){
            if(z.x<rat(0))
                continue;
            int cnt = 0;
            for(int b = 0; b<n; b++){
                rat sb = s[b]-s[a];
                rat b0 = rat(b)-rat(a);
                rat vb = v[b]-v[a];
                if(vb*z.x+sb==z.y*b0)
                    cnt++;
            }
            ans = max(ans, cnt);
        }
    }
    cout << ans;
    return 0;
}
/*
4
1 1
2 2
3 3
10 1
*/
