#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()

const int inf = 1e9;

int solve(int n, int m, int y, const vector<pair<int, int>> &a) {
	vector<pair<int, int>> ans(n);
	ans[y] = a[y];
	int sum = 0;
	for (int i = y - 1; i >= 0; --i) {
		// me - i, prev - i + 1
		ans[i] = a[i];
		int len = a[i].second - a[i].first;
		if (a[i].second < ans[i + 1].first) {
			ans[i].second = ans[i + 1].first;
			ans[i].first = ans[i].second - len;
		}
		else if (a[i].first > ans[i + 1].second) {
			ans[i].first = ans[i + 1].second;
			ans[i].second = ans[i].first + len;
		}
		sum += abs(ans[i].second - a[i].second);
	}
	for (int i = y + 1; i < n; ++i) {
		// me - i, prev - i - 1
		ans[i] = a[i];
		int len = a[i].second - a[i].first;
		if (a[i].second < ans[i - 1].first) {
			ans[i].second = ans[i - 1].first;
			ans[i].first = ans[i].second - len;
		}
		if (a[i].first > ans[i - 1].second) {
			ans[i].first = ans[i - 1].second;
			ans[i].second = ans[i].first + len;
		}
		sum += abs(ans[i].second - a[i].second);
	}
	return sum;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int m, n;
	cin >> m >> n;
	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i].first >> a[i].second;
	int ans = 2 * int(1e9);
	for (int i = 0; i < n; ++i)
		ans = min(ans, solve(n, m, i, a));
	cout << ans;
	return 0;
}