#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()

const int inf = 1e9;

int main() {
	int n, m; cin >> n >> m;
	vector<vector<int>> g(n);
	for (int i = 0; i < m; i++) {
		int v, u; cin >> v >> u;
		v--; u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	int x; cin >> x;
	vector<int> a(n);
	for (auto& c : a) {
		cin >> c;
	}

	set<pair<int, int>> buf;
	vector<int> dp(n, -inf);
	if (x > a[0])
		dp[0] = x;
	else
		dp[0] = x / 2;

	for (int i = 0; i < n; i++) {
		buf.insert({ dp[i], i });
	}

	for (int i = 0; i < n; i++) {
		pair<int, int> v = *buf.rbegin();
		buf.erase(v);
		for (auto to : g[v.second]) {
			int new_val;
			if (v.first > a[to])
				new_val = v.first;
			else
				new_val = v.first / 2;
			if (dp[to] < new_val) {
				buf.erase({ dp[to], to });
				dp[to] = new_val;
				buf.insert({ dp[to], to });
			}
		}
	}

	cout << dp[n - 1];
	return 0;
}