#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()

map<char, bool> mp;

int cnt(string s) {
	int ans = 0;
	bool fl = 0;
	for (int i = 0; i < s.size(); i++) {
		if (mp[s[i]]) {
			if (fl)
				continue;
			else
				ans++, fl = 1;
		}
		else
			fl = 0;
	}
	return ans;
}

int main() {

	int n;
	cin >> n;
	mp['a'] = 1;
	mp['e'] = 1;
	mp['i'] = 1;
	mp['o'] = 1;
	mp['u'] = 1;
	vector<int> a(n + 1);
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		a[i + 1] = cnt(s);
	}

	for (int i = 1; i <= n; i++) {
		a[i] = a[i - 1] + a[i];
	}
	int ans = 0;
	for (int i = 0; i < n; i++) {
		int pos = i;
		auto it = lower_bound(all(a), a[pos] + 5);
		if (it == a.end())
			continue;
		pos = it - a.begin();
		if (a[pos] != a[i] + 5)
			continue;
		it = lower_bound(all(a), a[pos] + 7);
		if (it == a.end())
			continue;
		pos = it - a.begin();
		if (a[pos] != a[i] + 12)
			continue;
		it = lower_bound(all(a), a[pos] + 5);
		if (it == a.end())
			continue;
		pos = it - a.begin();
		if (a[pos] != a[i] + 17)
			continue;
		ans++;
	}
	cout << ans;
	return 0;
}