#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

typedef long long ll;


bool is_square(ll x) {
    return (ll(sqrt(x)) * ll(sqrt(x)) == x);
}


ll reverse(ll x) {
    ll r = 0;
    while(x) {
        r *= 10;
        r += x % 10;
        x /= 10;
    }
    return r;
}


ll len(ll x) {
    ll r = 0;
    while(x) {
        r++;
        x /= 10;
    }
    return r;
}

int main() {
    ll a, b;
    cin >> a >> b;
    ll cnt = 0;
    for (ll i = ll(sqrt(a)); i * i <= b; i++) {
        if (is_square(reverse(i * i)) && len(reverse(i * i)) == len(i * i)) {
            cnt += 1;
        }
    }
    cout << cnt;
    return 0;
}
