import java.io.*;
import java.util.StringTokenizer;

public class C {

    public static BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    public static BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));
    public static StringTokenizer tokenizer = null;

    public static String next() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(reader.readLine());
        return tokenizer.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void flush() throws IOException {
        writer.flush();
    }

    public static void println() throws IOException {
        writer.newLine();
    }

    public static void print(String s) throws IOException {
        writer.write(s);
    }

    public static void println(String s) throws IOException {
        print(s);
        println();
    }


    public static void main(String[] args) throws IOException {
        taskC();
    }

    public static void taskC() throws IOException {
        int n = nextInt(), m = nextInt();
        int[] s = new int[m], t = new int[m];
        for (int i = 0; i < m; i++) {
            s[i] = nextInt();
            t[i] = nextInt();
        }
        double avg = 0;
        for (int i = 0; i < m; i++) avg += 0.5 * (t[i] + s[i]);
        avg /= m;
        int res = 0;
        for (int i = 0; i < m; i++) {
            double dist = avg < s[i] ? s[i] - avg : avg > t[i] ? avg - t[i] : 0;
            res += (int) dist;
        }
        println(res + "");
        flush();
    }



}
