import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class H {

    public static BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    public static BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));
    public static StringTokenizer tokenizer = null;

    public static String next() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(reader.readLine());
        return tokenizer.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void flush() throws IOException {
        writer.flush();
    }

    public static void println() throws IOException {
        writer.newLine();
    }

    public static void print(String s) throws IOException {
        writer.write(s);
    }

    public static void println(String s) throws IOException {
        print(s);
        println();
    }

    public static void main(String[] args) throws IOException {
        taskH();
    }

    public static void taskH() throws IOException {
        long a = Long.parseLong(next());
        long b = Long.parseLong(next());
        List<String> commands = new ArrayList<>();
        while (a != 0 && b != 0) {
            if (Math.abs(a) >= Math.abs(b)) {
                long k = a / b;
                a -= b * k;
                commands.add("1 " + -k);
            } else {
                long k = b / a;
                b -= a * k;
                commands.add("2 " + -k);
            }
        }
        println(commands.size() + "");
        for (int i = 0; i < commands.size(); i++) println(commands.get(i));
        flush();
    }




}
