//
// Created by michael on 14.11.2021.
//

#include <bits/stdc++.h>
using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

typedef long long ll;

const int INF = 0x3f3f3f3f;

bool good(char c) {
    return c == 'a' || c == 'e' || c == 'i' || c == 'o' || c == 'u';
}

int get(const string &s) {
    int cur = 0;
    int cnt = 0;
    for (auto &elem : s) {
        if (good(elem)) {
            ++cur;
        } else {
            if (cur != 0) ++cnt;
            cur = 0;
        }
    }
    if (cur != 0) ++cnt;
    return cnt;
}

void solve() {
    int n;
    cin >> n;
    vector<int> cnt(n);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        cnt[i] = get(s);
    }

    int res = 0;

    for (int i = 0; i < n; ++i) {
        vector<int> pref;
        pref.push_back(0);
        for (int j = i; j < n; ++j) {
            if (pref.back() > 17) break;
            pref.push_back(pref.back() + cnt[j]);
        }
        if (binary_search(all(pref), 5) && binary_search(all(pref), 12) && binary_search(all(pref), 17)) ++res;
    }
    cout << res;
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
