
#include <bits/stdc++.h>

using namespace std;

struct tree
{
    vector <int> t;
    int n;

    tree (int n) {
        this->n = n;
        t.resize(4 * n + 5, 1e9);
    }

    int get(int v, int tl, int tr, int l, int r) {
        if (l > tr || r < tl) {
            return 1e9;
        }
        if (l <= tl && tr <= r) {
            return t[v];
        }
        int m = (tl + tr) / 2;
        return min(get(v * 2, tl, m, l, r), get(v * 2 + 1, m + 1, tr ,l, r));
    }

    int get_min(int l, int r) {
        return get(1, 1, n, l, r);
    }

    void set(int v, int tl, int tr, int pos, int val) {
        if (tl == tr) {
            t[v] = val;
            return;
        }
        int m = (tl + tr) / 2;
        if (pos <= m) {
            set(v * 2, tl, m, pos, val);
        }
        else {
            set(v * 2 + 1, m + 1, tr, pos, val);
        }
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }

    void set(int pos, int val) {
        set(1, 1, n, pos, val);
    }
};

int main ()
{
    int n, m; cin >> n >> m;

    int s[m+1], l[m+1];

    for (int i = 1; i <= m; i++)
    {
        int t;
        cin >> s[i] >> t;
        l[i] = t-s[i]+1;
    }

    vector <tree> dp(m+1, tree(n+1));

    for (int i = 0; i <= n; i++)
    {
        dp[0].set(i, 0);
    }

    for (int i = 1; i <= m; i++)
    {
        for (int j = 1; j <= n-l[i]+1; j++)
        {
            int v = dp[i-1].get_min(max(1, j-l[i-1]+1), j+l[i]-1) + abs(j-s[i]);
//            cout << v << ' ' << j+l[i]-1 << ' ' << max(1, j-l[i-1]+1) << " | ";
            dp[i].set(j, v);
        }
//        cout << endl;
    }

    int ans = 1e9;

    for (int i = 1; i <= n; i++)
    {
        ans = min(ans, dp[m].get_min(i, i));
    }

    cout << ans << endl;
}
