#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
mt19937 rng(228);
const int N = 2e5 + 113;
int l[N], len[N];
struct window{
    deque<pair<ll, int>> d;
    void add(pair<ll, int> val) {
        while (d.size() && d.back() >= val)
            d.pop_back();
        d.push_back(val);
    }
    void erase(int index) {
        if (d.size() && d.front().second == index)
            d.pop_front();
    }
    ll getmin() {
        if (d.empty())
            return 1e18;
        return d.front().first;
    }
};
signed main() {
    int n, m;
    cin >> m >> n;
    vector<vector<ll>> dp(n + 1, vector<ll>(m, 1e18));
    dp[0][0] = 0;
    l[0] = 0, len[0] = m;
    for (int i = 1; i <= n; i++) {
        int l1, r1;
        cin >> l1 >> r1;
        l1--, r1--;
        l[i] = l1, len[i] = r1 - l1 + 1;
    }
    for (int i = 1; i <= n; i++) {
        window w;
        for (int g = 0; g < len[i]; g++)
            w.add({dp[i - 1][g], g});
        for (int j = 0; j < m; j++) {
            if (j + len[i] - 1 < m)
                w.add({dp[i - 1][j + len[i] - 1], j + len[i] - 1});
            if (j - len[i - 1] >= 0)
                w.erase(j - len[i - 1]);
            dp[i][j] = w.getmin() + abs(j - l[i]);
        }
    }
    ll minans = 1e18;
    for (int j = 0; j < m; j++) {
        minans = min(minans, dp[n][j]);
    }
    cout << minans << endl;
}