
#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <map>
#include <set>
#include <cstdio>
#include <vector>
#include <cmath>
#include <queue>
#include <numeric>
#include <climits>
#include <random>
#include <fstream>
#include <cstdlib>
#include <bitset>
#include <deque>
#include <iterator>
using namespace std;

template <typename T> inline T getint() {
    T val = 0;
    char c;
    bool neg = false;
    while ((c = getchar()) && !(c >= '0' && c <= '9')) {
        neg |= c == '-';
    }
    do {
        val = (val * 10) + c - '0';
    } while ((c = getchar()) && (c >= '0' && c <= '9'));
    return val * (neg ? -1 : 1);
}

typedef long long ll;
typedef long double ld;
const ll INF = LLONG_MAX;

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}

const ll maxn =  1e5;
const ld eps = 1e-10;

bool isQ(ll n){
    return ((ll)(sqrt(n)) * (ll)(sqrt(n))) == n;
}
ll rev(ll n){
    vector<ll> vv;
    while (n > 0){
        vv.push_back(n%10);
        n /= 10;
    }
    ll ans = 0;
    for (ll i = 0; i < vv.size(); i++){
        ans *= 10;
        ans += vv[i];
    }
    return ans;
}


int main() {
    std::ios::sync_with_stdio(false);
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //cout << rev(123456789);
    ll A, B;
    cin >> A >> B;
    ll sqA = (ll)(sqrt(A)), sqB = (ll)(sqrt(B));
    if (sqA * sqA < A){
        sqA++;
    }
    ll ans = 0;
    for (ll i = sqA; i <= sqB; i++){
        if (i % 10 == 0)
            continue;
        if(isQ(rev(i * i))){
            ans++;
            //cout << i * i << '\n';
        }
    }
    cout << ans;
}
