#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>

#define int long long
using namespace std;

vector<int> g1;
vector<int> g2;

bool cmp(int a, int b) {
    return (g1[a] - g2[a]) < (g1[b] - g2[b]);
}

bool cmp1(int a, int b) {
    return (g1[a] - g2[a]) > (g1[b] - g2[b]);
}

signed main() {
    int n, a, b;
    cin >> n >> a >> b;
    g1.resize(n);
    g2.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> g1[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> g2[i];
    }
    vector<int> k(n);
    for (int i = 0; i < n; i++) {
        k[i] = abs(g1[i] - g2[i]);
    }
    vector<char> d(n);
    int p = 0, t = 0;
    for (int i = 0; i < n; i++) {
        if (g1[i] < g2[i]) {
            d[i] = 'P';
            p++;
        } else {
            d[i] = 'T';
            t++;
        }
    }
    if (a > t and p >= b) {
        deque<int> dd;
        for (int i = 0; i < n; i++) {
            if (d[i] == 'P') {
                dd.push_back(i);
            }
        }
        sort(dd.begin(), dd.end(), cmp1);
        while (t < a) {
            d[dd.front()] = 'T';
            dd.pop_front();
            t++;
        }
    } else {
        deque<int> dd;
        for (int i = 0; i < n; i++) {
            if (d[i] == 'T') {
                dd.push_back(i);
            }
        }
        sort(dd.begin(), dd.end(), cmp);
        while (p < b) {
            d[dd.front()] = 'P';
            dd.pop_front();
            p++;
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        if (d[i] == 'T') {
            cnt += g1[i];
        } else {
            cnt += g2[i];
        }
    }
    cout << cnt << endl;
    for (auto c: d)
    {
        cout << c << " ";
    }
}
