#define _USE_MATH_DEFINES

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <cmath>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <ctime>
#include <numeric>
#include <random>

#define int long long
#define uint unsigned long long
#define double long double

#ifdef DIDEDOSHKA
#define start cout.setf(ios::fixed); cout.precision(10); int START = clock()
#define finish cout << "\ntime: " << (clock() - START) / (double)(CLOCKS_PER_SEC); return 0
#else
#define start cout.precision(10);
#define finish return 0
#endif

using namespace std;


//vector input
template<typename T>
istream &operator>>(istream &is, vector<T> &vec) {
	for (auto &i : vec) {
		is >> i;
	}
	return is;
}

//vector output
template<typename T>
ostream &operator<<(ostream &os, vector<T> &vec) {
	for (T i : vec) {
		os << i << ' ';
	}
	return os;
}

//2 dimensional vector output
template<typename T>
ostream &operator<<(ostream &os, vector<vector<T>> &vec) {
	for (vector<T> i : vec) {
		os << i << '\n';
	}
	return os;
}

void solve() {
	int n;
	cin >> n;
	vector<int> ans(n + 1);
	vector<int> pref_sum(n + 2);
	cout << "? " << 1 << ' ' << 1 << endl;
	int sum, l, r;
	cin >> sum >> l >> r;
	ans[1] = sum;
	pref_sum[1] += sum;
	vector<set<int>> a(n + 1);
//	for (int i = 1; i < n + 1; i++) {
//		for (int j = 1; j < i + 1; j++) {
//			a[i].insert(j);
//		}
//	}
	a[r].insert(l);
	for (int i = 2; i < n + 1; i++) {
		int curl;
		for (int j = 1; j <= i; j++) {
		    if (!a[i].count(j)) {
		    	curl = j;
		    }
		}
		
//		int curl = *a[i].lower_bound(1);
		cout << "? " << curl << ' ' << i << endl;
		cin >> sum >> l >> r;
		int cur = sum - (pref_sum[i - 1] - pref_sum[curl - 1]);
		pref_sum[i] = pref_sum[i - 1] + cur;
		a[r].insert(l);
		ans[i] = cur;
	}
	cout << "! ";
	for (int i = 1; i < n+1; i++) {
	    cout << ans[i] << ' ';
	}
}

int32_t main() {
	start;
	
	solve();
	
	finish;
}