#define _USE_MATH_DEFINES

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <cmath>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <ctime>
#include <numeric>
#include <random>

#define int long long
#define uint unsigned long long
#define double long double

#ifdef DIDEDOSHKA
#define start cout.setf(ios::fixed); cout.precision(10); int START = clock()
#define finish cout << "\ntime: " << (clock() - START) / (double)(CLOCKS_PER_SEC); return 0
#else
#define start cin.tie(NULL); cout.tie(NULL); cout.setf(ios::fixed); cout.precision(10); ios_base::sync_with_stdio(false)
#define finish return 0
#endif

using namespace std;


//vector input
template<typename T>
istream &operator>>(istream &is, vector<T> &vec) {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

//vector output
template<typename T>
ostream &operator<<(ostream &os, vector<T> &vec) {
    for (T i : vec) {
        os << i << ' ';
    }
    return os;
}

//2 dimensional vector output
template<typename T>
ostream &operator<<(ostream &os, vector<vector<T>> &vec) {
    for (vector<T> i : vec) {
        os << i << '\n';
    }
    return os;
}

vector<int> itov(int a) {
	vector<int> ans;
	while (a != 0) {
		ans.push_back(a % 10);
		a/= 10;
	}
	reverse(ans.begin(), ans.end());
	return ans;
}

int vtoi(vector<int> c) {
	int base = 1;
	int ans = 0;
	if (c.back() == 0) {
		return INT64_MAX;
	}
	for (int i = 0; i < c.size(); i++) {
		ans += c[i] * base;
	    base *= 10;
	}
	return ans;
}

void solve() {
	int a, b;
	cin >> a >> b;
	map<int, int> m;
	int ans1 = 0;
	int ans2 = 0;
	for (int i = 1; i * i <= b; i++) {
	    m[i * i] = 1;
	}
	int i;
	for (i = 1; i * i < a; i++) {
	    if (m.count(vtoi(itov(i * i)))) {
//	    	cout << i*i << '\n';
	    	ans1 += 1;
	    	ans2 += 1;
	    }
	}
	for (; i * i <= b; i++) {
		if (m.count(vtoi(itov(i * i)))) {
//			cout << i*i << '\n';
			ans1 += 1;
		}
	}
	cout << ans1 - ans2 << '\n';
//	cout << ans2 << '\n';
	
//	for (auto [elem,val] : m) {
//		cout << elem << '\n';
//
//	}
}

int32_t main() {
    start;

    solve();

    finish;
}