#include <unordered_set>
#include <unordered_map>
//#include <ext/rope>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <chrono>
#include <string>
#include <vector>
#include <bitset>
#include <cstdio>
#include <random>
#include <stack>
#include <cmath>
#include <queue>
#include <ctime>
#include <map>
#include <set>

//using namespace __gnu_cxx;
using namespace std;

/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")*/

typedef long long ll;   
typedef long double ld;
typedef pair <int, int> ii;
typedef pair <ll, ll> dl;
typedef vector <vector <int> > graph;

#define pb push_back
#define eb emplace_back 
#define ff first
#define ss second
#define show(x) cerr << (#x) << "=" << x << '\n'
#define ptree_node tree_node*
#define sqr(a) ((a) * (a))
#define all(x) (x).begin(), (x).end()
 
const int INF = 1e9;
const ld EPS = 1e-8;
const ld PI = atan2(0.0, -1.0);
const int M = 1e9;
const int MAXN = 2 * 1e5;

#define fast() ios_base::sync_with_stdio(0); cin.tie(0)

vector<int> words;

int main() {
    fast();
    
    #ifdef _LOCAL
        clock_t Tsart = clock();
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    set<char> cont = {'a', 'e', 'i', 'o', 'u'};
    int n;
    cin >> n;

    words.resize(n + 1, 0);

    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < s.size(); j++) {
            if ((cont.count(s[j]) && (j != 0 && !cont.count(s[j - 1]))) || (j == 0 && cont.count(s[j]))) {
                words[i + 1]++;
            }
        }
    }

    pair<int, int> p1 = {0, 0}, p2 = {1, words[1]};
    while (p2.second < 5) {
        p2.first++;
        p2.second += words[p2.first];
    }
    pair<int, int> p3 = {p2.first + 1, words[p2.first + 1]};
    while (p3.second < 7) {
        p3.first++;
        p3.second += words[p3.first];
    }
    pair<int, int> p4 = {p3.first + 1, words[p3.first + 1]};
    while (p3.second < 5) {
        p4.first++;
        p4.second += words[p4.first];
    }

    int cnt = 0;

    while (p4.second <= n) {
        if (p2.second == 5 && p3.second == 7 && p4.second == 5)
            cnt++;

        p1.first++;
        p1.second = words[p1.first];
        p2.second -= p1.second;
        while(p2.second < 5 && p2.second <= n) {
            p2.first++;
            p2.second += words[p2.first];
            p3.second -= words[p2.first];
        }
        while(p3.second < 7 && p3.second <= n) {
            p3.first++;
            p3.second += words[p3.first];
            p4.second -= words[p3.first];
        }
        while(p4.second < 5 && p4.second <= n) {
            p4.first++;
            p4.second += words[p4.first];
        }        
    }

    cout << cnt << '\n';

    #ifdef _LOCAL
        cerr << "Runtime: " << (ld)(clock() - Tsart) / CLOCKS_PER_SEC << '\n';
    #endif 
    return 0;
}