#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ctime>
#include <ext/rope>

using namespace std;
using namespace __gnu_cxx;

#define fast() {\
    ios_base::sync_with_stdio(false);\
    cin.tie(0);\
    cout << fixed << setprecision(0);\
}
#define op(){\
    freopen("input.txt", "r", stdin);\
    freopen("output.txt", "w", stdout);\
}

#define f first
#define s second
#define pb push_back
#define sqr(a) ((a) * (a))

using ll = long long;
using ld = long double;

using pl = pair <ll, ll>;
using pd = array<double, 2>;
using pld = array<ld, 2>;
using graph = vector<vector<ll> >;
using vll = vector<ll>;
using vii = vector<int>;
using vdd = vector<double>;

const ll INF = 1e+9 + 7;
const ll MEGAINF = 1e18 + 7;
const ll P = 31;
const ld EPS = 1e-6;
const ld PI = 3.14159265358979323;
const int MAXN = 1e6 + 10;
const int LOG = 30;

int n, m, clowns;
graph g;
vector <ll> h;
vector <ll> d;

ll check (ll a, ll b) {
    if (h[b] < d[a])
        return d[a];
    else
        return d[a] / 2;
}

void djikstra (int v) {
    d.resize(n, 0);
    d[v] = clowns;
    d[v] = check(v, v);
    set <pl> q;
    q.insert({d[v], v});
    while (!q.empty()) {
        ll u = (*(--q.end())).second;
        q.erase(--q.end());
        for (int i = 0; i < g[u].size(); i++) {
            ll to = g[u][i];
            if (d[to] < check(u, to)) {
                q.erase({d[to], to});
                d[to] = check(u, to);
                q.insert({d[to], to});
            }
        }
    }
}

int main()
{
    fast();

    #ifdef _LOCAL
        clock_t Tsart = clock();
        op();
    #endif

    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        x--; y--;
        g[x].pb(y);
        g[y].pb(x);
    }

    cin >> clowns;
    h.resize(n);
    for (int i = 0; i < n; i++)
        cin >> h[i];

    djikstra(0);

    cout << d[n - 1] << '\n';
    #ifdef _LOCAL
        cerr << "Runtime: " << (ld)(clock() - Tsart) / CLOCKS_PER_SEC << '\n';
    #endif

    return 0;
}
