#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <cctype>
#include <cmath>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define int long long
#define eb emplace_back
#define pb push_back
#define ld long double
#define f first
#define s second
#define fast() { \
    ios_base::sync_with_stdio(0); \
    cin.tie(0); \
    cout << fixed << setprecision(10); \
    cerr << fixed << setprecision(11); \
}

const int INF = 1e18 + 7;
const ld EPS = 1e-7;
const ld PI = 3.14159265358979323;
const int MOD = 1e9 + 7;
const int MOD1 = 1073676287;
const int P = 789;
const int P1 = 508;
const int MAXN = 2e5;

void solve() {
    int n;
    cin >> n;
    set<int> not_found;
    for (int i = 0; i < n; i++) not_found.insert(i);
    vector<int> found(n), a(n);
    vector<map<int, char>> block(n);
    for (int len = 1; len <= n && !not_found.empty(); len++) {
        int cnt = 0, sum = 0;
        for (int i = 0; i < len; i++) {
            cnt += found[i];
            sum += a[i];
        }
        for (int i = 0; i + len <= n && !not_found.empty(); i++) {
            int j = i + len - 1;
            if (cnt == len - 1 && block[i].find(j) == block[i].end()) {
                cout << "? " << i + 1 << ' ' << j + 1 << endl;
                int x, l, r;
                cin >> x >> l >> r;
                --l, --r;
                block[l][r] = 1;
                cnt++;
                auto it = not_found.lower_bound(i);
                int pos = *it;
                found[pos] = 1;
                not_found.erase(it);
                a[pos] = x - sum;
                sum = x;
            }
            sum -= a[i];
            cnt -= found[i];

            if (i + len < n) {
                sum += a[i + len];
                cnt += found[i + len];
            }
        }
    }

    assert(not_found.empty());

    cout << "! ";
    for (auto &x : a) cout << x << ' ';
    cout << endl;
}

signed main() {
    fast();
    solve();
    return 0;
}
