#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <cctype>
#include <cmath>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define int long long
#define eb emplace_back
#define pb push_back
#define ld long double
#define f first
#define s second
#define fast() { \
    ios_base::sync_with_stdio(0); \
    cin.tie(0); \
    cout << fixed << setprecision(10); \
    cerr << fixed << setprecision(11); \
}

const int INF = 1e18;
const ld EPS = 1e-7;
const ld PI = 3.14159265358979323;
const int MOD = 1e9 + 7;
const int MOD1 = 1073676287;
const int P = 789;
const int P1 = 508;
const int MAXN = 2e5;

void solve() {
    int a, b;
    cin >> a >> b;

    vector<pair<int, int>> res;
    auto add = [&] (int type, int k) {
        if (type == 1) {
            a += k * b;
        } else {
            b += k * a;
        }
        res.emplace_back(type, k);
        assert(abs(a) <= INF);
        assert(abs(b) <= INF);
    };

    if (a < 0 && b < 0) {
        if (abs(b) > abs(a)) {
            add(1, -1);
        } else {
            add(2, -1);
        }
    }

    if (b < 0) {
        add(2, ((abs(b) + a - 1) / a));
    } else if (a < 0) {
        add(1, ((abs(a) + b - 1) / b));
    }

    while (a && b) {
        if (a > b) {
            add(1, -a / b);;
        } else {
            add(2, -b / a);
        }
    }
    cout << (int) res.size() << '\n';
    for (auto &[a, b] : res) cout << a << ' ' << b << '\n';
}

signed main() {
    fast();
    solve();
    return 0;
}
