#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <cctype>
#include <cmath>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define int long long
#define eb emplace_back
#define pb push_back
#define ld long double
#define f first
#define s second
#define fast() { \
    ios_base::sync_with_stdio(0); \
    cin.tie(0); \
    cout << fixed << setprecision(10); \
    cerr << fixed << setprecision(11); \
}

const int INF = 1e18 + 7;
const ld EPS = 1e-7;
const ld PI = 3.14159265358979323;
const int MOD = 1e9 + 7;
const int MOD1 = 1073676287;
const int P = 789;
const int P1 = 508;
const int MAXN = 2e5;
const int TO = 1e12;

void solve() {
    int a, b;
    cin >> a >> b;
    map<int, int> mp;
    for (int x = 1; x * x <= TO; x++) {
        mp[x * x] = 1;
    }

    int res = 0;
    for (int x = 1; x * x <= b; x++) {
        if (x * x >= a) {
            string s = to_string(x * x);
            if (s.back() == '0') continue;
            reverse(s.begin(), s.end());
            int xx = stoi(s);
            if (mp.find(xx) != mp.end()) {
                res++;
            }
        }
    }

    cout << res;
}

signed main() {
    fast();
    solve();
    return 0;
}
