#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_cxx;
using namespace std;
using namespace __gnu_pbds;

#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(v) v.begin(), v.end()
using ordered_set = tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update>;

///pragms:

//#pragma GCC optimize("Ofast,O3,unroll-loops")

//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native,avx2")

using ull = unsigned long long;
using ll = long long;
using ld = long double;
//using ui = unsigned int;

/*const int MAX_MEM = 1e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new ( size_t n ) {
	char *res = mem + mpos;
	mpos += n;
	assert(mpos <= MAX_MEM);
	return (void *)res;
}
inline void operator delete ( void * ) { }*/

#define fi first
#define se second

int min_dist(pair<int, int> seg, int x) {
    if (x >= seg.fi && x <= seg.se)
        return 0;
    if (x < seg.fi)
        return seg.fi - x;
    return x - seg.se;
    ///return min(abs(seg.fi - x), abs(seg.se - x));
}

void update(vector<int> &tree, vector<int> &mod, int v, int tl, int tr, int l, int r, int w) {
    l = max(l, tl);
    r = min(r, tr);
    if (l > tr || r < tl)
        return;
    if (l == tl && r == tr) {
        tree[v] = min(tree[v], w);
        mod[v] = min(mod[v], w);
        return;
    }
    int tm = (tl + tr) >> 1;
    update(tree, mod, v << 1, tl, tm, l, r, w);
    update(tree, mod, (v << 1) + 1, tm + 1, tr, l, r, w);
    tree[v] = min(min(mod[v << 1], tree[v << 1]), min(mod[2 * v + 1], tree[2 * v + 1]));
}

const int inf = (int)1e9 + 7;

int get(vector<int> &tree, vector<int> &mod, int v, int tl, int tr, int l, int r) {
    l = max(l, tl);
    r = min(r, tr);
    if (l > tr || r < tl)
        return inf;
    if (l == tl && r == tr) {
        return min(mod[v], tree[v]);
    }
    int tm = (tl + tr) >> 1;
    return min(mod[v], min(get(tree, mod, v << 1, tl, tm, l, r), get(tree, mod, (v << 1) + 1, tm + 1, tr, l, r)));
}

signed main() {
    ios;
    int n, m;
    cin >> n >> m;
    vector<pair<int, int> > a(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i].first >> a[i].second;
        --a[i].fi;
        --a[i].se;
    }
    vector<vector<int> > dp(m, vector<int>(n));
    for (int j = 0; j < n; ++j) {
        dp[0][j] = min_dist(a[0], j);
    }
    vector<vector<int> > tree(m, vector<int>(4 * n, inf));
    vector<vector<int> > mod(m, vector<int>(4 * n, inf));
    for (int j = 0; j < n; ++j) {
        update(tree[0], mod[0], 1, 0, n - 1, j, j, dp[0][j]);
    }
    for (int i = 1; i < m; ++i) {
        int len = a[i].se - a[i].fi + 1;
        for (int j = 0; j < n; ++j) {
            ///int w = min_dist(a[i], j);
            if (j + len - 1 >= n)
                break;
            ///j, j + len - 1
            int w = abs(a[i].fi - j);
            update(tree[i], mod[i], 1, 0, n - 1, j, j + len - 1, w + get(tree[i - 1], mod[i - 1], 1, 0, n - 1, j, j + len - 1));
        }
    }
    cout << get(tree[m - 1], mod[m - 1], 1, 0, n - 1, 0, n - 1);
    return 0;
}

