#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_cxx;
using namespace std;
using namespace __gnu_pbds;

#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(v) v.begin(), v.end()
using ordered_set = tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update>;

///pragms:

//#pragma GCC optimize("Ofast,O3,unroll-loops")

//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native,avx2")

using ull = unsigned long long;
using ll = long long;
using ld = long double;
//using ui = unsigned int;

/*const int MAX_MEM = 1e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new ( size_t n ) {
	char *res = mem + mpos;
	mpos += n;
	assert(mpos <= MAX_MEM);
	return (void *)res;
}
inline void operator delete ( void * ) { }*/

ll opt(ll x, ll y) {
    return abs(x) < abs(y) ? x : y;
}

void solve(ll a, ll b) {
    vector<pair<int, ll> > ans;
    while (a != 0 && b != 0) {
        ll a1 = abs(a);
        ll b1 = abs(b);
        if (a1 > b1) {
            ll r1 = a1 % b1;
            ll r2 = a1 % b1 - b1;
            if (a < 0) {
                r1 *= -1;
                r2 *= -1;
            }
            ll r = opt(r1, r2);
            ll k = (r - a) / b;
            ans.emplace_back(1, k);
            a += b * k;
        }
        else {
            ll r1 = b1 % a1;
            ll r2 = b1 % a1 - a1;
            if (b < 0) {
                r1 *= -1;
                r2 *= -1;
            }
            ll r = opt(r1, r2);
            ll k = (r - b) / a;
            ans.emplace_back(2, k);
            b += a * k;
        }
    }
    cout << ans.size() << '\n';
    for (auto &[type, k] : ans) {
        cout << type << ' ' << k << '\n';
    }
}

signed main() {
    ios;
    ll a, b;
    cin >> a >> b;
    solve(a, b);
    /**vector<ll> phi(70);
    phi[0] = 1;
    phi[1] = 1;
    for (ll i = 2; i < 70; ++i) {
        phi[i] = phi[i - 1] + phi[i - 2];
    }
    solve(phi[68], phi[69]);**/
    return 0;
}

