#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;
typedef long double ld;

using str = string;
using vi = vector<int>;
using vl = vector<ll>;
using vvi = vector<vi>;

const int maxN = 1e5;
const int INFi = 2e9;
const ll INF = 2e18;

void solve() {
    int m, n; cin >> m >> n;
    vector<vector<int>> dp(n + 1, vector<int> (m, INFi));
    vector<int> len(n + 1);
    len[0] = m;
    rep(i, m) dp[0][i] = 0;
    for(int i = 1; i <= n; ++i) {
        int s, t; cin >> s >> t;
        s--;
        t--;
        len[i] = t - s + 1;
        deque<pair<int, int>> q;
        int r = 0;
        for(int j = 0; j + len[i] <= m; ++j) {
            int L = j - len[i - 1] + 1;
            int R = j + len[i] - 1;
            while(r <= R && r < m) {
                while(!q.empty() && q.back().second >= dp[i - 1][r]) q.pop_back();
                q.push_back({r, dp[i - 1][r]});
                r++;
            }
            while(!q.empty() && q.front().first < L) {
                q.pop_front();
            }
            assert(!q.empty());
            int need = abs(s - j);
            dp[i][j] = q.front().second + need;
        }
    }
    int mn = *min_element(all(dp[n]));
    cout << mn << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    rep(_, tests) {
        solve();
    }
    return 0;
}