#include <iostream>
#include <cmath>

#define lli long long int
#define ld long double

using namespace std;

lli A;
lli B;

lli f(lli n) {
    lli res = 0;
    while (n > 0) {
        lli a = n % 10;
        res *= 10;
        res += a;
        n /= 10;
    }
    return res;
}

bool isSquare(lli n) {
    return ((lli) sqrt(n)) * ((lli) sqrt(n)) == n;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> A >> B;
    lli nearestSquareToA = A;
    lli nearestSquareToB = B;

    while (!isSquare(nearestSquareToA)) {
        nearestSquareToA++;
    }
    while (!isSquare(nearestSquareToB)) {
        nearestSquareToB--;
    }

    lli res = 0;
    lli start = (lli) sqrt(nearestSquareToA);
    lli finish = (lli) sqrt(nearestSquareToB);
    for (lli i = start; i <= finish; i++) {
        if ((i * i) % 10 != 0 && isSquare(f(i * i))) {
            res++;
        }
    }
    cout << res;

}
