#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <numeric>
#include <bitset>
#include <cassert>
#include <ctime>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

bool is_tl() {
    if ((ld) clock() / CLOCKS_PER_SEC >= 0.9)
        return true;
    return false;
}

void solve() {
    int n;
    cin >> n;
    ll s = 0;
    vector<pair<pll, int>> a(n);
    ll x1 = 0, x2 = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.first;
        x1 ^= a[i].first.first;
        a[i].second = i;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.second;
        x2 ^= a[i].first.second;
    }
    sort(rall(a), [](const pair<pll, int>& l, const pair<pll, int>& r) {
        return (l.first.first ^ l.first.second) < (r.first.first ^ r.first.second);
    });
    s = x1 + x2;
    vector<bool> sw(n);
    while (!is_tl()) {
        for (int i = 0; i < n; ++i) {
            ll c = a[i].first.first ^ a[i].first.second;
            if ((x1 ^ c) + (x2 ^ c) - x1 - x2 >= 0) {
                swap(a[i].first.first, a[i].first.second);
                sw[a[i].second] = sw[a[i].second] ^ 1;
                s += (x1 ^ c) + (x2 ^ c) - x1 - x2;
                x1 ^= c;
                x2 ^= c;
            }
        }
    }
    int c = accumulate(all(sw), 0);
    cout << s << " " << c << '\n';
    for (int i = 0; i < n; ++i)
        if (sw[i]) cout << i + 1 << " ";

}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}