#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <numeric>
#include <bitset>
#include <cassert>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

vector<pair<int, ll>> ans;

ll sign(ll a) {
    if (a == 0) return 0;
    if (a < 0) return -1;
    return 1;
}

void gcd(ll a, ll b) {
    if (a == 0 || b == 0) return;
    ll a1 = abs(a), b1 = abs(b);
    if (a1 < b1) {
        ll c = b1 % a1;
        ll k = 0;
        if (abs(c) < abs(c - a1)) {
            k = b1 / a1;
        } else {
            k = b1 / a1 + 1;
        }
        int cc = sign(a) + sign(b);
        if (cc == 0) {
            ans.emplace_back(2, k);
            gcd(a, b + k * a);
        } else {
            ans.emplace_back(2, -k);
            gcd(a, b - k * a);
        }
    } else {
        ll c = a1 % b1;
        ll k = 0;
        if (abs(c) < abs(c - b1)) {
            k = a1 / b1;
        } else {
            k = a1 / b1 + 1;
        }
        int cc = sign(a) + sign(b);
        if (cc == 0) {
            ans.emplace_back(1, k);
            gcd(a + k * b, b);
        } else {
            ans.emplace_back(1, -k);
            gcd(a - k * b, b);
        }
    }
}

void solve() {
    ll a, b;
    cin >> a >> b;
    gcd(a, b);
    cout << ans.size() << '\n';
    for (auto& it : ans)
        cout << it.first << " " << it.second << '\n';
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}