﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <string>
#include <sstream>
#include <set>
#include <map>
#include <queue>
#include <numeric>

typedef long long ll;
using num = long long;

using namespace std;
/*
int MAX = 20;

vector<pair<bool, ll>> res;

bool recur(int k, int a, int b)
{
    if (k == MAX)
    {
        int result = res.size();
        stringstream s;
        while (a != 0 && b != 0)
        {
            if (abs(a) > abs(b))
            {
                s << "1 " << -(a / b) << '\n';
                a = a % b;
            }
            else
            {
                s << "2 " << -(b / a) << '\n';
                b = b % a;
            }
            ++result;
        }
        if (result > 50)
            return false;
        cout << result << '\n';
        for (int i = 0; i < res.size(); ++i)
        {
            cout << res[i].first << ' ' << res[i].second << '\n';
        }
        cout << s.str();
        return true;
    }
    if (a == 0 || b == 0)
    {
        cout << res.size() << '\n';
        for (int i = 0; i < res.size(); ++i)
        {
            cout << int(res[i].first) + 1 << ' ' << res[i].second << '\n';
        }
        return true;
    }

    int new_a = 0, new_b = 0;
    return false;
}
*/

std::set<char> glasnaya{
    'a', 'o', 'i', 'u', 'e'
};

num get(std::string const& str)
{
    auto temp = "x" + str;

    num count = 0;
    for (num i = 1; i < temp.size(); i++)
    {
        if (glasnaya.count(temp[i - 1]) == 0 && glasnaya.count(temp[i]) > 0)
            count++;
    }
    return count;
}

int main() {
    /*
    ll a, b;
    cin >> a >> b;
    int result = 0;
    stringstream s;
    while (a != 0 && b != 0)
    {
        if (abs(a) > abs(b))
        {
            s << "1 " << -(a / b) << '\n';
            a = a % b;
        }
        else
        {
            s << "2 " << -(b / a) << '\n';
            b = b % a;
        }
        ++result;
    }
    if (result > 50)
        throw(0);
    cout << result << '\n';
    cout << s.str();
    */

    num n;
    std::cin >> n;
    std::vector<num> arr(n);
    for (auto& elem : arr)
    {
        std::string str;
        std::cin >> str;
        elem = get(str);
    }

    std::vector<num> pref(n + 1);
    pref[0] = 0;
    for (num i = 1; i <= n; i++)
        pref[i] = pref[i - 1] + arr[i - 1];

    num count = 0;
    for (num i = 0; i < n-3; i++)
    {
        num l = i + 1, r = n - 2;
        while (r - l > 1)
        {
            num mid = (l + r) / 2;
            if (pref[mid+1] - pref[i] > 5)
                r = mid;
            else
                l = mid;
        }

        if (pref[l + 1] - pref[i] != 5)
            continue;

        num i2 = l + 1;
        l = i2, r = n - 1;
        while (r - l > 1)
        {
            num mid = (l + r) / 2;
            if (pref[mid+1] - pref[i2] > 7)
                r = mid;
            else
                l = mid;
        }

        if (pref[l + 1] - pref[i2] != 7)
            continue;

        num i3 = l + 1;
        l = i3, r = n;
        while (r - l > 1)
        {
            num mid = (l + r) / 2;
            if (pref[mid+1] - pref[i3] > 5)
                r = mid;
            else
                l = mid;
        }

        if (pref[l + 1] - pref[i3] != 5)
            continue;

        count++;
    }

    std::cout << count;

    return 0;
}