#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <math.h>
#include <iomanip>
#include <cassert>
#include <cstring>
#include <map>
#define pb push_back
#define F first
#define S second
#define LL long long
#define Matrix vector <vector <long long>>

using namespace std;

void Ludociel(){
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL); cout.tie(NULL);
    #ifdef Kultivator
        //freopen("W.txt", "r", stdin);
    #endif // Kultivator
}

const int Mx = (int)1e6 + 7;
const int Md = (int)1e9 + 7;
const long long Inf = (long long)1e18 + 7;

    int n, A, B, x[Mx], y[Mx], A1, B1;
int main(){
    Ludociel();
    /* set <int> A;
    A.insert(34);
    A.erase(prev(A.end()));
    cout << *A.rbegin(); */

    A1 = B1 = false;
    cin >> n >> A >> B;
    char Ans[Mx];
    long long sum = false;
    for(int i = 1; i <= n; i++) cin >> x[i];
    for(int i = 1; i <= n; i++) cin >> y[i];
    for(int i = 1; i <= n; i++){
        if(x[i] > y[i]){
            Ans[i] = 'T';
            sum += x[i];
            A1++;
        } else {
            Ans[i] = 'P';
            sum += y[i];
            B1++;
        }
    }
    if(A1 < A){
        vector <pair <int, int>> pw;
        for(int i = 1; i <= n; i++){
            if(Ans[i] == 'P'){
                pw.pb({abs(x[i] - y[i]), i});
            }
        }
        sort(pw.begin(), pw.end());
        for(int i = 0; i < pw.size(); i++){
            sum -= y[pw[i].S];
            sum += x[pw[i].S];
            Ans[pw[i].S] = 'T';
            A1++;
            if(A1 == A) break;
        }
     }
     if(B1 < B){
        vector <pair <int, int>> pw;
        for(int i = 1; i <= n; i++){
            if(Ans[i] == 'T'){
                pw.pb({abs(x[i] - y[i]), i});
            }
        }
        sort(pw.begin(), pw.end());
        for(int i = 0; i < pw.size(); i++){
            sum -= x[pw[i].S];
            sum += y[pw[i].S];
            Ans[pw[i].S] = 'P';
            B1++;
            if(B1 == B) break;
        }
     }
     cout << sum << '\n';
     for(int i = 1; i <= n; i++) cout << Ans[i] << ' ';
}
