#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <math.h>
#include <iomanip>
#include <cassert>
#include <cstring>
#include <map>
#define pb push_back
#define F first
#define S second
#define LL long long
#define Matrix vector <vector <long long>>

using namespace std;

void Ludociel(){
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL); cout.tie(NULL);
    #ifdef Kultivator
        //freopen("W.txt", "r", stdin);
    #endif // Kultivator
}

const int Mx = (int)1e6 + 7;
const int Md = (int)1e9 + 7;
const long long Inf = (long long)1e18 + 7;

long double x, T;

long double f(long double Time){
    long double Ex;
    if((long double)0 <= Time && Time <= (T / (long double)6)){
        Ex = ((long double)6 * x * Time) / T;
    } else if((T / 6) <= Time && Time <= (T / 3)){
        Ex = ((long double)6 * ((long double)100 - x) * Time) / T + (long double)2 * x - (long double)100;
    } else {
        Ex = (long double)100;
    }
    return Ex * (T - Time);
}

int main(){
    Ludociel();
    /* set <int> A;
    A.insert(34);
    A.erase(prev(A.end()));
    cout << *A.rbegin(); */

    cin >> x >> T;
    long double l = 0, r = T;
    for(int i = 1; i <= 1000; i++){
        long double m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
        if (f(m1) < f(m2)) l = m1;
        else r = m2;
    }
    cout << fixed << setprecision(6) << max(f(l), f(r)) << '\n';
}
