#include<iostream>
#include<set>
#include <vector>
#include <string>
#include <memory.h>
#include <iomanip>
#include <deque>
#include <queue>
#include <stack>
#include <iterator>
#include <sstream>
#define int long long
#define endl "\n"
#define F first
#define pii pair<int,int>
//#define or ||
//#define and &&
#define sec second
using namespace std;

const int INF = 1e9 + 7;

bool cmp(pii a, pii b)
{
    return a.first > b.first;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<vector<int>> gr(n + 1);

    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;

        gr[a].push_back(b);
        gr[b].push_back(a);
    }

    int x;
    cin >> x;

    vector<int> vc(n + 1);

    for (int i = 1; i <= n; i++)
    {
        cin >> vc[i];
        vc[i] = -vc[i];
    }

    vector<int> dist(n + 1, INF);
    if (vc[1] > -x)
    {
        dist[1] = -x;
    }
    else
    {
        dist[1] = -x / 2;
    }

    set<pii> q;

    q.insert({ dist[1], 1 });

    while (!q.empty())
    {
        int v = (*q.begin()).sec;
        q.erase(q.begin());

        for (auto p : gr[v])
        {
            int to = p;

            if (dist[v] < vc[to] && dist[v] < dist[to])
            {
                q.erase({ dist[to], to });
                dist[to] = dist[v];
                q.insert({ dist[to], to });
            }
            else if (dist[v] >= vc[to] && dist[v] / 2 < dist[to])
            {
                q.erase({ dist[to], to });
                dist[to] = dist[v] / 2;
                q.insert({ dist[to], to });
            }
        }
    }

    if (dist[n] == INF)
    {
        cout << 0;
        return 0;
    }
    else
    {
        cout << -dist[n];
        return 0;
    }

}

/*
5 5
1 2
2 3
3 4
4 5
2 5
*/

