#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <climits>
#include <queue>
#include <algorithm>
#include <assert.h>
#include <unordered_map>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = INT_MAX;
const ll MM = 100000000001;

set<ll> ans;
unordered_map<string, ll> m;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(18);
#ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif

    for (ll i = 1; i * i <= MM; i++)
    {
        ll sq = i * i;

        string s1 = to_string(sq);
        string s2 = to_string(sq);
        reverse(s2.begin(), s2.end());

        if (m[s2] != 0)
        {
            ans.insert(sq);
            ans.insert(m[s2]);
        }
        else if (s1 == s2) {
            ans.insert(sq);
        }
        m[s1] = sq;
    }

    ll a, b;
    cin >> a >> b;

    int idxa = distance(ans.begin(), ans.lower_bound(a));
    int idxb = distance(ans.begin(), ans.lower_bound(b + 1));
    // for (auto e: ans) {
    //     if (e < a) continue;
    //     if (e > b) break;
    //     cout << e << ' ';
    // }
    // cout << '\n';

    cout << idxb - idxa << '\n';
}