#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

ll rev(ll a) {
    ll ans = 0;
    while (a != 0) {
        ans = ans * 10 + a % 10;
        a /= 10;
    }
    return ans;
}

void solve() {
    ll a, b; cin >> a >> b;
    set<ll>sq;
    for (ll i = 1; i <= 1e6; i++) {
        if (i % 10 == 0)
            continue;
        sq.insert(i * i);
    }
    int out = 0;
    for (ll i = 1; i * i <= b; i++) {
        if (i % 10 == 0)
            continue;
        if (i * i < a)
            continue;
        ll r = rev(i * i);
            if (sq.find(r) != sq.end())
                out++;
    }
    cout << out;
}
void solve1() {

}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int t = 1;
    while (t--) {
        solve();
    }
}