#include <iostream>
#include <vector>
#include <iomanip>
#include <deque>
#include <set>

#define fr first
#define se second
#define ll int

using namespace std;

const ll N = 2 * 1e5;

set< ll > G[N + 1];
vector< ll > a(N + 1);
vector<bool>used(N + 1, true);

int mx = 0,n;

void dfs(int pos, int x) {
    if(!x) {
        return;

    }
    if(pos == n && x > mx) {
        mx = x;
        return;
    }
    for(auto qwe:G[pos]){
        if(used[qwe]) {
            int t = x;
            if(t <= a[qwe]) {
                t /= 2;
            }
            used[qwe] = false;
            dfs(qwe, t);
            used[qwe] = true;
        }
    }
}

main() {
    ll m;
    cin>>n>>m;

    for(int i = 0; i < m; i++) {
        int x,y;
        cin>>x>>y;
        G[x].insert(y);
        G[y].insert(x);
    }

    ll x;
    cin>>x;

    for(int i = 1; i <= n; i++) {
        cin>>a[i];
    }

    if(x <= a[1]) {
        x /= 2;
    }
    used[1] = false;
    dfs(1, x);
    cout<<mx;
}
