#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <cmath>
#include <algorithm>
#include <stack>
#include <map>
#include <iomanip>


using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll BASE = 179;
const ld EPS = 0.00000001;


ld x, t;

ld check(ld a) {
    ld q = t - a;
    if (a < t / 6) return q * ((6 * a * x) / t);
    if (a == t / 6) return q * x;
    if (a < t / 3) return q * ((6 * (a - t / 6) * (100 - x)) / t + x);
    if (a >= t / 3) return q * 100;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout << fixed << setprecision(9);
    cin >> x >> t;
    ld l = 0, r = t / 3 + 1;
    while (r - l > EPS) {
        ld m = (r + l) / 2;
        ld q = m - EPS;
        if (check(m) < check(q)) {
            r = m;
        }
        else {
            l = m;
        }
    }
    cout << check(l);
    return 0;
}