#define _CRT_SECURE_NO_WARNINGS
#define _GLIB_CXX_DEBUG
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <deque>
#include <queue>
#include <iomanip>
#include <sstream>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#define pb push_back
#define ff first
#define ss second
//#define endl '\n'

using namespace std;
using ll = long long;
using vi = vector<int>;

template<typename T>
bool rMin(T& x, const T& y)
{
	if (x > y)
	{
		x = y;
		return true;
	}
	return false;
}
template<typename T>
bool rMax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

vi a[200002];
int b[200002];
bool used[200002];
int res[200002];

void bfs(int x)
{
	used[1] = true;
	if (x > b[1])
	{
		res[1] = x;
	}
	else
	{
		res[1] = x / 2;
	}


	queue<int> q;
	queue<int> q1;
	q.push(1);

	while (!q.empty() or !q1.empty())
	{
		if (q.empty())
		{
			while (!q1.empty())
			{
				if (!used[q1.front()])
				{
					q.push(q1.front());
					used[q1.front()] = true;
				}

				q1.pop();
			}
			continue;
		}
		auto x = q.front();
		q.pop();

		for (int i = 0; i < a[x].size(); i++)
		{
			if (used[a[x][i]])
			{
				continue;
			}
			if (b[a[x][i]] < res[x])
			{
				q.push(a[x][i]);
				res[a[x][i]] = res[x];
				used[a[x][i]] = true;
			}
			else
			{
				q1.push(a[x][i]);
				res[a[x][i]] = res[x] / 2;
			}
		}
	}
}

void solve()
{
	int n, m;

	cin >> n >> m;

	for (int i = 0; i < m; i++)
	{
		int u, v;

		cin >> u >> v;

		a[u].pb(v);
		a[v].pb(u);
	}

	int l;

	cin >> l;

	for (int i = 1; i <= n; i++)
	{
		int x;

		cin >> x;

		b[i] = x;
	}

	bfs(l);

	cout << res[n] << endl;
}


int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(6);

	
	solve();
}