#define _CRT_SECURE_NO_WARNINGS
#define _GLIB_CXX_DEBUG
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <deque>
#include <queue>
#include <iomanip>
#include <sstream>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#define pb push_back
#define ff first
#define ss second
#define endl '\n'

using namespace std;
using ll = long long;
using vi = vector<int>;

template<typename T>
bool rMin(T& x, const T& y)
{
	if (x > y)
	{
		x = y;
		return true;
	}
	return false;
}
template<typename T>
bool rMax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct A
{
	int ind, val;
	A() {}
	A(int ind, int val) :ind(ind), val(val) {}
	bool operator<(const A& x) const
	{
		return this->val < x.val;
	}
};

int32_t main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(6);
	
	int n, a, b;
	cin >> n >> a >> b;
	vector <pair<int, int>> mas(n);
	set <A> x_mas, y_mas;
	for (int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		mas[i].first = x;
	}
	for (int i = 0; i < n; i++)
	{
		int x;
		cin >> x;
		mas[i].second = x;
	}
	for (int i = 0; i < n; i++)
	{
		x_mas.insert({ i,mas[i].first - mas[i].second });
		y_mas.insert({ i,mas[i].second - mas[i].first });
	}
	vector <char> ans(n,'-');
	int cnt = 0;
	for (int i = 0; i < a; i++)
	{
		A x = *--x_mas.end();
		cnt += mas[x.ind].first;
		ans[x.ind] = 'T';
		y_mas.erase({ x.ind,mas[x.ind].second - mas[x.ind].first });
		x_mas.erase({ x.ind,mas[x.ind].first - mas[x.ind].second });
	}
	for (int i = 0; i < b; i++)
	{
		A x = *--y_mas.end();
		cnt += mas[x.ind].second;
		ans[x.ind] = 'P';
		y_mas.erase({ x.ind,mas[x.ind].second - mas[x.ind].first });
		x_mas.erase({ x.ind,mas[x.ind].first - mas[x.ind].second });
	}
	for (int i = 0; i < n; i++)
	{
		if (ans[i] == '-')
		{
			if (mas[i].first > mas[i].second)
			{
				cnt += mas[i].first;
				ans[i] = 'T';
			}
			else
			{
				cnt += mas[i].second;
				ans[i] = 'P';
			}
		}
	}
	cout << cnt << endl;
	for (int i = 0; i < n; i++)
	{
		cout << ans[i] << ' ';
	}
}