#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <utility>
#include <queue>
#include <cmath>
#include <cstdlib>

#define fori(a, b) for(int i = a; i < b; ++i)
#define forj(a, b) for(int j = a; j < b; ++j)
#define fork(a, b) for(int k = a; k < b; ++k)
#define forn(n) for(int i = 0; i < n; ++i)
#define X first
#define Y second
#define mp make_pair

using namespace std;

typedef long long ll;         
typedef long double ld;         
typedef unsigned long long ull;

ll fun(ll x) {
    string s = to_string(x);
    reverse(s.begin(), s.end());
    if (s[0] == 0) return -1;
    ll res = 0;
    for (int i = 0; i < s.size(); ++i){
	res *= 10;
	res += s[i] - '0';
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll a, b, y;
    cin >> a >> b;
    set<ll> s, rs;
    for (ll x = 1; x * x <= b; ++x){
	s.insert(x * x);
	y = fun(x * x);
	rs.insert(y);
    }
    ll res = 0;
    for (ll e : s){
	if (a <= e && e <= b && rs.find(e) != rs.end()) res++;
    }
    cout << res << endl;
    return 0;
}