#include<iostream>
#include<string>
#include<vector>
#include<map>
#include<set>
#include<queue>
#include<fstream>
#include<algorithm>
#include<cmath>

#define ll long long

const int INF = 1e9 + 10;

using namespace std;

int n, m, x;

vector <vector <int>> graph;

vector <int> a;

vector <int> max_cl;

set <pair <int, int>> max_cl2;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> n >> m;
	int u, v;
	graph.resize(n);
	max_cl.assign(n, 0);
	a.resize(n);
	for (int i = 0; i < m; ++i) {
		cin >> u >> v;
		graph[u - 1].push_back(v - 1);
		graph[v - 1].push_back(u - 1);
	}
	cin >> x;
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	if (a[0] < x)
		max_cl[0] = x;
	else
		max_cl[0] = x / 2;
	for (int i = 0; i < n; ++i)
		max_cl2.insert({ -max_cl[i], i });
	while (max_cl2.size() > 0) {
		auto nu = *max_cl2.begin();
		max_cl2.erase(nu);
		for (int nv : graph[nu.second]) {
			int maxx;
			if (a[nv] < -nu.first)
				maxx = -nu.first;
			else
				maxx = (-nu.first) / 2;
			if (maxx > max_cl[nv]) {
				max_cl2.erase({ -max_cl[nv], nv });
				max_cl[nv] = maxx;
				max_cl2.insert({ -maxx, nv });
			}
		}
	}
	cout << max_cl[n - 1];
}


