#include<iostream>
#include<string>
#include<vector>
#include<map>
#include<set>
#include<queue>
#include<fstream>
#include<algorithm>
#include<cmath>
#include<iomanip>

#define ll long long

const int INF = 1e9 + 10;

using namespace std;


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n, a, b;
	cin >> n >> a >> b;
	vector<int> x(n), y(n);
	for (auto& hah : x)
		cin >> hah;
	for (auto& hah : y)
		cin >> hah;
	set<pair<int, int>> for_a, for_b;
	long long max_ans = 0;
	vector<char> ans(n);
	for (int i = 0; i < n; ++i) {
		if (x[i] > y[i]) {
			max_ans += x[i];
			for_a.insert({ x[i] - y[i], i });
			ans[i] = 'T';
		} 
		else {
			max_ans += y[i];
			for_b.insert({ y[i] - x[i], i });
			ans[i] = 'P';
		}
	}

	if (for_a.size() < a) {
		for (int i = 0; i < a - for_a.size(); ++i) {
			max_ans -= (*for_b.begin()).first;
			ans[(*for_b.begin()).second] = 'T';
			for_b.erase(for_b.begin());
		}
	}
	if (for_b.size() < b) {
		for (int i = 0; i < b - for_b.size(); ++i) {
			max_ans -= (*for_a.begin()).first;
			ans[(*for_a.begin()).second] = 'P';
			for_a.erase(for_a.begin());
		}
	}
	cout << max_ans << '\n';
	for (int i = 0; i < n; ++i) {
		cout << ans[i] << ' ';
	} 
}


