#include<iostream>
#include<string>
#include<vector>
#include<map>
#include<set>
#include<queue>
#include<fstream>
#include<algorithm>
#include<cmath>
#include<iomanip>

#define ll long long

const int INF = 1e9 + 10;

using namespace std;

long double maximum = 0, t, x;

long double val_func(long double a, long double b, long double c, long double x) {
	return x * x * a + x * b + c;
}

long double find_max(long double a, long double b, long double left, long double right) {
	while (right - left > 1e-10) {
		long double mid1 = (2 * left + right) / 3, mid2 = (2 * right + left) / 3;
		if (val_func(-a, t * a - b, b * t, mid1) < val_func(-a, t * a - b, b * t, mid2))
			left = mid1;
		else
			right = mid2;
	}
	return val_func(-a, t * a - b, b * t, (left + right) / 2);
}

pair <long double, long double> find_line(long double x1, long double x2, long double y1, long double y2) {
	long double a = (y1 - y2) / (x1 - x2), b = y1 - a * x1;
	return {a, b};
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cin >> x >> t;
	maximum = 100 * 2 * t / 3;
	auto fir = find_line(0, t / 6, 0, x), sec = find_line(t / 6, t / 3, x, 100);
	maximum = max(maximum, find_max(fir.first, fir.second, 0, t / 6));
	maximum = max(maximum, find_max(sec.first, sec.second, t / 6, t / 3));
	cout << fixed << setprecision(13);
	cout << maximum;
}


