import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.StringTokenizer;

public class B {
    private static Reader myReader;
    private static HashSet<Integer>[] right;
    public static void main(String[] args) {
        myReader = new Reader();
        int n = myReader.nextInt();
        right = new HashSet[n+1];
        for (int i=0; i<=n; i++) right[i] = new HashSet<>();
        long[] arr = new long[n+1];
        long[] sum = new long[n+1];
        for (int i=1; i<=n; i++) {
            int l = -1;

            for (int j=1; j<=i; j++) {
                if (!right[i].contains(j)) {
                    l = j; break;
                }
            }
            long ask = ask(l, i);
            long diff = sum[i-1] - sum[l-1];
            arr[i] = ask - diff;
            sum[i] = sum[i-1] + arr[i];
        }
        StringBuilder ans = new StringBuilder();
        for (int i=1; i<=n; i++) ans.append(arr[i]).append(" ");
        System.out.println("!");
        System.out.println(ans);
    }
    private static long ask(int l, int r) {
        System.out.println("? "+l+" "+r);
        System.out.flush();
        long a = myReader.nextLong();
        int le = myReader.nextInt();
        int ri = myReader.nextInt();
        right[ri].add(le);
        return a;
    }
    static class Reader {
        BufferedReader reader;
        StringTokenizer st;

        Reader() {
            reader = new BufferedReader(new InputStreamReader(System.in));
        }

        String nextToken() {
            try {
                if (st==null || !st.hasMoreElements()) st = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                e.printStackTrace();
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(nextToken());
        }
        long nextLong() { return Long.parseLong(nextToken());}
    }
}
