#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <iomanip>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <set>
#include <map>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <cassert>
#include <cstring>
#include <random>
#include <chrono>
#include <ext/rope>
#include <bitset>

#define sqr(x) ((x) * (x))
#define fi first
#define se second
#define pb push_back
#define all(x) x.begin(),x.end()
#define sz(x) ((ll)(x).size())

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
using ll = long long;
using ld = long double;

template <class T>
using indexed_set = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
ld Time() { return ld(clock()) / CLOCKS_PER_SEC; }



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    int n,t,p;
    cin>>n>>t>>p;
    vector<int> ta(n);
    for (int i=0;i<n;i++)
    {
        cin>>ta[i];
    }
    vector<int> pa(n);
    for (int i=0;i<n;i++)
    {
        cin>>pa[i];
    }
    vector<pair<int,int>> m(n);
    multiset<pair<int,int>>st,sp;
    int T=0,P=0;
    for(int i=0;i<n;i++)
    {
        if (pa[i]>ta[i])
        {
            m[i].fi=pa[i];
            m[i].se=0;
            st.insert({pa[i]-ta[i],i});
            P++;
        }
        else
        {
            m[i].fi=ta[i];
            m[i].se=1;
            sp.insert({ta[i]-pa[i],i});
            T++;
        }
    }
    while (T<t)
    {
        m[st.begin()->se].se=abs(m[st.begin()->se].se-1);
        m[st.begin()->se].fi-=st.begin()->fi;
        st.erase(st.begin());
        T++;
    }
    while (P<p)
    {
        m[sp.begin()->se].se=abs(m[sp.begin()->se].se-1);
        m[sp.begin()->se].fi-=sp.begin()->fi;
        sp.erase(sp.begin());
        P++;
    }
    ll ans=0;
    for (int i=0;i<n;i++)
    {
        ans+=m[i].fi;
    }
    cout<<ans<<endl;
    for (int i=0;i<n;i++)
    {
        cout<<(m[i].se==0?'P':'T')<<" ";
    }
    return 0;
}