#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <utility>
#include <sstream>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <complex>
#include <cassert>
#include <memory>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const long double EPS = 1e-8;

void solve() {

    int n;
    cin >> n;
    vector<long double> s(n), v(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i] >> v[i];
    }
    int realans = min(n, 2);
    for (long double i = 0; i < n; ++i) {
        for (long double j = i + 1; j < n; ++j) {
            int ans = 2;
            map<long double, int> val;
            int maxval = 0;
            for (long double q = j + 1; q < n; ++q) {
                long double k = (q - i) * (v[j] - v[i]) + (i - j) * (v[q] - v[i]);
                long double b = (j - i) * (s[q] - s[i]) + (i - q) * (s[j] - s[i]);
                if (fabs(k) <= EPS) {
                    if (fabs(b) <= EPS) {
                        ++ans;
                    }
                }
                else {
                    ++val[b / k];
                }
            }
            auto it = val.begin();
            if (it == val.end()) {
                realans = max(realans, ans + maxval);
                continue;
            }
            int valnow = it->second;
            maxval = valnow;
            long double lastval = it->first;
            for (++it; it != val.end(); ++it) {
                if (fabs(it->first - lastval) > EPS) {
                    valnow = 0;
                }
                valnow += it->second;
                maxval = max(maxval, valnow);
            }
            realans = max(realans, ans + maxval);
        }
    }
    cout << realans << "\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    t = 1;
    while (t--) {
        solve();
    }

    return 0;
}