#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <utility>
#include <sstream>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <complex>
#include <cassert>
#include <memory>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve() {

    int n, a, b;
    cin >> n >> a >> b;
    vector<int> x(n), y(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> y[i];
    }
    vector<int> ans(n, 0);
    int sum = 0, cnta = 0, cntb = 0;
    for (int i = 0; i < n; ++i) {
        if (y[i] > x[i]) {
            ans[i] = 1;
            ++cntb;
            sum += y[i];
        }
        else {
            ++cnta;
            sum += x[i];
        }
    }
    if (cnta < a) {
        vector<pair<int, int>> best;
        for (int i = 0; i < n; ++i) {
            if (ans[i]) {
                best.emplace_back(y[i] - x[i], i);
            }
        }
        sort(best.begin(), best.end());
        for (int i = 0; i < a - cnta; ++i) {
            sum -= best[i].first;
            ans[best[i].second] = 0;
        }
    }
    else if (cntb < b) {
        vector<pair<int, int>> best;
        for (int i = 0; i < n; ++i) {
            if (!ans[i]) {
                best.emplace_back(x[i] - y[i], i);
            }
        }
        sort(best.begin(), best.end());
        for (int i = 0; i < b - cntb; ++i) {
            sum -= best[i].first;
            ans[best[i].second] = 1;
        }
    }
    cout << sum << "\n";
    for (int i = 0; i < n; ++i) {
        if (ans[i]) {
            cout << "P ";
        }
        else {
            cout << "T ";
        }
    }
    cout << "\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    t = 1;
    while (t--) {
        solve();
    }

    return 0;
}