#include <bits/stdc++.h>
using namespace std;
struct Edge {
    int v, u;
};
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;

    vector<vector<int>> graph(n);

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }
    vector<int> dist (n, -1);
    vector<int> druid (n, -1);

    int x; cin >> x;
    dist[0] = x;
    for (int i = 0; i < n; ++i) {
        cin >> druid[i];
    }
    if (dist[0] <= druid[0]) {
        dist[0] = x / 2;
    }
    set<pair<int, int>> st;
    st.insert(make_pair(dist[0], 0));
    for (int i = 0; i < n; ++i) {
        if (st.size() == 0){
            break;
        }
        auto it = st.end(); it--;
        int v = it->second;
        st.erase(it);
        for (int j = 0; j < graph[v].size(); ++j) {
            int u = graph[v][j];
            int dist_new = dist[v];
            if (dist_new <= druid[u]){
                dist_new /= 2;
            }
            if (dist_new > dist[u]){
                st.erase(make_pair(dist[u], u));
                dist[u] = dist_new;
                st.insert(make_pair(dist[u], u));
            }
        }
    }
    cout << max(dist[n - 1], (int)0);
    return 0;
}