#include <bits/stdc++.h>

using namespace std;


#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>

using namespace __gnu_pbds;
/*
#include <ext/pb_ds/tree_policy.hpp>
typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;
*/

//#define int ll

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

#define ff first
#define ss second
#define mp make_pair
#define pf push_front
#define pb push_back
#define IO ios_base::sync_with_stdio(false); cin.tie(NULL);
#define print(x) { for (auto __val : (x)) cout << __val << ' '; cout << '\n'; }
#define printp(x) { for (auto __val : (x)) cout << "{" << __val.ff << ", " << __val.ss << "} "; cout << '\n'; }
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const ll mod = 1e9 + 7, mod2 = 1e9 + 9, mod3 = 998244353;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int random(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }
#define int long long
struct alpha {
    ll x;
    vector<int> ind;

    alpha(ll x) : x(x) {}

    alpha(ll x, int i) : x(x), ind({i}) {}

    operator ll() { return x; }

    vector<int> operator^(alpha other) {
        x ^= other.x;
        vector<int> res;
        res.resize(ind.size() + other.ind.size());
        merge(ind.begin(), ind.end(), other.ind.begin(), other.ind.end(), res.begin());
        vector<int> final;
        for (int i = 0; i < res.size(); ++i) {
            while (i + 1 < res.size() && res[i] == res[i + 1]) i += 2;
            if (i == res.size()) break;
            final.push_back(res[i]);
        }
        return final;
    }
};

//int str(vector<int> a, vector<int> b) {
//    int n = a.size();
//    vector<int> d(n);
//    int x1 = 0, x2 = 0;
//    for (int i = 0; i < n; ++i)
//        d[i] = a[i] ^ b[i], x1 ^= a[i], x2 ^= b[i];
//    int ans = x1 + x2;
//    for (int i = 0; i < (1 << n); ++i) {
//        int y1 = x1, y2 = x2;
//        for (int j = 0; j < n; ++j) {
//            if (i & (1 << j))
//                y1 ^= d[j], y2 ^= d[j];
//        }
//        ans = max(ans, y1 + y2);
//    }
//    return ans;
//}

void solve(vector<int> a, vector<int> b) {
    int n = a.size();
    ll x1 = 0, x2 = 0;
    vector<alpha> p(n, alpha(0));
    for (int i = 0; i < n; ++i) {
        x1 ^= a[i];
        x2 ^= b[i];
        p[i] = alpha(a[i] ^ b[i], i);
    }
    alpha cur(0);
    for (int bit = 62; bit >= 0; --bit) {
        if ((x1 & (1LL << bit)) != (x2 & (1LL << bit))) continue;
        vector<alpha *> w;
        for (int i = 0; i < p.size(); ++i) if (p[i] & (1LL << bit)) w.push_back(&p[i]);
        if (w.empty()) continue;
        if (!(x1 & (1LL << bit))) {
            x1 ^= *w[0];
            x2 ^= *w[0];
            cur.ind = cur ^ *w[0];
        }
        for (int i = 1; i < w.size(); ++i) {
            w[i]->ind = *w[i] ^ *w[0];
        }
        for (int i = 0; i < p.size(); ++i) {
            if (&p[i] == w[0]) {
                p.erase(p.begin() + i);
                break;
            }
        }
    }
    cout << x1 + x2 << ' ' << cur.ind.size() << '\n';
    for (int x: cur.ind) cout << x+1 << ' ';

}

/*

*/
signed main() {
    IO
    //freopen(".in" , "r" , stdin); freopen(".out" , "w" , stdout);
    int test = 1;
    //cin >> test;
    while (test--) {
        int n;
        cin >> n;
        vector<int> a(n), b(n);
        for (int &x: a)cin >> x;
        for (int &x: b)cin >> x;
        solve(a, b);
    }
}