#include <iostream>

using namespace std;

pair<int, int> def[100000];
pair<int, int> cols[100000];

int main() {
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < m; i++) {
        cin >> def[i].first >> def[i].second;
    }
    int min_moves = INT32_MAX;
    for(int i = 0; i < m; i++) {
        int moves = 0;
        for(int j = 0; j < m; j++) {
            cols[j] = def[j];
        }
        for(int j = i - 1; j >= 0; j--) {
            if(cols[j].second < cols[j + 1].first) {
                moves += cols[j + 1].first - cols[j].second;
            } else if(cols[j + 1].second < cols[j].first) {
                moves += cols[j].first - cols[j + 1].second;
            }
        }
        for(int j = i + 1; j < m; j++) {
            if(cols[j].second < cols[j - 1].first) {
                moves += cols[j - 1].first - cols[j].second;
            } else if(cols[j - 1].second < cols[j].first) {
                moves += cols[j].first - cols[j - 1].second;
            }
        }
        if(moves < min_moves) {
            min_moves = moves;
        }
    }
    cout << min_moves << endl;
}