class Node:
    def __init__(self):
        self.value = 0
        self.droids = 0
        self.cons = set()

n, m = map(int, input().split())

graph = []
for _ in range(n):
    graph.append(Node())

for _ in range(m):
    u, v = map(int, input().split())
    graph[u - 1].cons.add(v - 1)
    graph[v - 1].cons.add(u - 1)

x = int(input())

for i, droids in enumerate(map(int, input().split())):
    graph[i].droids = droids

if x > graph[0].droids:
    graph[0].value = x
else:
    graph[0].value = x // 2

checked = set()
to_check = {0}
while len(to_check) > 0:
    to_check_copy = to_check.copy()
    to_check.clear()
    for i in to_check_copy:
        for con in graph[i].cons:
            if graph[i].value > graph[con].droids:
                v = graph[i].value
            else:
                v = graph[i].value // 2
            graph[con].value = max(v, graph[con].value)
            if con not in to_check and con not in checked:
                to_check.add(con)
        checked.add(i)

print(graph[n - 1].value)