#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

int main() {
  ll n;
  cin >> n;

  ll start = 1, end = 1;

  vector<ll> answer(n);
  vector<pair<ll, ll>> banned;

  for (ll i = 1; i <= n; i++) {
    if (i != 1) {
      pair<ll, ll> query = {start, end};
      while (find(banned.begin(), banned.end(), query) != banned.end()) {
        start--, query.first = start;
      }
    }

    cout << "? " << start << ' ' << end << '\n';

    ll ans, ban_left, ban_right;
    cin >> ans >> ban_left >> ban_right;

    banned.emplace_back(ban_left, ban_right);

    if (start == end)
      answer[start - 1] = ans;
    else {
      ll prev_sum = 0;
      for (ll j = start - 1; j < end; j++)
        prev_sum += answer[j];

      ll number = ans - prev_sum;
      answer[end - 1] = number;
    }

    start = i + 1, end = i + 1;
  }

  cout << "!\n";
  for (ll item : answer)
    cout << item << ' ';

  return 0;
}
