﻿#include <iostream>
#include <map>
#include <vector>
#include <fstream>
#include <set>
#include <algorithm>
#include <iomanip>
#include <string>
#include <deque>
#include <math.h>
using namespace std;
#define int long long
typedef pair <int, int> ii;
typedef vector <int> vi;
typedef vector <ii> vii;
typedef vector<int> veci;
#define $ '\n'
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
inline void solve();

template <class T> istream& operator >> (istream& is, vector<T> &x) {
	for (T& i : x) is >> i;
	return is;
}
template <class T> ostream& operator << (ostream& o, const vector<T>& x) {
	for (T e : x) o << e << ' ';
	return o;
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t = 1;
	// cin >> t;
	solve();
	cout.flush();

	return 0;
}
inline void solve1() {
	int n;
	cin >> n;
	set <ii> s;
	vi a(n);
	int sum = 0;
	for (int i = 0; i < n; i++)
	{
		int cou = sum;
		for (int j = 0; j <= i; j++)
		{
			if (s.find({ j, i }) == s.end())
			{
				cout << "? " << j + 1 << ' ' << i + 1 << endl;
				int x, l, r;
				cin >> x >> l >> r;
				l--; r--;
				a[i] = x - cou;
				sum += a[i];
				s.insert({ l, r });
				break;
			}
			else
			{
				cou -= a[i];
			}
		}
	}
	cout << '!' << endl;
	for (auto i : a)
		cout << i << ' ';
	cout << endl;

	return;

}

struct bl {
	int p = 0, t = 0, i = -1;
	bl() {}
	bl(int t, int p, int i) : t(t), p(p), i(i) {}
	int mx() const {
		return max(t, p);
	}
	char mxc() const {
		if (p < t) return 'T';
		return 'P';
	}
};

inline void solve() {
	int n, a, b; cin >> n >> a >> b;
	veci t(n); cin >> t;
	veci p(n); cin >> p;

	vector<bl> info;
	for (int i = 0; i < n; i++) {
		info.push_back(bl(t[i], p[i], i));
	}


	sort(all(info), [=](const bl& x, const bl& y) {
		return (x.t - x.p) > (y.t  - y.p);
	});

	vector<char> ans(n);
	int sum = 0;
	for (int i = 0; i < n; i++) {
		if (i < a) {
			sum += info[i].t;
			ans[info[i].i] = 'T';
		}
		else if (i >= n - b) {
			sum += info[i].p;
			ans[info[i].i] = 'P';
		}
		else {
			sum += info[i].mx();
			ans[info[i].i] = info[i].mxc();
		}
	}
	cout << sum << $;
	cout << ans << $;

}