#include <iostream>
#include <string>
#include <vector>

using namespace std;

vector<int> L;
int n;

int slog(string s) {
    int cnt = 0;
    if (s[0] == 'a' || s[0] == 'e' || s[0] == 'i' || s[0] == 'o' || s[0] == 'u') {
        cnt += 1;
    }
    for (int i = 1; i < s.size(); i++) {
        if (s[i] == 'a' || s[i] == 'e' || s[i] == 'i' || s[i] == 'o' || s[i] == 'u') {
            if (!(s[i - 1] == 'a' || s[i - 1] == 'e' || s[i - 1] == 'i' || s[i - 1] == 'o' || s[i - 1] == 'u')) {
                cnt += 1;
            }
        }
    }
    return cnt;
}

bool check(int i) {
    int cnt = 0, i2 = i;
    while (i2 < n && cnt < 5) {
        cnt += L[i2];
        i2++;
    }
    if (cnt != 5) {
        return false;
    }
    while (i2 < n && cnt < 12) {
        cnt += L[i2];
        i2++;
    }
    if (cnt != 12) {
        return false;
    }
    while (i2 < n && cnt < 17) {
        cnt += L[i2];
        i2++;
    }
    if (cnt != 17) {
        return false;
    }
    return true;
}

int main()
{
    string x;
    int i2, cnt = 0;
    cin >> n;
    L.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> x;
        L[i] = slog(x);
    }
    for (int i = 0; i < n; i++) {
        if (check(i)) {
            cnt++;
        }
    }
    cout << cnt << "\n";
}
