#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define x first
#define y second
#define ll long long
#define ld long double

#define int ll
#define double ld

using namespace std;

const int inf = 1e9;
const int INF = 1e18;

pair<int, pair<int, int>> ask(int l, int r) {
    cout << "? " << l + 1 << " " << r + 1 << endl;

    int a, b, c;
    cin >> a >> b >> c;
    return {a, {b - 1, c - 1}};
}

void reply(vector<int> & arr) {
    cout << "!" << endl;
    for (int i : arr)
        cout << i << " ";
}

void solve() {
    int n;
    cin >> n;
    vector<int> arr(n);
    vector<int> pref(n);
    vector<set<int>> banned(n);

    auto res = ask(0, 0);
    arr[0] = res.x;
    pref[0] = res.x;

    banned[res.y.y].insert(res.y.x);

    for (int i = 1; i < n; ++i) {
        for (int j = i; j >= 0; --j) {
            if (!banned[i].count(j)) {
                auto res = ask(j, i);
                arr[i] = res.x;

                arr[i] = arr[i] - pref[i - 1];
                if (j > 0)
                    arr[i] += pref[j - 1];
                pref[i] = pref[i - 1] + arr[i];
                banned[res.y.y].insert(res.y.x);
                break;
            }
        }
    }

    reply(arr);
}

signed main() {
/*
#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL

*/
    solve();
}
