#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define x first
#define y second
#define ll long long
#define ld long double

#define int ll
#define double ld
#define endl '\n'

using namespace std;

const int inf = 1e9;
const int INF = 1e18;

const int maxn = 2e5;
vector<int> g[maxn + 1];

int cost[maxn + 1];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    int x;
    cin >> x;
    for (int i = 1; i <= n; ++i)
        cin >> cost[i];


    vector<int> dst(n + 1, -INF);
    set<pair<int, int>> s;
    dst[1] = x;
    if (cost[1] >= x)
        dst[1] /= 2;
    s.insert({-dst[1], 1});

    while (s.size()) {
        int u = s.begin()->y;
        s.erase(s.begin());

        for (int v : g[u]) {
            int to_send = dst[u];
            if (to_send <= cost[v])
                to_send /= 2;
            if (dst[v] < to_send) {
                s.erase({-dst[v], v});
                dst[v] = to_send;
                s.insert({-dst[v], v});
            }
        }
    }

    cout << dst[n] << endl;

}

signed main() {
#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL

    solve();
}
