#if 1

#define DEBUG 0
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

#if DEBUG
int runs = 3;
ifstream input("ProblemH/in.txt");
ofstream output("ProblemH/out.txt");
#else
int runs = 1;
istream& input = std::cin;
ostream& output = std::cout;
#endif

typedef long long ll;
typedef pair<int, int> vec2;


void gcd(ll a, ll b, vector<vec2> &ans)
{
	if (a == 0 || b == 0)
		return;
	if (a > b)
	{
		ans.push_back({ 1, (a % b - a) / b });
		gcd(a % b, b, ans);
	}
	else
	{
		ans.push_back({ 2, (b % a - b) / a });
		gcd(a, b % a, ans);
	}
}

int main()
{
	while (runs-- > 0)
	{
		ll a, b;
		input >> a >> b;

		vector<vec2> ans;

		if (a != 0 && b != 0)
		{
			if (b < 0)
			{
				ll k = abs(b / a) + 1;
				if (a * b > 0)
					k *= -1;

				ans.push_back({ 2, k });
				b = b + k * a;
			}
			if (a < 0)
			{
				ll k = abs(a / b) + 1;
				if (a * b > 0)
					k *= -1;

				ans.push_back({ 1, k });
				a = a + k * b;
			}

		}

		gcd(a, b, ans);

		output << ans.size() << "\n";
		for (int i = 0; i < ans.size(); i++)
			output << ans[i].first << " " << ans[i].second << "\n";
	}
	return 0;
}

#endif