#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <queue>
using namespace std;

int main() {
	int n, m, u, v, x, t;
	cin >> n >> m;
	vector <vector<int>> r(n);
	vector <int> w(n);
	for (int i = 0; i < m; i++) {
		cin >> u >> v;
		u--;
		v--;
		r[v].push_back(u);
		r[u].push_back(v);
	}
	cin >> x;
	for (int i = 0; i < n; i++) {
		cin >> w[i];
	}
	priority_queue <pair<int, int>> q;
	if (w[0] >= x) x /= 2;
	vector <int> clon(n, -1);
	clon[0] = x;
	q.push(make_pair(x, 0));
	while (!q.empty()) {
		x = q.top().first;
		int v = q.top().second;
		q.pop();
		if (x != clon[v]) continue;
		for (auto u : r[v]) {
			if (x > w[u]) {
				if (clon[u] < x) {
					clon[u] = x;
					q.push(make_pair(x, u));
				}
			}
			else {
				if (clon[u] < x / 2) {
					clon[u] = x / 2;
					q.push(make_pair(x / 2, u));
				}
			}
		}
	}
	if (clon[n - 1] == -1) clon[n - 1] = 0;
	cout << clon[n - 1];
}