#include <algorithm>
#include <math.h>
#include <iostream>
#include <vector>
#include <set>
#include <string>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<ll> vll;
typedef vector<int> vi;
typedef vector<double> vd;

ll reverse(ll x)
{
	int a = 0;

	while (x != 0)
	{
		a *= 10;
		a += x % 10;
		x /= 10;
	}
	return a;
}

void solveJ()
{
	ll a, b;
	cin >> a >> b;

	ll min = static_cast<int>(sqrt(a)), max = static_cast<int>(sqrt(b));
	set<ll> res;
	for (ll i = min; i <= max; i++)
	{
		if (i * i % 10 == 0)
			continue;
		ld x = sqrt(static_cast<ld>(reverse(i * i)));
		ll y = static_cast<int>(x);
		if (x == y && i * i >= a && i * i <= b)
		{
			res.insert(i * i);
		}
	}
	cout << res.size() << '\n';
}

/*void solveA()
{
	int n, m, k;
	cin >> n >> m >> k;

	if (k > n || k > m)
	{
		cout << "Impossible\n" << endl;
		return;
	}
	cout << "Possible\n";

	for (int i = 0, cnt = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			if (i == j && cnt < k)
			{
				cout << "*";
				cnt++;
			}
			else
				cout << ".";
		}
		cout << "\n";
	}

}*/

void solveE()
{
	vector<string> wrds;
	vi sls;
	int n;

	cin >> n;
	for (int i = 0; i < n; i++)
	{
		string a;
		cin >> a;
		wrds.push_back(a);
	}
}

int main()
{
	solveJ();
	return 0;
}