#include <iostream>
#include <algorithm>
#include <vector>
#include <sstream>
#include <map>
#include <cmath>

using namespace std;
typedef int64_t int64;

bool IsGlas( char Ch )
{
  if (Ch == 'a' || Ch == 'e' || Ch == 'i' || Ch == 'o' || Ch == 'u')
    return true;
  return false;
}

int GlasCount( string s )
{
  int cnt = 0;

  for (int i = 0; i < s.length(); i++)
  {
    if (IsGlas(s[i]))
    {
      cnt++;
      while (i < s.length() && IsGlas(s[i]))
        i++;
    }
  }

  return cnt;
}

int main( void )
{
  int n;
  vector<string> Input;

  cin >> n;
  vector<int> Slogs(n);
  Input.resize(n);

  for (int i = 0; i < n; i++)
  {
    cin >> Input[i];
    Slogs[i] = GlasCount(Input[i]);
  }

  int cnt = 0;
  for (int i = 0; i < n; i++)
  {
    int sum = 0;
    int j = i; 

    while (sum < 5 && j < n)
      sum += Slogs[j], j++;
    if (j >= n || sum != 5)
      continue;
    sum = 0;
    while (sum < 7 && j < n)
      sum += Slogs[j], j++;
    if (j >= n || sum != 7)
      continue;
    sum = 0;
    while (sum < 5 && j < n)
      sum += Slogs[j], j++;
    if (j >= n || sum != 5)
      continue;
    cnt++;
  }
  cout << cnt;
  return 0;
}
