#include <stdio.h>
#include <math.h>

typedef unsigned long long int ULL;

int isSqr( ULL n )
{
  float s;

  s = sqrtf((float)n);
  return (ULL)s == s;
}
ULL pow2( ULL a )
{
  return a * a;
}

ULL flipNum( ULL n )
{
  ULL res = 0;
  
  if (n != 0)
    while (n >= 1)
    {
      res *= 10;
      res += n % 10;
      n /= 10;
    }
  return res;
}

int main( void )
{
  ULL b, e, i, count, temp;

  scanf("%llu", &b);
  scanf("%llu", &e);

  /*for (i = b, count = 0; i <= e; i++)
    if (i % 10 != 0 && isSqr(i) && isSqr(flipNum(i)))
      count++;/* printf("NUM: %llu\n", i);*/
  for (temp = 0, i = b, count = 0; temp <= e; i++)
  {
    temp = pow2(i);
    if (temp % 10 != 0 && isSqr(flipNum(temp)))
      count++;
  }
  printf("%llu", count);
  

  return 0;
}