#include <iostream>
#include <vector>

std::vector<std::pair<int, int>> Zapr;

bool IsZapr( int N1, int N2 )
{
	for (int i = 0; i < Zapr.size(); i++)
		if (Zapr[i].first == N1 && Zapr[i].second == N2)
			return true;
	return false;
}

int EvalSum( int N1, int N2, int *Arr )
{
	int res = 0;
	for (int i = N1 - 1; i <= N2 - 1; i++)
		res += Arr[i];
	return res;
}

int main( void )
{
	int n, *Arr;

	std::cin >> n;
	Arr = new int[n];

	for (int i = 1; i <= n; i++)
	{
		for (int j = i; j >= 1; j--)
			if (!IsZapr(j , i))
			{
				int sum, zapr1, zapr2;

				std::cout << "? " << j << " " << i << " " << std::endl;
				std::cin >> sum;
				std::cin >> zapr1;
				std::cin >> zapr2;
				Zapr.push_back(std::pair<int, int>(zapr1, zapr2));
				Arr[i - 1] = sum - EvalSum(j , i - 1, Arr);
				break;
			}
	}

	std::cout << "!" << std::endl;

	for (int i = 0; i < n; i++)
		std::cout << Arr[i] << " ";
	delete[] Arr;
	return 0;
}