#include <stdio.h>
#include <stdlib.h>
void swap( int *x, int *y )
{
    int tmp;
    tmp = *x;
    *x = *y;
    *y = tmp;
}

void QuickSort( int *a, int N )
{
    int b = 0, e = N - 1;
    float x = a[N / 2];
    
    if (N < 2)
        return;
    while(b <= e)
    {
        while (a[b] < x)
            b++;
        while (a[e] > x)
            e--;
            
        if (b <= e)
        {
            if (b != e)
            swap(&a[b], &a[e]);
            b++;
            e--;
        }
    }
}

int main( void )
{
    int sum, a, b, n, i, j = 0, k = 0;
    scanf("%i %i %i", &n, &a, &b);
    int T[n], P[n], aa[n], tmin[n];
    char tpt[n];
    for (i = 0; i < n; i++)
        scanf("%i", &T[i]);
    for (i = 0; i < n; i++)
        scanf("%i", &P[i]);
    
    for (i = 0; i < n; i++)
        aa[i] = T[i] - P[i];
            
    
    QuickSort(aa, n);
    
    for (j = 0; j < n; j++)
        for (i = 0; i < n; i++)
            if (T[i] - P[i] == aa[j])
            {
                tmin[k] = i;
                k++;
            }
    for( i = 0; i< n; i++)
    {
        if (T[i] > P[i])
        {
            tpt[i] = 'T';
            sum += T[i];
            a--;
        }
        else        
        {
            tpt[i] = 'P';
            sum += P[i];
            b--;
        }
    }
    if (a > 0)
        for (i = 0; i < n; i++)
        {    
            tpt[tmin[i]] = 'T';
            sum -= P[tmin[i]];
            sum += T[tmin[i]];
            a--;
            if (a <= 0)
                break;
        }    
        
    if (b > 0)
        for (i = 0; i < n; i++)
        {   
            tpt[tmin[i]] = 'P';
            sum -= T[tmin[i]];
            sum += P[tmin[i]];
            b--;
            if (b <= 0)
                break;
        }    
        
    printf("%i\n", sum);
    for (i = 0; i < n; i++)
    {
        printf("%c ", tpt[i]);
    }
}