#include <bits/stdc++.h>
#define ll long long
using namespace std;
const int N = 2e5 + 10, oo = 1e9 + 10, LOG = 61;
ll base[LOG], ban[LOG], reversed = -1;
void insert(ll x) {
   x &= reversed;
   for (int bit = LOG - 1; bit >= 0; --bit) {
      if (x >> bit & 1) {
         if (base[bit] == 0) {
            base[bit] = x;
            return;
         }
         x ^= base[bit];
      }
   }
   assert(x == 0);
}
ll get_max(ll z) {
   for (int bit = LOG - 1; bit >= 0; --bit) {
      z = max(z, z ^ base[bit]);
   }
   return z;
}
int main() {
   ios::sync_with_stdio(0); cin.tie(0);
   ll n, x = 0, y = 0;
   cin >> n;
   vector<ll> a(n), b(n);
   for (int i = 0; i < n; ++i) {
      cin >> a[i];
      x ^= a[i];
   }
   for (int i = 0; i < n; ++i) {
      cin >> b[i];
      y ^= b[i];
   }
   ll z = 0;
   for (int bit = LOG - 1; bit >= 0; --bit) {
      if ((x ^ y) >> bit & 1) {
         reversed ^= 1LL << bit;
      } else {
         z += 1LL * (x >> bit & 1) << bit;
      }
   }
   vector<pair<ll, ll>> s(n);
   for (int i = 0; i < n; ++i) {
      s[i] = {a[i] ^ b[i], i};
      insert(s[i].first);
   }
   ll to = get_max(z) ^ z;
   ll all_xor = 0;
   sort(s.rbegin(), s.rend());
   vector<int> ans;
   for (int i = 0; i < n; ++i) {
      if (to > (to ^ s[i].first)) {
         ans.push_back(s[i].second);
         all_xor ^= s[i].first;
         to ^= s[i].first;
      }
   }
   cout << (x ^ all_xor) + (y ^ all_xor) << ' ' << (int)ans.size() << endl;
   for (int i : ans) cout << i + 1 << ' ';
}
