#pragma GCC target("avx2")
#pragma GCC optimization("O3")
#pragma GCC optimization("unroll-loops")

#include <set>
#include <map>
#include <queue>
#include <deque>
#include <stack>
#include <ctime>
#include <random>
#include <cmath>
#include <vector>
#include <bitset>
#include <string>
#include <cstring>
#include <iomanip>
#include <assert.h>
#include <iostream>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define bpp __builtin_popcount
#define dbg(var) cout << endl << #var << "=" << var << endl;
#define show(vec) {cout << endl << sz(vec) << endl; for(int el : vec) cout << el << " "; cout << endl;}

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int,int> pii;

ll binpow(ll a,ll b){
    ll res = 1;
    while(b > 0){
        if(b & 1)
            res *= a;
        a *= a;
        b >>= 1;
    }
    return res;
}

ll powmod(ll a,ll b,ll m){
    ll res = 1;
    while(b > 0){
        if(b & 1)
            res = (res * a) % m;
        a = (a * a) % m;
        b >>= 1;
    }
    return res;
}

int GCD(int a,int b){
    return (b > 0 ? GCD(b,a % b) : a);
}

const int N = 4e5 + 5;
const int mod = 1e9 + 7;
const ll inf = 1e18 + 18;
const double pi = acos(-1.0);
const double eps = 1e-9;

vector<ll> v;

set<int> S;

ll ReverseInt(ll x){
    ll Ans = 0;
    while(x){
        Ans += (x % 10);
        Ans *= 10;
        x /= 10;
    }
    return Ans / 10;
}

inline void solve(){
    ll a,b;
    cin >> a >> b;
    for(int i = 1; i * 1ll * i <= b; i++){
        if(i % 10 == 0) continue;
        ll x = i * 1ll * i;
        ll revx = ReverseInt(x);
        if(x == revx){
            v.pb(x);
            continue;
        }
        ll sqrevx = (ll)sqrt(revx);
        if(sqrevx * sqrevx == revx){
            if(revx <= b) v.pb(revx);
            if(x <= b) v.pb(x);
        }
    }
    sort(all(v));
    v.resize(unique(all(v)) - v.begin());
    int pos = lower_bound(all(v),a) - v.begin();
    //dbg(sz(v));
    //dbg(pos);
    cout << sz(v) - pos << endl;
}

signed main(){
	/*#ifndef ONLINE_JUDGE
		freopen("input.txt","r",stdin);
		freopen("output.txt","w",stdout);
	#endif*/
	ios_base::sync_with_stdio(0),cin.tie(0),cout.tie(0);
	int tt = 1;
	//cin >> tt;
	while(tt--) solve();
	return 0;
}