#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <deque>
#include <queue>
#include <set>
#include <map>

#define USE_MATH_DEFINES
#define int int64_t

using namespace std;

int32_t main(){
    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[--u].push_back(--v);
        g[v].push_back(u);
    }

    vector<int> l(n), d(n, 0);
    cin >> d[0];

    for (int i = 0; i < n; cin >> l[i++]) {}

    d[0] = (d.front() > l.front() ? d.front() : d.front() / 2);
    priority_queue<pair<int, int>> q;
    q.push(make_pair(d[0], 0));

    while (!q.empty()) {
        int v = q.top().second, cur_d = q.top().first;

        q.pop();

        if (cur_d < d[v])
            continue;

        for (int j = 0; j < g[v].size(); j++) {
            int to = g[v][j];

            if (d[v] > l[to]) {
                if (d[v] > d[to]) {
                    d[to] = d[v];
                    q.push(make_pair(d[to], to));
                }
            }
            else if (int(d[v] / 2) > d[to]) {
                d[to] = d[v] / 2;
                q.push(make_pair(d[to], to));
            }
        }
//        cout << v << ' ' << cur_d << '\n';
    }
//    for (int i = 0; i < n; i++)
//        cout << d[i] << ' ';
    cout << d.back();

}
