#include <iostream>
#include <string>
#include <vector>

using namespace std;

inline bool is_glasnaya(char c)
{
    return c == 'a' || c == 'e' || c == 'i' || c == 'o' || c == 'u';
}

inline unsigned int calc(const string& str)
{
    unsigned int c = 0;

    for(int i = 0; i < str.size(); i++)
    {
        if(is_glasnaya(str[i]))
        {
            c++;

            while(i < str.size() && is_glasnaya(str[i]))    i++;
        }
    }

    return c;
}

int main()
{
    int n, k = 0;

    cin >> n;

    vector<unsigned int> words(n);

    for(int i = 0; i < n; i++)
    {
        string str;

        cin >> str;

        words[i] = calc(str);
    }

    for(int i = 0; i < n - 3; i++)
    {
        int p = i, c = 0;
        bool flag = false;

        for(; p < n; p++)
        {
            c += words[p];

            if(c == 5)
            {
                p++;
                flag = true;
                break;
            }
            else if(c > 5)
            {
                break;
            }
        }

        if(!flag)    continue;

        for(; p < n; p++)
        {
            c += words[p];

            if(c == 12)
            {
                p++;
                flag = true;
                break;
            }
            else if(c > 12)
            {
                break;
            }
        }

        if(!flag)    continue;

        for(; p < n; p++)
        {
            c += words[p];

            if(c == 17)
            {
                k++;
                break;
            }
            else if(c > 17)
            {
                break;
            }
        }
    }

    cout << k;
}
