﻿#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <set>
#include <iostream>

typedef long long ll;

using namespace std;

ll change(ll num) {
    string s;
    ll ans;
    s = to_string(num);
    reverse(s.begin(), s.end());
    if (s[0] == '0') return -1;
    ans = stoi(s);
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    ll a, b;

    cin >> a >> b;

    set<ll> sett;

    for (ll i = a; i <= b; i++) {
        if (find(sett.begin(), sett.end(), i) != sett.end()) continue;
        ll num = i;
        double temp;
        temp = sqrt(num);
        if (temp != (int)temp) continue;
        double tmp;
        ll g;
        g = change(num);
        if (g == -1) continue;
        tmp = sqrt(g);
        if (tmp != (int)tmp) continue;
        sett.insert(num);
        sett.insert(g);
    }
    //for (auto i : sett) cout << i << ' ' << "\n";
    cout << sett.size();
}