﻿#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <utility>
#include <set>
#include <unordered_set>
#include <map>
#include <bitset>
#include <optional>
using namespace std;


unsigned long long reverse_num(unsigned long long num) {
	string str_num = to_string(num);
	string str_result = "";
	for (unsigned long long i = str_num.size() - 1; i >= 0; --i) {
		str_result.push_back(str_num[i]);
	}

	return stoi(str_result);
}

bool is_valid_square(int num) {
	return ((int)sqrt(num) * (int)sqrt(num)) == num && (num % 10 != 0);
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	

	int a, b;
	cin >> a >> b;

	unsigned long long count = 0;

	/*
	if ((int)10 == (double)10.0) cout << "amogus" << endl;
	for (int i = a; i < sqrt(b); ++i) {
		
		if ((i * i > a) && (i * i <= b) && reverse_num(i * i) > a && reverse_num(i * i) <= b) {
			cout << i * i << endl;
			count++;
		}
	} */

	for (unsigned long long i = a; i <= b; ++i) {
		unsigned long long reverse_i = reverse_num(i);
		if (is_valid_square(i) && is_valid_square(reverse_i)) {
			count++;
		}
	}
	

	cout << count << endl;

	return 0;
}