#include <iostream>
#include <vector>
#include <set>

const long long maxN = 200000;
long long n, m, u, v, x, a[maxN], dist[maxN];
std::vector<long long> gr[maxN];
std::set<std::pair<long long, long long>> s;

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cin >> n >> m;
    for (long long i = 0; i < m; i++) {
        std::cin >> u >> v;
        gr[--u].push_back(--v);
        gr[v].push_back(u);
    }
    std::cin >> x;
    for (long long i = 0; i < n; i++)
        std::cin >> a[i];
    if (x > a[0])
        dist[0] = x;
    else
        dist[0] = x / 2;
    s.insert({ -dist[0], 0 });
    while (!s.empty()) {
        u = s.begin()->second;
        s.erase(s.begin());
        for (long long v : gr[u])
            if ((dist[u] > a[v] && dist[u] > dist[v]) || (dist[u] <= a[v] && dist[u] / 2 > dist[v])) {
                s.erase({ -dist[v], v });
                if (dist[u] > a[v])
                    dist[v] = dist[u];
                else
                    dist[v] = dist[u] / 2;
                s.insert({ -dist[v], v });
            }
    }
    std::cout << dist[n - 1];
    return 0;
}
