﻿#include <bits/stdc++.h>

using namespace std;

#define magic_define cin.tie(NULL); ios_base::sync_with_stdio(false); cout << fixed; cout.precision(17);
#define ll __int128
#define pii pair<int, int>
#define vi vector<int>

std::ostream&
operator<<(std::ostream& dest, __int128_t value)
{
    std::ostream::sentry s(dest);
    if (s) {
        __uint128_t tmp = value < 0 ? -value : value;
        char buffer[128];
        char* d = std::end(buffer);
        do
        {
            --d;
            *d = "0123456789"[tmp % 10];
            tmp /= 10;
        } while (tmp != 0);
        if (value < 0) {
            --d;
            *d = '-';
        }
        int len = std::end(buffer) - d;
        if (dest.rdbuf()->sputn(d, len) != len) {
            dest.setstate(std::ios_base::badbit);
        }
    }
    return dest;
}

void solve() {
    long long _a, _b;
    cin >> _a >> _b;
    ll a = _a, b = _b;
    vector<pair<ll, ll>> ans;
    while (a != 0 && b != 0) {
        if (abs(a) < abs(b)) {
            ans.push_back({ 2, -(b / a) });
            b -= a * (b / a);
        }
        else {
            ans.push_back({ 1, -(a / b) });
            a -= b * (a / b);
        }
    }
    cout << ans.size() << "\n";
    for (auto elem : ans)
        cout << elem.first << " " << elem.second << "\n";
}

int32_t main() {
    magic_define;
    solve();
    return 0;
}