#pragma GCC target("avx2")
#pragma GCC optimization("O3")
#pragma GCC optimization("unroll-loops")

#include <bits/stdc++.h>

#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

void solve()
{
    ll n, m;
    cin >> n >> m;
    ll x, y;
    vector<vector<ll>> a(n);
    vector<ll> b(n);
    for (int i = 0; i < m; ++i)
    {
        cin >> x >> y;
        --x;
        --y;
        a[x].push_back(y);
        a[y].push_back(x);
    }
    cin >> x;
    for (int i = 0; i < n; ++i)
    {
        cin >> b[i];
    }
    vector<ll> dp(n + 4, 0);
    for (int _ = 0; _ < 100; ++_)
    {
        if (x > b[0])
            dp[0] = x;
        else
            dp[0] = x / 2;
        for (int i = 0; i < n; ++i)
        {
            if (dp[i])
            {
                for (int j = 0; j < a[i].size(); ++j)
                {
                    if (a[i][j] > i)
                        dp[a[i][j]] = max(dp[a[i][j]], dp[i] > b[a[i][j]] ? dp[i] : dp[i] / 2);
                }
            }
        }
    }
    cout << dp[n - 1] << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    ll _ = 1;
    // cin >> _;
    while (_--)
        solve();
}