
#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <bitset>
#include <fstream>
#include <unordered_set>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#include <stack>
#include <queue>
#include <complex>
#include <random>
#include <chrono>


using namespace std;
using namespace __gnu_pbds;



/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")*/

/*#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,tune=native")
#pragma GCC target("avx2")
#pragma GCC optimization("O3")
#pragma GCC optimization("unroll-loops")*/

#define int long long
#define ll long long
//#define int short int
#define eb emplace_back
#define pb push_back
#define ld long double
//#define ld double
#define mp make_pair
#define f first
#define s second
#define gleg(x) return cout << x, 0
#define pii pair <int, int>
#define deb(a) cerr << #a << " = " << a << '\n';
//#define sz(x) (int)s.size();
#define fast() {     ios_base::sync_with_stdio(0);     cin.tie(0);     cout << fixed << setprecision(9);     cerr << fixed << setprecision(12); }


typedef tree <
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set ;


const int INF = 1e18 + 7;
const ld EPS = 1e-6;
const int MAXI = 350;
const int MOD = 998244353;
const int MOD1 = 1e9 + 7;
const int MAXST = 2000000;
const int P = 31;
const int P1 = 37;
const int N = 5100000;
const ld PI = 3.14159265358979323;
const int bp = 23;
//const int sz = 1 << bp;


ostream &operator<<(ostream &stream, const pair <int, int> &p) {
    stream << p.first << ' ' << p.second << ' ';
    return stream;
}

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

clock_t tStart = clock();

struct T{
    ld x, y;

    T(){
        x = y = 0;
    }

    T(ld _x, ld _y){
        x = _x, y = _y;
    }

    ld len(){
        return sqrt(x * x + y * y);
    }

    void norm(){
        x /= len();
        y /= len();
    }

    void mult(ld k){
        x *= k;
        y *= k;
    }

    void del(ld k){
        x /= k;
        y /= k;
    }
};



ld operator ^ (T a, T b){
    return a.x * b.y - a.y * b.x;
}

ld operator * (T a, T b){
    return a.x * b.x + a.y * b.y;
}

T operator + (T a, T b){
    return T(a.x + b.x, a.y + b.y);
}

T operator - (T a, T b){
    return T(a.x - b.x, a.y - b.y);
}

struct ts{
    int x, y, ind;

    ts(){
        x = y = ind = 0;
    }

    ts(int _x, int _y, int _ind){
        x = _x, y = _y, ind = _ind;
    }
};

signed main(){
    fast();
    srand(time(0));
//    #ifdef LOCAL
    //freopen("stacks.in", "r", stdin);
    //freopen("stacks.out", "w", stdout);
//    #endif

    int n, a, b;
    cin >> n >> a >> b;
    vector <ts> t(n);

    for (int i = 0; i < n; i++){
        cin >> t[i].x;
        t[i].ind = i;
    }

    for (int i = 0; i < n; i++){
        cin >> t[i].y;
    }

    sort(t.begin(), t.end(), [](ts a, ts b){
        if (a.x - a.y == b.x - b.y)
            return a.ind < b.ind;
        else
            return a.x - a.y > b.x - b.y;
    });

    int sm = 0;
    vector <char> ans(n);
    for (int i = 0; i < a; i++){
        sm += t[i].x;
        ans[t[i].ind] = 'T';
    }

    for (int i = n - 1; i >= n - b; i--){
        sm += t[i].y;
        ans[t[i].ind] = 'P';
    }

    for (int i = a; i < n - b; i++){
        if (t[i].x > t[i].y) {
            sm += t[i].x;
            ans[t[i].ind] = 'T';
        }
        else{
            sm += t[i].y;
            ans[t[i].ind] = 'P';
        }
    }

    cout << sm << '\n';
    for (auto i: ans)
        cout << i << ' ';
    cout << '\n';
    return 0;
}
