
#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <bitset>
#include <fstream>
#include <unordered_set>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#include <stack>
#include <queue>
#include <complex>
#include <random>
#include <chrono>


using namespace std;
using namespace __gnu_pbds;



/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")*/

/*#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,tune=native")
#pragma GCC target("avx2")
#pragma GCC optimization("O3")
#pragma GCC optimization("unroll-loops")*/

#define int long long
#define ll long long
//#define int short int
#define eb emplace_back
#define pb push_back
#define ld long double
//#define ld double
#define mp make_pair
#define f first
#define s second
#define gleg(x) return cout << x, 0
#define pii pair <int, int>
#define deb(a) cerr << #a << " = " << a << '\n';
//#define sz(x) (int)s.size();
#define fast() {     ios_base::sync_with_stdio(0);     cin.tie(0);     cout << fixed << setprecision(9);     cerr << fixed << setprecision(12); }


typedef tree <
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set ;


const int INF = 1e18 + 7;
const ld EPS = 1e-6;
const int MAXI = 350;
const int MOD = 998244353;
const int MOD1 = 1e9 + 7;
const int MAXST = 2000000;
const int P = 31;
const int P1 = 37;
const int N = 5100000;
const ld PI = 3.14159265358979323;
const int bp = 23;
//const int sz = 1 << bp;


ostream &operator<<(ostream &stream, const pair <int, int> &p) {
    stream << p.first << ' ' << p.second << ' ';
    return stream;
}

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

clock_t tStart = clock();

struct T{
    ld x, y;

    T(){
        x = y = 0;
    }

    T(ld _x, ld _y){
        x = _x, y = _y;
    }

    ld len(){
        return sqrt(x * x + y * y);
    }

    void norm(){
        x /= len();
        y /= len();
    }

    void mult(ld k){
        x *= k;
        y *= k;
    }

    void del(ld k){
        x /= k;
        y /= k;
    }
};



ld operator ^ (T a, T b){
    return a.x * b.y - a.y * b.x;
}

ld operator * (T a, T b){
    return a.x * b.x + a.y * b.y;
}

T operator + (T a, T b){
    return T(a.x + b.x, a.y + b.y);
}

T operator - (T a, T b){
    return T(a.x - b.x, a.y - b.y);
}




string to_str(int x){
    string s;
    while (x){
        s += char('0' + x % 10);
        x /= 10;
    }
    return s;
}

int to_int(string s){
    int x = 0;
    for (int i = 0; i < s.size(); i++){
        x *= 10;
        x += s[i] - '0';
    }
    return x;
}

signed main(){
    fast();
    srand(time(0));
//    #ifdef LOCAL
    //freopen("stacks.in", "r", stdin);
    //freopen("stacks.out", "w", stdout);
//    #endif
    int a, b;
    cin >> a >> b;
    int kol1 = 0, kol2 = 0;
    map<int, int> mp;
    for (int i = 1; i * i <= 1e11; i++){
        mp[i * i] = 1;
    }
    for (int i = ceil(sqrt(a)); i <= sqrt(b); i++){
        int x = i * i;
        if (i % 10 == 0)
            continue;
        string s = to_string(x);
        string s2 = s;
        reverse(s2.begin(), s2.end());
        int y = to_int(s2);
        if (mp.find(y) != mp.end()) {
            kol1++;
        }
    }
    cout << kol1 << '\n';
    return 0;
}
