#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define fi first
#define se second
#define endl "\n"

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

long double n, m, dp[100010], dp1[100010], mn[500010], ans, L[100010], s[100010];

void build (int l, int r, int x)
{
    if (r < l) return;
    if (l == r)
    {
        mn[x] = dp[l];
        return;
    }
    build (l, (l + r) / 2, x * 2);
    build ((l + r) / 2 + 1, r, x * 2 + 1);
    mn[x] = min (mn[x * 2], mn[x * 2 + 1]);
}

void get (int l, int r, int tl, int tr, int x)
{
    if (r < l) return;
    if (tl > r) return;
    if (tr < l) return;

    tl = max (l, tl);
    tr = min (r, tr);

    if (l == tl and r == tr)
    {
        ans = min (ans, mn[x]);
        return;
    }
    get (l, (l + r) / 2, tl, tr, x * 2);
    get ((l + r) / 2 + 1, r, tl, tr, x * 2 + 1);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> m >> n;
    for (int i = 1; i <= n; i++)
    {
        int e, t;
        cin >> e >> t;
        L[i] = e;
        s[i] = t - e + 1;
    }
    for (int i = 1; i <= m; i++) dp1[i] = 1e9;
    s[0] = n + m;
    for (int i = 1; i <= n; i++)
    {
        build (1, m, 1);
        for (int o = 1; o <= m; o++)
        {
            int l, r;
            int k = abs (L[i] - o);
            l = o - s[i - 1] + 1;
            l = max (1, l);
            r = o + s[i] - 1;
            if (r > m) break;
            ans = 1e9;
            get (1, m, l, r, 1);
            dp1[o] = ans + k;
        }
        for (int o = 1; o <= m; o++)
        {
            dp[o] = dp1[o];
            dp1[o] = 1e9;
        }
    }
    ans = 1e9;
    for (int i = 1; i <= m; i++) ans = min (ans, dp[i]);
    cout << ans << endl;
    return 0;
}
