#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 1e6 + 3e2;

#define MP make_pair

vector<int> g[N];

int a[N];
int d[N];
bool processed[N];

void solve(){
    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= m; i++){
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    int p;
    cin >> p;

    for (int i = 1; i <= n; i++) cin >> a[i];

    if (a[1] >= p) p /= 2;
    d[1] = p;

    priority_queue<pair<int, int>> pq;
    pq.push(MP(p, 1));

    while (!pq.empty()){
        int x = pq.top().second; pq.pop();
        if (processed[x]) continue;
        processed[x] = true;
        for (int y : g[x]){
            int cur = d[x];
            if (a[y] >= cur) cur /= 2;
            if (d[y] < cur){
                d[y] = cur;
                pq.push(MP(d[y], y));
            }
        }
    }

    cout << d[n];

}

int main(){
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int TC = 1;
    //cin >> TC;

    for (int tt = 1; tt <= TC; tt++){
        solve();
    }

    return 0;
}
