#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("O3")
#pragma GCC target ("avx2")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define pb push_back

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set =
tree<T, null_type, less<T>, rb_tree_tag, 
tree_order_statistics_node_update>;

typedef long long ll;

double x, t, k1, k2;

double f (double y) {
	if (y >= 0.0 && y < t/6.0) {
		return (k1 * y) * (t - y);
	} else if (y >= t/6 && y < t/3) {
		return ((y-t/6) * k2 + x) * (t - y);	
	} else {
		return 100.0 * (t - y);
	}		
}

int main() {
  	ios_base::sync_with_stdio(0);
  	cin.tie(0); cout.tie(0);
  	cin >> x >> t;
  	k1 = 6.0 * x / t; 
  	k2 = 6 * (100 - x) / t;
  	double l = 0.0, r = t;
  	for (int i = 0; i < 300; i++) {
  		double m1 = l + (r - l) / 3.0;
  		double m2 = r - (r - l) / 3.0;
  		if (f(m1) < f(m2)) {
				l = m1;  			
  		} else {
  			r = m2;
  		}
  	}
  	cout << fixed << setprecision(10) << min(f(l), f(r));
  	return 0;
}
