//#pragma GCC target ("avx2")
//#pragma GCC optimization ("Ofast")
//#pragma GCC optimization ("unroll-loops")

//#pragma comment(linker,"/stack:200000000")
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

//order_of_key(k): Number of items strictly smaller than k .
//find_by_order(k): K-th element in a set (counting from zero).
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define full(x,n) x,x+n+1
#define full(x) x.begin(),x.end()
#define finish return 0

#define putb push_back
#define f first
#define s second

//logx(a^n)=loga(a^n)/logx(a)
//logx(a*b)=logx(a)+logx(b)
//logx(y)=log(y)/log(x)
//logb(n)=loga(n)/loga(b)

#define ordered_set tree<ll,null_type,less<ll>,rb_tree_tag,tree_order_statistics_node_update>
#define putf push_front
#define gainb pop_back

//(a+b)^n=sum of C(n,i)*a^i*b^(n-i) 0<=i<=n
//(a-b)^n=sum of C(n,i)*a^i*b^(n-i) for even i-for odd i

#define gainf pop_front
#define len(x) (int)x.size()
#define int long long

// 1/b%mod=b^(m-2)%mod
// (a>>x)&1==0
// a^b=(a+b)-2(a&b)

typedef double db;
typedef long long ll;

//sum of squares n*(n+1)*(2n+1)/6
//sum of cubes [n*(n+1)/2]^2
//sum of squares for odds n*(4*n*n-1)/3
//sum of cubes for odds n*n*(2*n*n-1)

const int ary=1e6+5;
const ll mod=1e18;
const ll inf=1e18;

using namespace std;
using namespace __gnu_pbds;
int n,m,t[2][4*ary],l[ary],r[ary],k[ary],o;
void build(int v=1,int tl=1,int tr=n){
	t[o][v]=mod;
	if(tl==tr){
		return;
	}
	int tm=(tl+tr)/2;
	build(v*2,tl,tm);
	build(v*2+1,tm+1,tr);
}
void upd(int pos,int x,int v=1,int tl=1,int tr=n){
	if(tr<pos||tl>pos){
		return;
	}
	if(tl==tr){
		t[o][v]=x;
		return;
	}
	int tm=(tl+tr)/2;
	upd(pos,x,v*2,tl,tm);
	upd(pos,x,v*2+1,tm+1,tr);
	t[o][v]=min(t[o][v*2],t[o][v*2+1]);
}
int get(int l,int r,int v=1,int tl=1,int tr=n){
	if(r<tl||tr<l||l>r){
		return mod;
	}
	if(l<=tl&&tr<=r){
		return t[o][v];
	}
	int tm=(tl+tr)/2;
	return min(get(l,r,v*2,tl,tm),get(l,r,v*2+1,tm+1,tr));
}
 main(){
  	ios_base::sync_with_stdio(0);
  	cin.tie(0);cout.tie(0);
	cin>>n>>m;
	for(int i=1;i<=m;i++){
		o=i%2;
		build();
		int s,t;
		cin>>s>>t;
		k[i]=t-s+1;
		l[i]=1;
		r[i]=n-k[i]+1;
		for(int j=l[i];j<=r[i];j++){
			int a=abs(s-j);
			if(i==1){
				upd(j,a);
				continue;
			}
			int l1=max(j-k[i-1]+1,l[i-1]);
			int r1=min(j,r[i-1]);
			o=1-o;
			a+=get(l1,r1);
			o=1-o;
			upd(j,a);
		}
		if(get(1,n)>=mod){
			assert(0);
			assert(1);
		}
	}
	cout<<get(1,n);
}
