#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <deque>
#include <queue>
#include <chrono>
#include <string>
#include <string.h>
#include <set>
#include <map>

using namespace std;

#define int long long
#define ff first
#define ss second
#define all(x) (x).begin(),(x).end()
#define pb push_back
#define ll long long

ll gcd(ll a, ll b){
    if(!b) return a;
    return gcd(b, a % b);
}

ll lcm(ll a, ll b){
    return (a / gcd(a, b)) * b;
}

ll binpow(ll a, ll b, ll m){
    a %= m;
    if(b == 1) return a;
    ll k = binpow(a, b / 2, m) % m;
    k = k * k; k %= m;
    if(b % 2) k = (k * a) % m;
    return k % m;
}

int rev(int a){
    if(a % 10 == 0) return -1;
    vector <int> v;
    while(a > 0){
        v.pb(a % 10);
        a /= 10;
    }
    int res = 0;
    for(auto &x: v){
        res *= 10;
        res += x;
    }
    return res;
}

vector <int> a;
map <char, bool> let;

int fun(string s){
    int n = (int)s.size();
    int res = 0;
    for(int i = 0; i < n; i ++){
        if(let[s[i]] and (i == 0 or !let[s[i - 1]]))
            res ++;
    }
    return res;
}

void t_main(){
    int n; cin >> n;
    string s;
    a.resize(n + 1);
    
    for(int i = 1; i <= n; i ++){
        cin >> s;
        a[i] = fun(s);
    }
    bool a1 = false, a2 = false, a3 = false;
    int cur = 0, ans = 0;
    for(int i = 1; i <= n; i ++){
        a1 = false, a2 = false, a3 = false; cur = 0;
        for(int j = i; (cur <= 17 and j <= n); j ++){
            cur += a[j];
            if(cur == 5) a1 = true;
            if(cur == 12) a2 = true;
            if(cur == 17) a3 = true;
        }
        if(a1 && a2 && a3) ans ++;
    }
    cout << ans << "\n";
}

signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    
    let['a'] = true;
    let['i'] = true;
    let['o'] = true;
    let['e'] = true;
    let['u'] = true;
    
    int tt = 1;
    //cin >> tt;
    
    while(tt --) t_main();
    return 0;
}
