#include <bits/stdc++.h>

using namespace std;

const int MAXN = 2e5 + 5;

vector<int> g[MAXN];
vector<int> d(MAXN);
vector<int> dist(MAXN,0);
struct cmp{
    bool operator()(const pair<int,int> &a,const pair<int,int> &b) {
        return a.first > b.first;
    }
};

void dijkstra(int x) {
	dist[1]=x;
	set<pair<int,int>, cmp> q;
	q.insert({x,1});

	while(!q.empty()) {
		int cur=q.begin()->second;
		q.erase(q.begin());
		for(int i=0;i<g[cur].size();i++) {
			int to = g[cur][i];
			int curcnt = dist[cur];
			if (curcnt <= d[to]) curcnt/=2;

			if (dist[to] < curcnt) {
				q.erase({dist[to],to});
				dist[to] = curcnt;
				q.insert({dist[to],to});
			}
		}
	}
}

int main() {

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n,m;
    cin>>n>>m;

    for(int i=0;i<m;i++) {
        int x,y;
        cin>>x>>y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    int x;
    cin>>x;
    for(int i=1;i<=n;i++) cin>>d[i];

    if (x<=d[1]) x/=2;
    dijkstra(x);

    cout<<dist[n];


    return 0;
}
