#include <bits/stdc++.h>
using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> s(m + 1), t(m + 1);
    for (int i = 1; i <= m; ++i) {
        cin >> s[i] >> t[i];
        --s[i]; --t[i];
    }
    vector<vector<int>> dp(n, vector<int>(m + 1, 2e9));
    for (int i = 0; i < n; ++i) {
        dp[i][0] = 0;
    }
    deque<int> d;
    for (int j = 1; j <= m; ++j) {
        int len = t[j - 1] - s[j - 1] + 1;
        d.clear();
        for (int i = 0; i < t[j] - s[j]; ++i) {
            while (!d.empty() && dp[d.back()][j - 1] >= dp[i][j - 1]) {
                d.pop_back();
            }
            d.push_back(i);
        }
        for (int i = 0; i + t[j] - s[j] < n; ++i) {
            if (!d.empty() && d.front() + len - 1 < s[j]) {
                d.pop_front();
            }
            while (!d.empty() && dp[d.back()][j - 1] >= dp[i + t[j] - s[j]][j - 1]) {
                d.pop_back();
            }
            d.push_back(i + t[j] - s[j]);
            dp[i][j] = dp[d.front()][j - 1] + abs(s[j] - i);
        }
    }
    int ans = 2e9;
    for (int i = 0; i < n; ++i) {
        ans = min(ans, dp[i][m]);
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
