#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e9 + 7;
vector<int> graph[200001];
int robot[200001];
int ans[200001];

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n , m;
    cin >> n >> m;
    for (int i = 0; i < m; i++){
        int v1 , v2;
        cin >> v1 >> v2;
        v1--; v2--;
        graph[v1].push_back(v2);
        graph[v2].push_back(v1);
    }
    int x; cin >> x;
    for (int i = 0; i < n; i++){
        cin >> robot[i];
        ans[i] = -INF;
    }
    priority_queue<pair<int, int>, vector<pair<int, int>>> q;
    if(robot[0] >= x){
        q.push({0, x / 2}); ans[0] = x / 2;
    } else {
        q.push({0, x}); ans[0] = x;
    }
    while(!q.empty()){
        pair<int, int> c = q.top();
        q.pop();

        int v = c.first;
        int kl = c.second;

        if(ans[v] > kl){
            continue;
        }


        for(int i = 0; i < graph[v].size(); i++){
            int robot0 = robot[graph[v][i]];
            if(robot0 >= kl){
                 if (ans[graph[v][i]] < kl / 2){
                    q.push({graph[v][i], kl / 2});
                    ans[graph[v][i]] = kl / 2;
                 }
            }
            else{
                if(ans[graph[v][i]] < kl){
                    q.push({graph[v][i], kl});
                    ans[graph[v][i]] = kl;
                }
            }
        }
    }
    cout << ans[n - 1];
    /*
    4 4
    1 2
    1 3
    2 4
    3 4
    7
    10 2 3 1

    */
}
