﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <ctype.h>
#include <deque>
#include <cstring>
#include <set>
#include <bitset>
#include <map>
#include <chrono>
#include <random>
#include <unordered_map>
#include <stdio.h>

using namespace std;

//╱╱╭━╮╭━┳━━━┳━╮╱╱╱╱╱╱╭━┳━━━┳━╮╭━╮
//╱╭╯╭╋╯╭┫╭━╮┣╮╰╮╱╱╱╱╭╯╭┫╭━╮┣╮╰╋╮╰╮
//╭╯╭╋╯╭╯┃┃┃┃┃╰╮╰┳╮╭┳╯╭╯┃┃┃┃┃╰╮╰╋╮╰╮
//┃┃┃┃┃┃╱┃┃┃┃┃╱┃┃┃╰╯┃┃┃╱┃┃┃┃┃╱┃┃┃┃┃┃
//┃┃┃┃┃┃╱┃╰━╯┃╱┃┃┣╮╭┫┃┃╱┃╰━╯┃╱┃┃┃┃┃┃
//╰╮╰╋╮╰╮╰━━━╯╭╯╭╯╰╯╰╮╰╮╰━━━╯╭╯╭╋╯╭╯
//╱╰╮╰╋╮╰╮╱╱╱╭╯╭╯╱╱╱╱╰╮╰╮╱╱╱╭╯╭╋╯╭╯
//╱╱╰━╯╰━╯╱╱╱╰━╯╱╱╱╱╱╱╰━╯╱╱╱╰━╯╰━╯

vector<int> gr[100000 + 113];
vector<int> color_global, pay;
int sol = 0, n;

void dfsFirst(vector<int> &color, int v, int x) {
    color[v] = 1;
    if (v == n - 1) {
        sol = x;
    }
    for (int u : gr[v]) {
        if (!color[u] && pay[u] < x) {
            dfsFirst(color, u, x);
        }
    }
}

void dfsSecond(vector<int>& color, int v) {
    bool flag = false;
    for (int u : gr[v]) {
        if (color_global[u]) {
            flag = true;
        }
    }
    if (flag) {
        color[v] = 1;
    }
}

void solve() {
    int m, x;
    cin >> n;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        gr[u - 1].push_back(v - 1);
        gr[v - 1].push_back(u - 1);
    }

    gr[n].push_back(0);
    gr[0].push_back(n);

    cin >> x;
    for (int i = 0; i < n; ++i) {
        int q;
        cin >> q;
        pay.push_back(q);
        color_global.push_back(0);
    }

    pay.push_back(1);
    color_global.push_back(1);

    while (x > 0 && sol == 0) {
        vector<int> color(n + 1);
        for (int i = 0; i < n + 1; ++i) {
            if (color_global[i] == 0) {
                continue;
            }
            
            dfsFirst(color, i, x);
     
        }
        for (int j = 0; j < n; ++j) {
            if (color[j]) {
                color_global[j] = 1;
            }
        }
        x /= 2;
        vector<int> color2(n + 1);
        for (int i = 0; i < n + 1; ++i) { 
            if (color_global[i] == 0) {
                dfsSecond(color2, i);
            }
        }
        for (int j = 0; j < n; ++j) {
            if (color2[j]) {
                color_global[j] = 1;
            }
        }
    }
    cout << sol;
}

int main() {
    ios_base::sync_with_stdio(false);
    srand((unsigned int)time(nullptr));
    cout.setf(ios::fixed);
    cout.precision(9);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int T = 1;
    //cin >> T;
    while (T--) { solve(); }

    return (0 - 0); //;(
}