#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <math.h>
#include <functional>
#include <string>
using namespace std;
#define all(o) (o).begin(), (o).end()
#define rall(o) (o).rbegin(), (o).rend()
using ll = long long;
#if LOCAL
#define dbg(o) {cout << #o << " = " << (o) << "\n"; o;}
#else
#define dbg(o) (o)
#endif

template<typename T>
ostream &operator<<(ostream &out, vector<T> v) {
    for (T e : v) {
        out << e << " ";
    }
    return out;
}
template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &e : v) {
        in >> e;
    }
    return in;
}
string res = "";
int ans = 0;
int f = 1;
void my_gcd(ll a, ll b) {
    if (b == 0) return;
    ans++;
    res += to_string((f ? 1 : 2)) + " " + to_string(-(a/b)) + "\n";
    f ^= 1;
    my_gcd(b, a % b);
}

void solve() {
    ll a, b; cin >> a >> b;

    if (a < 0) {
        ll x = (abs(a) / abs(b)) + 1;
        if (b < 0) {
            a -= x * b;
            ans++;
            res += "1 " + to_string(-x) + "\n";
        } else {
            a += x * b;
            ans++;
            res += "1 " + to_string(x) + "\n";
        }
    }
    if (b < 0) {
        ll x = (abs(b) / abs(a)) + 1;
        b += a * x;
        ans++;
        res += "2 " + to_string(x) + "\n";
    }
    dbg(a);
    dbg(b);
    my_gcd(a, b);
    cout << ans << endl;
    cout << res;
}

int main() {
    cout.precision(16);
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#if LOCAL
    freopen("../A.in", "r", stdin);
    // freopen("../A.out", "w", stdout);
#endif
    solve();
    return 0;
}
