#include <bits/stdc++.h>
using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

typedef long long ll;

const int INF = 0x3f3f3f3f;
const ll LLINF = 0x3f3f3f3f3f3f3f3f;
const int MAXN = 2e5;

ll dist[MAXN];
std::vector<int> g[MAXN];
ll now[MAXN];
bool used[MAXN];

void solve() {
    int n, m;
    std::cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int a, b;
        std::cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    ll x;
    std::cin >> x;
    for (int i = 0; i < n; i++) std::cin >> now[i];
    dist[0] = (x > now[0] ? x : x / 2);
    std::priority_queue<pair<ll, ll>> q;
    q.emplace(dist[0], 0);
    while (!q.empty()) {
        auto [cock, v] = q.top();
        q.pop();
        if (used[v]) continue;
        used[v] = true;
        for (auto &to : g[v]) {
            if (used[to]) continue;
            ll newval = (cock > now[to] ? cock : cock / 2);
            if (newval > dist[to]) {
                dist[to] = newval;
                q.emplace(dist[to], to);
            }
        }
    }
    std::cout << dist[n - 1] << '\n';
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
