#include <bits/stdc++.h>
using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

//#define double long double

using ll = long long;

/*
3
0 1
0 1
1 1

 */

/*
5
0 1
0 2
0 3
0 40
0 4

 */

const double EPS = 1e-9;

struct ps {
    double a, b;

    ps() = default;
    ps(double a, double b) : a(a), b(b) {}

    bool operator<(const ps &p) const {
        // a - p.a < 0
        if (fabs(a - p.a) > EPS) return (a - p.a) < -EPS;
        return (b - p.b) < -EPS;
    }
};

void solve() {
    int n;
    cin >> n;
    if (n == 1) {
        cout << "1\n";
        return;
    }
    vector<int> s(n), v(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i] >> v[i];
    }
    int ans = 2;
    for (int i = 0; i < n; i++) {
        map<ps, int> mp;
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            double k = (v[j] - v[i]) / (double) (j - i);
            double b = (s[j] - s[i]) / (double) (j - i);
            mp[{k, b}]++;
        }
        map<ps, int> mp2;
        for (auto[p1, x]: mp) {
            ans = max(x + 1, ans);
            auto[k1, b1] = p1;
            set<ps> ss;
            for (auto[p2, y]: mp) {
                auto[k2, b2] = p2;
                double k = k1 - k2;
                double b = b2 - b1;
                if (fabsl(k) > EPS) {
                    double z = b / k;
                    double h = b1 + z * k1;
                    if (z >= -EPS) ss.emplace(z, h);
                }
            }
            for (auto p: ss) {
                mp2[p] += x;
            }
        }
        for (auto[p, x]: mp2) {
            ans = max(ans, x + 1);
        }
    }
    cout << ans << '\n';
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
