#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#define forall(i, x) for(auto& i: x)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define mp make_pair
#define f first
#define s second

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = double;

const ll inf = 9e18;
struct equality
{
    ld A, B, C;
};
struct pt
{
    ld x, y;
};
equality get_equality(pt A, pt B)
{
    equality t = {B.y - A.y, A.x - B.x, A.y * B.x - A.x * B.y};
    return t;
}
ld effect(equality a, ld time)
{
    ld p = -(a.A * time + a.C) / a.B;
    return p;
}
void solve(){

    ld x, T;
    cin >> x >> T;
    equality t6 = get_equality({0, 0}, {T/6.0, x});
    equality t3 = get_equality({T/6.0, x}, {T/3.0, 100.0});
    ld l = 0, r = T/6.0;
    ld maxt6= 0;
    for(int i = 0; i < 1e5; i++)
    {
        double m1 = l + (r - l) / 3.0,
                m2 = r - (r - l) / 3.0;
        if(effect(t6, m1) * (T - m1) <= effect(t6, m2) * (T - m2))
        {
            maxt6 = max(maxt6, max(effect(t6, m1) * (T - m1), effect(t6, m2) * (T - m2)));
            l = m1;
        }
        else
        {
            maxt6 = max(maxt6, max(effect(t6, m1) * (T - m1), effect(t6, m2) * (T - m2)));
            r = m2;
        }
    }
    ld maxt3 = 0;
    l = T/6.0, r = T/3.0;
    for(int i = 0; i < 1e5; i++)
    {
        double m1 = l + (r - l) / 3.0,
                m2 = r - (r - l) / 3.0;
        if(effect(t3, m1) * (T - m1) <= effect(t3, m2) * (T - m2))
        {
            maxt3 = max(maxt3, max(effect(t3, m1) * (T - m1), effect(t3, m2) * (T - m2)));
            l = m1;
        }
        else
        {
            maxt3 = max(maxt3, max(effect(t3, m1) * (T - m1), effect(t3, m2) * (T - m2)));
            r = m2;
        }
    }
    cout << fixed << setprecision(20) << max(maxt3, maxt6);
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tt = 1;
    //cin >> tt;
    while (tt--) solve();
    return 0;
}
/*
 4 4
 1 2
 1 3
 2 4
 3 4
 7
 10 2 3 1

 4 4
 1 2
 1 3
 2 4
 3 4
 7
 10 3 3 1
 */