#define _USE_MATH_DEFINES

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <cmath>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <ctime>
#include <numeric>
#include <random>

#define int long long
#define uint unsigned long long
#define double long double

#ifdef DIDEDOSHKA
#define start cout.setf(ios::fixed); cout.precision(10); int START = clock()
#define finish cout << "\ntime: " << (clock() - START) / (double)(CLOCKS_PER_SEC); return 0
#else
#define start cin.tie(NULL); cout.tie(NULL); cout.setf(ios::fixed); cout.precision(10); ios_base::sync_with_stdio(false)
#define finish return 0
#endif

using namespace std;


//vector input
template<typename T>
istream &operator>>(istream &is, vector<T> &vec) {
	for (auto &i : vec) {
		is >> i;
	}
	return is;
}

//vector output
template<typename T>
ostream &operator<<(ostream &os, vector<T> &vec) {
	for (T i : vec) {
		os << i << ' ';
	}
	return os;
}

//2 dimensional vector output
template<typename T>
ostream &operator<<(ostream &os, vector<vector<T>> &vec) {
	for (vector<T> i : vec) {
		os << i << '\n';
	}
	return os;
}

void solve() {
	int n, m;
	cin >> n >> m;
	int k;
	cin >> k;
	if (k > min(n, m)) {
		cout << "Impossible\n";
	} else {
		cout << "Possible\n";
		for (int i = 0; i < n; i++) {
			
				if (k > 0) {
					for (int l = 0; l < k - 1; l++) {
						cout << '.';
					}
					cout << '*';
					for (int l = k; l < m; l++) {
						cout << '.';
					}
					cout << '\n';
					k--;
				} else {
					for (int l = 0; l < m; l++) {
					    cout << '.';
					}
					cout << '\n';
				}
				
			
		}
	}
}

int32_t main() {
	start;
	
	solve();
	
	finish;
}