#define _USE_MATH_DEFINES

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <cmath>
#include <set>
#include <stack>
#include <bitset>
#include <map>
#include <ctime>
#include <numeric>
#include <random>

#define int long long
#define uint unsigned long long
#define double long double

#ifdef DIDEDOSHKA
#define start cout.setf(ios::fixed); cout.precision(10); int START = clock()
#define finish cout << "\ntime: " << (clock() - START) / (double)(CLOCKS_PER_SEC); return 0
#else
#define start cin.tie(NULL); cout.tie(NULL); cout.setf(ios::fixed); cout.precision(10); ios_base::sync_with_stdio(false)
#define finish return 0
#endif

using namespace std;


//vector input
template<typename T>
istream &operator>>(istream &is, vector<T> &vec) {
	for (auto &i : vec) {
		is >> i;
	}
	return is;
}

//vector output
template<typename T>
ostream &operator<<(ostream &os, vector<T> &vec) {
	for (T i : vec) {
		os << i << ' ';
	}
	return os;
}

//2 dimensional vector output
template<typename T>
ostream &operator<<(ostream &os, vector<vector<T>> &vec) {
	for (vector<T> i : vec) {
		os << i << '\n';
	}
	return os;
}

void solve() {
	double ans = 0;
	double X, T;
	cin >> X >> T;
	double type = 0;
	double d = 100 - X;
	double e = 6 / T;
	double f = 2 * X - 100;

//	double vershina;
	for (double i = 0; i < T; i += 0.0001) {
		if (i <= T / 6) {
			if (ans < (T - i) * (X / (T / 6)) * i) {
				ans = (T - i) * (X / (T / 6)) * i;
				type = i;
			}
		} else if (i <= T / 3) {
			if (ans < (T - i) * ((((100 - X) * 6 / T) * i) + (2 * X - 100))) {
//				vershina = i;
//				cout << (d * e * T - f) * vershina - d * e * vershina * vershina + f * T << '\n';
//				cout << (T - i) * ((((100 - X) * 6 / T) * i) + (2 * X - 100)) << '\n';
				ans = (T - i) * ((((100 - X) * 6 / T) * i) + (2 * X - 100));
				type = i;
			}
			
		} else {
			if (ans < (T - i) * 100) {
				ans = (T - i) * 100;
				type = i;
			}
		}
	}
	double maxa = T * X * 5 / 6;
	double maxb;

//	double vershina = (d * e * T - f) / (2 * d * e);
	double vershina = min(T / 3, max(T / 6, T / 2 - (f / (2 * d * e))));
	
//	cout << vershina << '\n';
	
	
	maxb = (d * e * T - f) * vershina - d * e * vershina * vershina + f * T;
//	cout << f * T << '\n';

//	maxb = (T - vershina) * ((((100 - X) * 6 / T) * vershina) + (2 * X - 100));
	
	
	double maxc = (T * 100 * 2 / 3);

//	cout << vershina << '\n';
//	cout << maxa << ' ' << maxb << ' ' << maxc << '\n';

	cout << max({maxa, maxb, maxc}) << '\n';
//	cout << ans << '\n';
//	cout << type << '\n';
}

int32_t main() {
	start;
	
	solve();
	
	finish;
}