#include <unordered_set>
#include <unordered_map>
//#include <ext/rope>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <chrono>
#include <string>
#include <vector>
#include <bitset>
#include <cstdio>
#include <random>
#include <stack>
#include <cmath>
#include <queue>
#include <ctime>
#include <map>
#include <set>

//using namespace __gnu_cxx;
using namespace std;

/*#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")*/

typedef long long ll;   
typedef long double ld;
typedef pair <int, int> ii;
typedef pair <ll, ll> dl;
typedef vector <vector <int> > graph;

#define pb push_back
#define eb emplace_back 
#define ff first
#define ss second
#define show(x) cerr << (#x) << "=" << x << '\n'
#define ptree_node tree_node*
#define sqr(a) ((a) * (a))
#define all(x) (x).begin(), (x).end()
 
const int INF = 1e9;
const ld EPS = 1e-9;
const ld PI = atan2(0.0, -1.0);
const int M = 1e9;
const int MAXN = 2e5 + 1000;

#define fast() ios_base::sync_with_stdio(0); cin.tie(0)

vector<vector<int>> g;
int a[MAXN];
int dp[MAXN];
priority_queue<pair<int, int>> u;

long double x, T;

ld f1(ld t) {
    return (t * x * T - sqr(t) * x) / (T / 6); 
}

ld f2(ld t) {
    return (x + (t - T / 6) / (T / 3 - T / 6) * (100 - x)) * (T - t);
}
int main() {
    fast();
    
    #ifdef _LOCAL
        clock_t Tsart = clock();
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    cin >> x >> T;
    long double ans = 100 * (T - T / 3.0);

    ld l = 0, r = T / 6;
    while (r - l > EPS) {
        ld m1 = l + (r - l) / 3,
            m2 = r - (r - l) / 3;
        if (f1(m1) < f1(m2))
            l = m1;
        else
            r = m2;
    }
    ans = max(f1(l), ans);
    l = T / 6, r = T / 3;
    while (r - l > EPS) {
        ld m1 = l + (r - l) / 3,
            m2 = r - (r - l) / 3;
        if (f2(m1) < f2(m2))
            l = m1;
        else
            r = m2;
    }
    ans = max(f2(l), ans);
    cout << fixed << setprecision(7) << ans << '\n';
    #ifdef _LOCAL
        cerr << "Runtime: " << (ld)(clock() - Tsart) / CLOCKS_PER_SEC << '\n';
    #endif 
    return 0;
}