#include <algorithm>
#include <array>
#include <bitset>
#include <cassert>
#include <cctype>
#include <cmath>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <sstream>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;

#define int long long
#define eb emplace_back
#define pb push_back
#define ld long double
#define f first
#define s second
#define fast() { \
    ios_base::sync_with_stdio(0); \
    cin.tie(0); \
    cout << fixed << setprecision(10); \
    cerr << fixed << setprecision(11); \
}

const int INF = 1e18 + 7;
const ld EPS = 1e-7;
const ld PI = 3.14159265358979323;
const int MOD = 1e9 + 7;
const int MOD1 = 1073676287;
const int P = 789;
const int P1 = 508;
const int MAXN = 2e5;

void solve() {
    long double x, t;
    cin >> x >> t;
    long double res = (t - t / 3) * 100;
    {
        long double hypo = sqrt((t / 6) * (t / 6) + x * x);
        auto f = [&] (long double w) {
            long double k = w / x;
            long double h = hypo * k;
            long double katet = sqrt(h * h - w * w);
            return (t - katet) * w;
        };
        long double l = 0, r = x;
        for (int kok = 0; kok < 100; kok++) {
            long double m1 = l + (r - l) / 3;
            long double m2 = r - (r - l) / 3;
            if (f(m1) > f(m2)) {
                r = m2;
            } else {
                l = m1;
            }
        }
        res = max(res, f(l));
    }
    if (x < 100) {
        long double x_len = t / 3 - t / 6;
        long double hypo = sqrt(x_len * x_len + (100 - x) * (100 - x));
        auto f = [&] (long double w) {
            long double k = (w - x) / (100 - x);
            long double h = hypo * k;
            long double katet = sqrt(h * h - (w - x) * (w - x));
            return (t - katet - t / 6) * w;
        };
        long double l = x, r = 100;
        for (int kok = 0; kok < 100; kok++) {
            long double m1 = l + (r - l) / 3;
            long double m2 = r - (r - l) / 3;
            if (f(m1) > f(m2)) {
                r = m2;
            } else {
                l = m1;
            }
        }
        res = max(res, f(l));
    }


    cout << fixed << setprecision(12) << res;
}

signed main() {
    fast();
    solve();
    return 0;
}
