#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <deque>
#include <algorithm>

using namespace std;

typedef long long ll;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll n, m;
    cin >> n >> m;
    vector<vector<ll>> vec(n);
    for (int i = 0; i < m; i++)
    {
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        vec[x].push_back(y);
        vec[y].push_back(x);
    }
    ll x;
    cin >> x;
    vector<ll> vec2(n);
    for (int i = 0; i < n; i++)
    {
        cin >> vec2[i];
    }
    vector<ll> dlin(n, - 1);
    vector<bool> used(n, false);
    used[0] = true;
    dlin[0] = (x > vec2[0] ? x : x / 2);
    deque<ll> d;
    d.push_back(0);
    while (!d.empty())
    {
        ll now = d.front();
        used[now] = true;
        for (int i = 0; i < vec[now].size(); i++)
        {
            ll to = vec[now][i];
            if (!used[to] || dlin[to] < (dlin[now] > vec2[to] ? dlin[now] : dlin[now] / 2))
            {
                d.push_back(to);
                dlin[to] = max(dlin[to], (dlin[now] > vec2[to] ? dlin[now] : dlin[now] / 2));
            }
        }
        d.pop_front();
        
    }
    cout << dlin[n - 1];
}