#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <queue>
#include <deque>
#include <ctime>
#include <chrono>
#include <random>
#include <bitset>
#include <stack>
#include <cstring>
#define fast cin.tie(0);cout.tie(0);cin.sync_with_stdio(0);cout.sync_with_stdio(0)
#define F first
#define S second
#define pq priority_queue
#define umap unordered_map
#define uset unordered_set
#define pb push_back
#define sqr(x) ((x)*(x))
#define fill(v,n) for(int qqq=0;qqq<n;qqq++)cin>>v[qqq]
#define seed (myclock::now() - beginning).count()
#define mod 1000000007
#define eps 1e-8
#define BIL 1000000000ll
#define INF sqr(2 * BIL)

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ull, ull> pull;
typedef long double ld;
typedef pair<ld, ld> pld;
typedef chrono::high_resolution_clock myclock;

vector<ll> t;

void build(int v, int l, int r, vector<ll> &a) {
	if (l == r) {
		t[v] = a[l];
		return;
	}
	int mid = (l + r) / 2;
	build(v * 2, l, mid, a);
	build(v * 2 + 1, mid + 1, r, a);
	t[v] = min(t[v * 2], t[v * 2 + 1]);
}

ll min(int v, int tl, int tr, int l, int r) {
	if (l > tr || r < tl) return INF;
	if (l <= tl && tr <= r)
		return t[v];
	int mid = (tl + tr) / 2;
	return min(min(v * 2, tl, mid, l, r), min(v * 2 + 1, mid + 1, tr, l, r));
}

int main() {
	int n, m;
	cin >> n >> m;
	t.resize(4 * n);
	vector<vector<ll>> dp(m, vector<ll>(n, INF));
	vector<int> len(m);
	for (int i = 0; i < m; i++) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		for (int j = 0; j < n - r + l; j++)
			dp[i][j] = abs(l - j);
		len[i] = r - l + 1;
	}
	for (int i = 1; i < m; i++) {
		build(1, 0, n - 1, dp[i - 1]);
		for (int j = 0; j < n - len[i] + 1; j++) {
			ll mn = min(1, 0, n - 1, max(0, j - len[i - 1] + 1), j + len[i] - 1);
			dp[i][j] += mn;
		}
	}
	ll ans = INF;
	for (ll i : dp[m - 1])
		ans = min(ans, i);
	cout << ans;
}