#pragma GCC optimization ("O3")
#pragma GCC optimization ("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include <iostream>
#include <cstdlib>
#include <cctype>
#include <functional>
#include <sstream>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <random>
#include <chrono>
#include <iomanip>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <stack>
#include <deque>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using db = long double;
using str = string;

#define SZ(sp) int((sp).size())
#define bgn(sp) (sp).begin()
#define rbgn(sp) (sp).rbegin()
#define all(sp) bgn(sp), (sp).end()
#define rall(sp) rbgn(sp), (sp).rend()
#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define eb emplace_back
#define FOR(i,a,b) for (int i = (a); i < (b); ++i)
#define rFOR(i,a,b) for (int i = (a); i >= (b); --i)
#define debugLine() cout << "\n------------\n";
#define ordered_set tree < pair < int, int >, null_type,less < pair < int, int > >, rb_tree_tag, tree_order_statistics_node_update >
#define indexed_multiset tree < int, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update>
//iterator = find_by_order(k-th); (0...n)
// element = order_of_key(x); number of elements smaller than x

const ll MOD1 = 1e18 + 3;
const ll MOD2 = 1000000123;
const ll INF = 1e13 + 7;
const db EPS = 1e-7;
const db PI = acos((db)-1);
const ll N = 100007;
const ll K = 200007;
const ll P = 53;
mt19937 rng((unsigned int) chrono::steady_clock::now().time_since_epoch().count());

#define int ll

struct mySegmentTree {
    int sz;

    struct Node {
        int val=INF;
    };
    vector < Node > tree;

    void init(int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        tree.assign(2 * sz - 1, Node());
    }

    void build(int n) {
        init(n);
    }

    void updateFromChildren(int x) {
        tree[x].val = min(tree[2 * x + 1].val, tree[2 * x + 2].val);
    }

    void setEl(int pos, int el, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x].val = el;
            return;
        }
        int mid = (lx + rx) / 2;
        if (pos < mid) {
            setEl(pos, el, 2 * x + 1, lx, mid);
        }
        else {
            setEl(pos, el, 2 * x + 2, mid, rx);
        }
        updateFromChildren(x);
    }

    void setEl(int pos, int el) {
        setEl(pos, el, 0, 0, sz);
    }

    int getMin(int l, int r, int x, int lx, int rx) {
        if (l >= rx || r <= lx) {
            return INF;
        }
        if (l <= lx && rx <= r) {
            return tree[x].val;
        }
        int mid = (lx + rx) / 2;
        return min(getMin(l, r, 2 * x + 1, lx, mid), getMin(l, r, 2 * x + 2, mid, rx));
    }

    int getMin(int l, int r) {
        return getMin(l, r, 0, 0, sz);
    }
};

void solve(int cnt_test=0) {
    int n, m;
    cin >> n >> m;
    vector < pair < int, int > > arr(m);
    for (auto &el: arr) {
        cin >> el.fi >> el.se;
        --el.fi;
        --el.se;
    }
    vector < vector < int > > dp(2, vector < int > (n));
    vector < mySegmentTree > tree(2);
    tree[0].build(n);
    tree[1].build(n);
    for (int i = 0; i < n; ++i) {
        if (i + arr[0].se - arr[0].fi >= n) {
            dp[0][i] = INF;
            tree[0].setEl(i, INF);
            continue;
        }
        int res = abs(i - arr[0].fi);
        dp[0][i] = res;
        tree[0].setEl(i, res);
    }
    //for (auto &el: dp[0]) {
     //   cout << el << ' ';
    //}
    //cout << '\n';
    for (int i = 1; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            if (j + arr[i].se - arr[i].fi >= n) {
                dp[1][j] = INF;
                tree[1].setEl(j, INF);
                continue;
            }
            int res = abs(arr[i].fi - j);
            int l = max(0ll, j - (arr[i - 1].se - arr[i - 1].fi + 1) + 1);
            int r = j + (arr[i].se - arr[i].fi + 1) - 1;
            int res2 = tree[0].getMin(l, r + 1);
            if (res2 == INF) {
                while (true) {}
            }
            res += res2;
            dp[1][j] = res;
            tree[1].setEl(j, res);
        }
        dp[0] = dp[1];
        tree[0] = tree[1];
        //for (auto &el: dp[0]) {
        //    cout << el << ' ';
        //}
        //cout << '\n';
    }
    int res = *min_element(all(dp[0]));
    if (res == INF) {
        while (true) {}
    }
    cout << *min_element(all(dp[0]));
    cout << endl;
}

void precalc() {

}

int32_t main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    precalc();
    int tt = 1;
    //cin >> tt;
    for (int cnt_test = 1; cnt_test <= tt; ++cnt_test) {
        //cout << "Case #" << cnt_test << ":" << endl;
        solve(cnt_test);
        //debugLine();
    }
    return 0;
}
