#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <numeric>
#include <bitset>
#include <cassert>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

int n;
int a, b;
int sum = 0;
pair<int, int> tasks[300000];
vector<pair<int, int>> qwe[2];
bool isThr[300000];

void printAns()
{
    cout << sum << endl;
    for(int i = 0; i < n; i++)
    {
        if(isThr[i])
        {
            cout << 'T' << ' ';
        } else {
            cout << 'P' << ' ';
        }
    }
}

void solve() {
    cin >> n >> a >> b;
    for(int i = 0; i < n; i++)
    {
        cin >> tasks[i].first;
    }
    for(int i = 0; i < n; i++)
    {
        cin >> tasks[i].second;
    }
    for(int i = 0; i < n; i++) {
        int t, p;
        t = tasks[i].first;
        p = tasks[i].second;
        if(t > p)
        {
            sum += t;
            qwe[0].push_back(make_pair(t - p, i));
            isThr[i] = true;
        }
        else
        {
            sum += p;
            qwe[1].push_back(make_pair(p - t, i));
        }
    }

    if(qwe[0].size() >= a && qwe[1].size() >= b)
    {
        printAns();
    } else if(qwe[0].size() < a){
        sort(qwe[1].begin(), qwe[1].end());
        int d = a - qwe[0].size();
        for(int i = 0 ; i < d; i++)
        {
            isThr[qwe[1][i].second] = true;
            sum -= qwe[1][i].first;
        }
        printAns();
    }
    else
    {
        sort(qwe[0].begin(), qwe[0].end());
        int d = b - qwe[1].size();
        for(int i = 0 ; i < d; i++)
        {
            isThr[qwe[0][i].second] = false;
            sum -= qwe[0][i].first;
        }
        printAns();
    }
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}