#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#include <numeric>
#include <bitset>
#include <cassert>

using namespace std;

#define en '\n'
#define endl '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)((x).size())

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

ll reverse(ll a) {
    ll res = 0;
    while (a > 0) {
        if (res == 0 && a % 10 == 0) return -1;
        res *= 10;
        res += a % 10;
        a /= 10;
    }
    return res;
}

void solve() {
    ll n, m;
    cin >> n >> m;
    unordered_set<ll> is;
    for (ll i = 1; i * i <= m; ++i) {
        if (i * i < n) continue;
        is.emplace(i * i);
    }
    int cnt = 0;
    for (ll i = 1; i * i <= m; ++i) {
        if (i * i < n) continue;
        ll res = reverse(i * i);
        if (is.count(res)) {
//            cout << i * i << " " << res << '\n';
            ++cnt;
        }
    }
    cout << cnt;
}

int main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}