﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <string>
#include <sstream>
#include <set>
#include <map>
#include <queue>

typedef long long ll;
typedef long double ld;
using num = long long;

using namespace std;

int main() {
    
    num n;
    std:cin >> n;

    std::vector<num> arr(n);
    std::vector<num> pref(n + 1, 0);
    pref[0] = 0;

    std::set<std::pair<num, num>> error;

    for (num i = 1; i <= n; i++)
    {
        num j = i;
        while (error.count({ j, i }))
        {
            j--;
        }
        std::cout << j << ' ' << i << std::endl;
        num s, l, r;
        std::cin >> s >> l >> r;
        error.insert({ l, r });

        num self = s - (pref[i - 1] - pref[j - 1]);
        arr[i - 1] = self;
        pref[i] = pref[i - 1] + arr[i - 1];
    }

    std::cout << "! ";
    for (auto e : arr)
        std::cout << e << ' ';
    std::cout << std::endl;

    return 0;
}
//apugynaqyvi