﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <string>
#include <sstream>
#include <set>
#include <map>
#include <queue>
#include <numeric>
#include <iomanip>

typedef long long ll;
typedef long double ld;
using ll = long long;
using ld = long double;
using num = long long;

using namespace std;

ld f1(ld t, ld x, ld t0)
{
	return (t - t0) * t0 / t * 6 * x;
}

ld f2(ld t, ld x, ld t0)
{
	return (t - t0) * (x + ((t0 - (t / 6)) / t * 6 * (100 - x)));
}

ld f3(ld t, ld x, ld t0)
{
	return (t - t0) * 100;
}

int main() {
	num xx, tt;
	std:cin >> xx >> tt;
	ld t = tt, x = xx;

	ld l1 = 0, r1 = t/6;
	for (num i = 0; i < 100000; i++)
	{
		ld mid = (r1 - l1) / 3;
		ld l0 = l1 + mid, r0 = r1 - mid;

		if (f1(t, x, l0) > f1(t, x, r0))
			r1 = r0;
		else
			l1 = l0;
	}

	ld l2 = t/6, r2 = t / 3;
	for (num i = 0; i < 100000; i++)
	{
		ld mid = (r2 - l2) / 3;
		ld l0 = l2 + mid, r0 = r2 - mid;

		if (f2(t, x, l0) > f2(t, x, r0))
			r2 = r0;
		else
			l2 = l0;
	}

	ld l3 = t / 3, r3 = t;
	for (num i = 0; i < 100000; i++)
	{
		ld mid = (r3 - l3) / 3;
		ld l0 = l3 + mid, r0 = r3 - mid;

		if (f3(t, x, l0) > f3(t, x, r0))
			r3 = r0;
		else
			l3 = l0;
	}

	std::cout << setprecision(18) << std::max({ f1(t, x, l1), f2(t, x, l2), f3(t, x, l3) });
}