#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <set>
#include <queue>
#include <stack>
#include <iomanip>
#include <cstdlib>
#include <fstream>
#include <ctime>
#include <random>

#define int long long

using namespace std;

bool comp(pair<int ,int > a, pair<int ,int> b){
    return a.first < b.first;
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k1, k2;
    cin >> n >> k1 >> k2;
    vector<int> a, b;
    a.resize(n);
    b.resize(n);
    for(int i = 0; i < n; i ++)
        cin >> a[i];
    for(int i = 0; i < n; i ++)
        cin >> b[i];
    vector<pair<int, int> > sum(n);
    for(int i = 0; i < n; i ++){
        sum[i].first = a[i] - b[i];
        sum[i].second = i;
    }
    sort(sum.begin(), sum.end(), comp);
//    for(int i = 0; i < n; i ++)
//        cout << sum[i].first << ' ' << sum[i].second << '\n';

    vector<int> ans(n);
    vector<bool> used(n);
    for(int i = n - 1; i >= n - k1; i --){
        ans[sum[i].second] = 1;
        used[sum[i].second] = 1;
    }
    for(int i = 0; i < k2; i ++){
        ans[sum[i].second] = 2;
        used[sum[i].second] = 1;
    }
    for(int i = 0; i < n; i ++){
        if (used[i])
            continue;
        if (sum[i].first > 0)
            ans[i] = 1;
        else
            ans[i] = 2;
    }
    int ans1 = 0;
    for(int i = 0; i < n; i ++){
        if (ans[i] == 1)
            ans1 += a[i];
        else
            ans1 += b[i];
    }
    cout << ans1 << '\n';
    for(int i = 0; i < n; i ++)
        if (ans[i] == 1)
            cout << 'T' << ' ';
        else
            cout << 'P' << ' ';
    return 0;
}
