#include <bits/stdc++.h>
#define F               first
#define S               second
#define endl            "\n"
#define NO              "NO\n"
#define YES             "YES\n"
#define mp              make_pair
#define pp              pop_back
#define pb              push_back
#define int             long long
#define lb              lower_bound
#define ub              upper_bound
#define sz(x)           int32_t(x.size())
#define all(x)          x.begin(),x.end()
#define rall(x)         x.rbegin(),x.rend()
#define pll             pair<long long,long long>
#define FOR(i,a,b)      for(int i = (a); i <= (b); i++)
#define ROF(i,a,b)      for(int i = (a); i >= (b); i--)
#define IOS             ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)
using namespace std;
const int N = 1e6 + 100;
const int MOD = 1e9+7;
const int INF = 1e10;
long long bp(long long a,long long b){
    long long res = 1;
    while(b > 0){
        if(b&1)res = (res*a)%MOD, b--;
        a = (a*a)%MOD, b >>= 1;
    }
    return res;
}
bool bit(long long x,int p){
    long long y = (1 << p);
    return x&y;
}
long long gcd(long long a,long long b){
    return __gcd(a,b);
}
long long lcm(long long a,long long b){
    return (a*b)/__gcd(a,b);
}
bool prime(int x){
    if(x <= 1)return 0;
    if(x <= 2)return 1;
    if(!(x&1))return 0;
    for(int d = 3; d*d <= x; d += 2){
        if(!(x%d))return 0;
    }
    return 1;
}
int t[N * 4], a[N];

void build(int v, int l, int r){
    if(l != r){
        int mid = (l + r) / 2;
        build(v + v, l, mid);
        build(v + v + 1, mid + 1, r);
        t[v] = min(t[v + v], t[v + v + 1]);
    }
    else{
        t[v] = a[l]; return;
    }
}
void update(int v, int l, int r, int pos, int val){
    if(l != r){
        int mid = (l + r) / 2;
        if(pos <= mid){
            update(v + v, l, mid, pos, val);
        }
        else{
            update(v + v + 1, mid + 1, r, pos, val);
        }
        t[v] = min(t[v + v], t[v + v + 1]);
    }
    else{
        t[v] = val;
    }
}
int getmx(int v, int tl, int tr, int l, int r){
    if(tl > r || tr < l)return 1e10;
    else if(l <= tl && tr <= r) return t[v];
    else{
        int mid = (tl + tr) / 2;
        return min(getmx(v + v, tl, mid, l, r), getmx(v + v + 1, mid + 1, tr, l, r));
    }
}
int n, m, buf[N];
vector <pair <int, int> > v;

void solve(){
    cin >> n >> m;

    for(int i = 1; i <= m; ++i){
        int x, y; cin >> x >> y; v.pb(mp(x, y));
    }

    int cnt = 1;
    for(int i = v[0].F - 1; i >= 1; --i){
        a[i] = cnt; cnt++;
    }
    cnt = 1;
    for(int i = v[0].F + 1; i <= n; ++i){
        a[i] = cnt; cnt++;
    }
    cnt = 1;
    a[0] = INF; a[n + 1] = INF;

    int len = v[0].S - v[0].F + 1;

    for(int i = n - len + 2; i <= n; ++i){
        a[i] = INF;
    }

    build(1, 1, n);

    for(int i = 1; i < sz(v); ++i){
        int len = v[i].S - v[i].F + 1;
        int len2 = v[i - 1].S - v[i - 1].F + 1;
        for(int j = 1; j <= n; ++j) buf[j] = INF;

        for(int j = len2; j <= n - len + 1; ++j){
            int x = abs(j - v[i].F);
            if(j - len2 + 1 < 1 || j + len - 1 > n) continue;
            int y = getmx(1, 1, n, j - len2 + 1, j + len - 1) + x;
            buf[j] = y;
        }

        for(int j = 1; j <= n; ++j){
            update(1, 1, n, j, buf[j]);
        }
    }

    cout << getmx(1, 1, n, 1, n) << "\n";

}

int32_t main(){
    IOS;
    int t = 1; //cin >> t;
    while(t--){
        solve();
    }
}
