#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <math.h>
#include <iomanip>
#include <cassert>
#include <cstring>
#include <map>
#define pb push_back
#define F first
#define S second
#define LL long long
#define Matrix vector <vector <long long>>

using namespace std;

void Ludociel(){
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL); cout.tie(NULL);
    #ifdef Kultivator
        //freopen("W.txt", "r", stdin);
    #endif // Kultivator
}

const int Mx = (int)1e6 + 7;
const int Md = (int)1e9 + 7;
const long long Inf = (long long)1e18 + 7;

int Done(string A){
    int Res = false;
    bool Used = false;
    for(int i = 0; i < A.size(); i++){\
        if(A[i] == 'a' || A[i] == 'e' || A[i] == 'i' || A[i] == 'o' || A[i] == 'u'){
            if(!Used){
                Res++;
                Used = true;
            }
        } else {
            Used = false;
        }
    }
    return Res;
}

int main(){
    Ludociel();
    int n;
    cin >> n;
    string St;
    vector <int> A;
    while(n--){
        cin >> St;
        A.pb(Done(St));
    }
    LL Ans = false;
    for(int i = 0; i < A.size(); i++){
        int sum = false, Phase = 1;
        for(int j = i; j < A.size(); j++){
            if(Phase == 1){
                sum += A[j];
                if(sum > 5) break;
                if(sum == 5){
                    sum = false;
                    Phase = 2;
                }
            } else if(Phase == 2){
                sum += A[j];
                if(sum > 7) break;
                if(sum == 7){
                    sum = false;
                    Phase = 3;
                }
            } else {
                sum += A[j];
                if(sum > 5) break;
                if(sum == 5){
                    Ans++;
                    break;
                }
            }
        }
    }
    cout << Ans << '\n';
}
