#include<iostream>
#include<bits/stdc++.h>
#include <vector>
#include <string>
#include <memory.h>
#include <iomanip>
#include <deque>
#include <queue>
#include <stack>
#include <iterator>
#include <sstream>
#define int long long
#define endl "\n"
#define F first
#define S second
using namespace std;

bool cmp(pair<int, int> a, pair<int, int> b) {
    return a.F > b.F;
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;

	vector<vector<int>> gr(n + 1);
	vector<bool> used(n + 1);

	for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        gr[u].push_back(v);
        gr[v].push_back(u);
	}
	gr[0] = {1};
	gr[1].push_back(0);
	vector<int> a(n + 1), dist(n + 1, 0);

	int x;
	cin >> x;

	for (int i = 0; i < n; i++) {
        cin >> a[i + 1];
	}

	set<pair<int, int>, decltype(&cmp)> q(cmp);
	q.insert({x, 0});
	dist[0] = x;

	while (!q.empty()) {
        int v = q.begin()->S;
        q.erase(q.begin());

        for (auto u : gr[v]) {
            if (a[u] < dist[v] and dist[v] > dist[u]) {
                q.erase({dist[u], u});
                dist[u] = dist[v];
                q.insert({dist[u], u});
            }
            else if (a[u] >= dist[v] and dist[v] / 2 > dist[u]) {
                q.erase({dist[u], u});
                dist[u] = dist[v] / 2;
                q.insert({dist[u], u});
            }
        }
	}
	cout << dist[n];

	return 0;
}
