#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <math.h>
#include <climits>
#include <queue>
#include <algorithm>
#include <assert.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = INT_MAX;

bool cmp(const pair<ll, int> &a, const pair<ll, int> &b)
{
    if (a.first < b.first)
        return true;
    if (a.first > b.first)
        return false;
    return a.second < b.second;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(18);
#ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif

    int n, a, b;
    cin >> n >> a >> b;

    vector<int> x(n);
    vector<int> y(n);
    vector<char> ans(n, 'T');

    for (int i = 0; i < n; i++)
        cin >> x[i];
    for (int i = 0; i < n; i++)
        cin >> y[i];
    
    int cnt_dick = n;

    vector<pair<ll, int>> diff(n);

    ll s = 0;
    for (int i = 0; i < n; i++)
    {
        s += x[i];
        diff[i] = {y[i] - x[i], i};
    }
    sort(diff.begin(), diff.end(), cmp);
    reverse(diff.begin(), diff.end());

    for (int i = 0; i < b; i++) {
        cnt_dick--;
        s += diff[i].first;
        ans[diff[i].second] = 'P';
    }

    for (int i = b; i < n; i++) {
        if (cnt_dick == a) break;
        if (diff[i].first > 0) {
            cnt_dick--;
            s += diff[i].first;
            ans[diff[i].second] = 'P';
        }
    }

    cout << s << '\n';
    for (auto e: ans) {
        cout << e << ' ';
    }
    cout << '\n';
}