#include <bits/stdc++.h>
//#include <bits/extc++.h>
//#include <tr2/dynamic_bitset>

#define int int64_t
//#define double long double

using namespace std;
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;
//
//template<typename T>
//using orset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//
//template<typename T>
//using ormset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

constexpr int N = 1e5;
constexpr int mod = 1e9 + 7;

int bin_pow (int x, int y) {
    if (y == 0)
        return 1;
    if (y & 1)
        return bin_pow(x, y - 1) * x;
    int z = bin_pow(x, y>>1);
    return z * z;
}

int pow_mod (int x, int y) {
    if (y == 0)
        return 1;
    if (y & 1)
        return bin_pow(x, y - 1) * x % mod;
    int z = bin_pow(x, y>>1);
    return z * z % mod;
}

int divide(int x, int y) {
    return x * bin_pow(y, mod - 2) % mod;
}

void input () {

}

/*template<typename T>
T j_ans () {

}

template<typename T>
T p_ans () {

}

bool check () {
    return j_ans() == p_ans();
}*/

int t[4 * N + 4];

void build(int v, int tl, int tr, vector<int> &a) {
    if (tl == tr) {
        t[v] = a[tl];
        return;
    }
    int tm = (tl + tr)>>1;
    build(v<<1, tl, tm, a);
    build(v<<1|1, tm + 1, tr, a);
    t[v] = min(t[v<<1], t[v<<1|1]);
}

int get (int v, int tl, int tr, int l, int r) {
    if (l > r)
        return LLONG_MAX;
    if (l == tl && r == tr)
        return t[v];
    int tm = (tl + tr)>>1;
    return min(get (v<<1, tl, tm, l, min(r, tm)), get (v<<1|1, tm + 1, tr, max(tm + 1, l), r));
}

int32_t main () {
    cout.precision(9);
    cout.setf(ios::fixed);
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> v(m);
    for (auto &i: v) {
        cin >> i.first >> i.second;
        i.first--, i.second--;
    }
    vector<vector<int>> dp(m, vector<int>(n, LLONG_MAX));
    for (int i = 0; i + (v[0].second - v[0].first) < n; i++) {
        dp[0][i] = abs(v[0].first - i);
}
    for (int i = 1; i < m; i++) {//
        build(1, 0, n - 1, dp[i - 1]);
        for (int j = 0; j + (v[i].second - v[i].first) < n; j++) {
            dp[i][j] = abs(v[i].first - j);
            int l = max(0LL, j - (v[i - 1].second - v[i - 1].first));
            int r = min(n - 1, j + (v[i].second - v[i].first));
            dp[i][j] += get(1, 0, n - 1, l, r);
        }
    }

//    for (int i = 0; i < m; i++) {
//        for (int j = 0; j < n; j++)
//            cout << dp[i][j] << ' ';
//        cout << '\n';
//    }

    int ans = LLONG_MAX;
    for (int i = 0; i < n; i++)
        ans = min(ans, dp[m - 1][i]);
    cout << ans;
}