#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <utility>
#include <sstream>
#include <numeric>
#include <algorithm>
#include <cmath>
#include <vector>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <complex>
#include <cassert>
#include <memory>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve() {

    int n;
    cin >> n;
    vector<double> s(n), v(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i] >> v[i];
    }
    int realans = min(n, 2);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int ans = 2;
            map<double, int> val;
            int maxval = 0;
            for (int q = j + 1; q < n; ++q) {
                double k = (q - i) * (v[j] - v[i]) + (i - j) * (v[q] - v[i]);
                double b = (j - i) * (s[q] - s[i]) + (i - q) * (s[j] - s[i]);
                if (k == 0) {
                    if (b == 0) {
                        ++ans;
                    }
                }
                else {
                    maxval=max(maxval, ++val[b / k]);
                }
            }
            realans = max(realans, ans + maxval);
        }
    }
    cout << realans << "\n";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
    t = 1;
    while (t--) {
        solve();
    }

    return 0;
}