#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 1e6 + 3e2;

typedef long double ld;

ld linear(ld l, ld r, ld x, ld val1, ld val2){
    x -= l;
    r -= l;

    ld val = val1 + (val2 - val1) * x / r;
    return val;
}

ld T, X;
ld ff(ld sleep){
    if (3 * sleep >= T) return 100;
    if (6 * sleep == T) return X;
    if (sleep == 0) return 0;
    if (T <= 6 * sleep && 6 * sleep <= 2 * T){
        return linear(T / 6, T / 3, sleep, X, 100);
    } else {
        return linear(0, T / 6, sleep, 0, X);
    }
}

ld f(ld sleep){
    return (T - sleep) * ff(sleep);
}

void solve(){
    cin >> X >> T;

    ld ans = max({f(0), f(T / 3), f(T / 6), f(T)});

    ld l = 0, r = T / 6;
    for (int it = 0; it < 1000; it++){
        ld m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
        ld f1 = f(m1), f2 = f(m2);
        ans = max(ans, max(f1, f2));
        if (f1 > f2){
            r = m2;
        } else l = m1;
    }

    l = T / 6, r = T / 3;
    for (int it = 0; it < 1000; it++){
        ld m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
        ld f1 = f(m1), f2 = f(m2);
        ans = max(ans, max(f1, f2));
        if (f1 > f2){
            r = m2;
        } else l = m1;
    }

    l = T / 3, r = T;
    for (int it = 0; it < 1000; it++){
        ld m1 = l + (r - l) / 3, m2 = r - (r - l) / 3;
        ld f1 = f(m1), f2 = f(m2);
        ans = max(ans, max(f1, f2));
        if (f1 > f2){
            r = m2;
        } else l = m1;
    }

    cout << fixed << setprecision(8) << ans;

}

int main(){
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int TC = 1;
    //cin >> TC;

    for (int tt = 1; tt <= TC; tt++){
        solve();
    }

    return 0;
}
