#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

#define f first
#define s second
#define all(x) x.begin(); x.end()
#define sz(x) (int)(x).size()
#define pb push_back()
#define mp make_pair

const int maxn = 1e6 + 7;
const ll inf = 1e18;

ll dp[maxn], t[maxn * 4];
int l[maxn], r[maxn];

void upd(int v, int tl, int tr, int pos, ll val){
	if(tl == tr){
		t[v] = val;
		return;
	}
	int tm = tl + tr >> 1;
	if(pos <= tm)
		upd(v + v, tl, tm, pos, val);
	else
		upd(v + v + 1, tm + 1, tr, pos, val);
	t[v] = min(t[v + v], t[v + v + 1]);
}

ll get(int v, int tl, int tr, int l, int r){
	if(tl > r || tr < l)
		return inf;
	if(l <= tl && tr <= r)
		return t[v];
	int tm = tl + tr >> 1;
	return min(get(v + v, tl, tm, l, r), get(v + v + 1, tm + 1, tr, l, r));
}

void solve(){
	int n, m;
	cin >> n >> m;	
	for(int i = 1; i <= m; i++){
		cin >> l[i] >> r[i];
	}
	int len = r[1] - l[1] + 1;
	for(int i = len; i <= n; i++){
		dp[i] = abs(r[1] - i);	
	}
	for(int i = 1; i < len; i++)
		dp[i] = inf;
	for(int i = 1; i <= n; i++)
		upd(1, 1, n, i, dp[i]);
	for(int i = 2; i <= m; i++){
		int len = r[i - 1] - l[i - 1];
		for(int j = 1 + r[i] - l[i]; j <= n; j++){
			int L = max(1 + len, j - r[i] + l[i]), R = min(j + len, n);
			dp[j] = get(1, 1, n, L, R) + abs(r[i] - j);
		}
		for(int j = 1 + r[i] - l[i]; j <= n; j++)
			upd(1, 1, n, j, dp[j]);
		for(int j = 1; j <= r[i] - l[i]; j++)
			upd(1, 1, n, j, inf);
	}
	cout << get(1, 1, n, 1, n);
}

int main(){
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t = 1;
	//cin >> t;
	while(t--){
		solve();
	}
	return 0;
}