import kotlin.math.absoluteValue
import kotlin.math.roundToLong
import kotlin.math.sqrt

const val ONLINE_JUDGE = true //I'm not sure if it exists

fun main() {
    if (!ONLINE_JUDGE) {
        System.setIn(
            (
                    "77 123"
                    ).byteInputStream()
        )
    }

    solveK()
}

//fun solveJ(){
//    val s = long().toDouble()
//    val e = long().toDouble()
//    val ans = mutableListOf<String>()
//    for (i in sqrt(s).roundToLong()..sqrt(e).roundToLong()+1) {
//        val str = (i*i).toString()
//        if (str.last() == '0') continue
//        val rts = str.reversed().toDouble()
//        var sqrtrqs = sqrt(rts)
//        if (sqrtrqs % 1 < 0.00000001 || sqrtrqs % 1 > 0.99999999) sqrtrqs = sqrtrqs.roundToLong()
//        else continue
//        if (str == (sqrtrqs*sqrtrqs).toString().reverse()) ans.add(str)
//    }
//}

fun solveK() {
    val (x, t) = intArr()
    val varA = 5 * t * x * 1.0 / 6

    val crestB = (700 - 8 * x) * t / 12.0 / (100 - x) //T of crest
    val crestSuit = ((700 - 8 * x) * t) in (t * 2 * (100 - x))..(t * 4 * (100 - x))

    val varBCrest = ((100 - x) * 6.0 / t * crestB + 2 * x - 100) * (t - crestB)

    val varC = 2 * t * 1.0 / 3 * 100

    if (crestSuit) println(maxOf(varA, varBCrest, varC))
    else println(maxOf(varA, varC))
}

fun solveJ() {
    val l = long()
    val r = long()
    var res = 0
    for (i in (sqrt(l.toDouble()).roundToLong() - 3)..(sqrt(r.toDouble()).roundToLong() + 3)) {
        if (i <= 0) continue
        if (i * i !in l..r) continue //To avoid calculation errors...

        if (i % 10 == 0L) continue //To avoid trailing zeros

        val another = (i * i).toString().reversed().toLong()
        val end = another % 10

        val j = sqrt(another + .0).roundToLong()
        if (((j - 1)..(j + 1)).any { it * it == another }) res++
    }

    println(res)
}

fun solveH() {
    var (a, b) = longArr()
    val res = mutableListOf<Pair<Int, Long>>()

    fun apply1(k: Long) {
        res.add(1 to k)
        a += k * b
    }

    fun apply2(k: Long) {
        res.add(2 to k)
        b += k * a
    }

    while (a != 0L && b != 0L) {
        if (a.absoluteValue < b.absoluteValue) {
            val k = divide(b.absoluteValue, a.absoluteValue)
            when {
                a < 0 && b < 0 -> apply2(-k)
                a < 0 && b > 0 -> apply2(k)
                a > 0 && b < 0 -> apply2(k)
                a > 0 && b > 0 -> apply2(-k)
            }
        } else {
            val k = divide(a.absoluteValue, b.absoluteValue)
            when {
                a < 0 && b < 0 -> apply1(-k)
                a < 0 && b > 0 -> apply1(k)
                a > 0 && b < 0 -> apply1(k)
                a > 0 && b > 0 -> apply1(-k)
            }
        }
    }

    println(res.size)
    for (pair in res) println("" + pair.first + " " + pair.second)
}

//Assuming a & b are positive
fun divide(a: Long, b: Long): Long = if (a % b == 0L) a / b else (a.toDouble() / b).roundToLong()

fun solveE() {
    val n = int()

    fun String.countUnits(): Int {
        var units = 0
        var vowels = -1
        for (c in toCharArray())
            if (c == 'a' || c == 'i' || c == 'o' || c == 'u' || c == 'e') {
                vowels++
            } else {
                if (vowels != -1) units++
                vowels = -1
            }
        if (vowels != -1) units++
        return units
    }

    val words = List(n) { line().countUnits() }

    var haikus = 0

    out@ for (pivot0 in words.indices) {
        var len = 0
        var pivot1 = 0
        for (j in pivot0 until pivot0 + 5) {
            if (j !in words.indices) continue@out
            pivot1 = j

            len += words[j]
            if (len > 5) continue@out
            if (len == 5) break
        }
        len = 0
        var pivot2 = 0
        for (j in pivot1 + 1 until pivot1 + 8) {
            if (j !in words.indices) continue@out
            pivot2 = j

            len += words[j]
            if (len > 7) continue@out
            if (len == 7) break
        }
        len = 0
        for (j in pivot2 + 1 until pivot2 + 6) {
            if (j !in words.indices) continue@out
            len += words[j]
            if (len > 5) continue@out
            if (len == 5) break
        }
        haikus++
    }

    println(haikus)

//    val s = words.size
//    val fth = mutableListOf<List<Int>>()
//    val sth = mutableListOf<List<Int>>()
//
//    for (i in words.indices) {
//        for (l in i..i + 4) {
//            if (l !in words.indices) break
//            val s = words.subList(i, l).sumOf { it }
//            if (s == 5) fth.add(listOf(i, l))
//            if (s > 5) break
//        }
//        for (l in i..i + 6) {
//            if (l !in words.indices) break
//            val s = words.subList(i, l).sumOf { it }
//            if (s == 7) sth.add(listOf(i, l))
//            if (s > 7) break
//        }
//    }
//    var fi = 0
//    var si = 0
//    var fil = 0
//    var haikus = 0
//    while (fi != fth.lastIndex) {
//        while (si < sth.lastIndex && sth[si][0] < fth[fi][1]) si += 1
//        while (fil < fth.lastIndex && fth[fil][0] < sth[si][1]) fil += 1
//        if (sth[si][0] == fth[fi][1] && fth[fil][0] == sth[si][1]) haikus += 1
//        fi += 1
//    }
//
//    println(haikus)
}

fun solveD() {
    val (v, e) = intArr()
    val neighbors = List(v) { mutableListOf<Int>() }
    repeat(e) {
        val (a, b) = intArr()
        neighbors[a - 1].add(b - 1)
        neighbors[b - 1].add(a - 1)
    }

    val x = int()
    val droids = intArr()

    val cameWith = IntArray(v)
    cameWith[0] = if (x > droids[0]) x else x / 2

    fun dfs(i: Int) {
        val was = cameWith[i]
        for (nei in neighbors[i]) {
            val became = if (was > droids[nei]) was else was / 2
            if (became > cameWith[nei]) {
                cameWith[nei] = became
                if (i != v - 1) dfs(nei)
            }
        }
    }

    dfs(0)
    println(cameWith.last())
}

fun solveB() {
    val n = int()
    val arr = MutableList<Long?>(n) { null }
    val banned = List(n) { mutableListOf<Int>() }

    var index = 0
    val pref = mutableListOf<Long>(0)
    while (index != n) {
        for (i in 0..index) {
            if (index in banned[i]) continue
            println("? ${i + 1} ${index + 1}")
            val slbrb = longArr()
            val s = slbrb[0]
            val lb = slbrb[1].toInt()
            val rb = slbrb[2].toInt()
            arr[index] = s - (pref[index] - pref[i])
            banned[lb - 1].add(rb - 1)
            banned[rb - 1].add(lb - 1)
            pref.add(pref.last() + arr[index]!!)
            break
        }
        index += 1
    }
    println("!")
    println(arr.joinToString(" "))

}

fun solveA() {
    val (r, c, n) = intArr()
    if (n > r || n > c) return println("Impossible")
    println("Possible")
    val line = ".".repeat(c)
    if (r < c) {
        for (i in 0 until n) println(".".repeat(i) + "*" + ".".repeat(c - i - 1))
    } else {
        for (i in 0 until n) println(".".repeat(i) + "*" + ".".repeat(c - i - 1))
    }
    repeat(r - n) { println(line) }
}

fun line() = readLine()!!
fun int() = readLine()!!.trim().toInt()
fun long() = readLine()!!.trim().toLong()
fun intArr() = readLine()!!.trim().split(" ").mapNotNullTo(mutableListOf()) { if (it == "") null else it.toInt() }
fun longArr() = readLine()!!.trim().split(" ").mapNotNullTo(mutableListOf()) { if (it == "") null else it.toLong() }
fun intArr2(rows: Int) = List(rows) { intArr() }