#include <bits/stdc++.h>

using namespace std;

#define pos first
#define S second
#define pb push_back
#define pushf push_front
#define popb pop_back
#define popf pop_front
#define vec vector
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef map<ll, ll> mll;
typedef map<string, string> msl;

const ll inf = 1e18;
const ll maxn = 1e4;
const ll mod = 1e9 + 7;
const ll P = 239;
const ld PI = acos(-1);
const double eps = 1e-8;
ll m, k, n;
char ch;
bool ok = true;

typedef long long T;
#define Point Vector


struct Vector {
    T x, y;

    Vector() {
        x = 0;
        y = 0;
    }

    Vector(T new_x, T new_y) {
        x = new_x;
        y = new_y;
    }

    Vector operator+(const Vector &a) const {
        return Vector(x + a.x, y + a.y);
    }

    Vector operator-(const Vector &a) const {
        return Vector(x - a.x, y - a.y);
    }

    Vector operator-() const {
        return Vector(-x, -y);
    }

    Vector operator*(const ll &k) const {
        return Vector(x * k, y * k);
    }

    Vector operator/(const ll &k) const {
        return Vector(x / k, y / k);
    }

    T operator*(const Vector &a) const {
        return x * a.x + y * a.y;
    }

    T operator%(const Vector &a) const {
        return x * a.y - y * a.x;
    }

    T lenSqr() const {
        return x * x + y * y;
    }

    ld len() const {
        return sqrt(lenSqr());
    }

    Vector(const Vector &a, const Vector &b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }

    bool belong_corner(Point &a, Point &d, Point &b) const { // c belongs to corner adb
        Vector da(d, a), db(d, b), dc(d, *this);
        return ((da % dc) * (dc % db) >= 0 && (da % dc) * (da % db) >= 0);
    }

    bool belong_segment(Point &a, Point &b) const {// c belongs to segment ab
        Vector ab(a, b), ac(a, *this);
        Vector cb(*this, b), ca(*this, a);
        return ((ab % ac) == 0 && (cb * ca) <= 0);
    }

    bool belong_line(Point &b, Point &c) const {
        Vector ab(*this, b), ac(*this, c);
        return (ab % ac) == 0;
    }

    bool belong_beam(Point &a, Point &b) const {
        Vector ac(a, *this), ab(a, b);
        return ((ab % ac) == 0 && (ab * ac) >= 0);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("point2.in", "r", stdin);
    //freopen("point2.out", "w", stdout);
    cout << fixed << setprecision(12);
    Point a, b, c, d;
    cin >> n;
    vec<Point> z(n);
    vec<ll> v(n);
    for (ll i = 0; i < n; ++i) {
        cin >> z[i].x >> v[i];
        z[i].y = i;
    }
    ll ans = 0;
    for (ll t = 0; t <= 100000; ++t) {
        for (ll i = 0; i < n; ++i) {
            for (ll j = i + 1; j < n; ++j) {
                ll cnt = 2;
                for (ll k = j + 1; k < n; ++k) {
                    Vector a(z[i].x + v[i] * t, z[i].y);
                    Vector b(z[j].x + v[j] * t, z[j].y);
                    Vector c(z[k].x + v[k] * t, z[k].y);
                    if (a.belong_line(b, c)) cnt++;
                }
                ans = max(ans, cnt);
            }
        }
    }
    cout << ans;
    return 0;
}
