#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;


#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>

using namespace __gnu_pbds;
/*
#include <ext/pb_ds/tree_policy.hpp>
typedef tree<
        int,
        null_type,
        less<int>,
        rb_tree_tag,
        tree_order_statistics_node_update> ordered_set;
*/

//#define int ll

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

#define ff first
#define ss second
#define mp make_pair
#define pf push_front
#define pb push_back
#define IO ios_base::sync_with_stdio(false); cin.tie(NULL);
#define print(x) { for (auto __val : (x)) cout << __val << ' '; cout << '\n'; }
#define printp(x) { for (auto __val : (x)) cout << "{" << __val.ff << ", " << __val.ss << "} "; cout << '\n'; }
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const ll mod = 1e9 + 7, mod2 = 1e9 + 9, mod3 = 998244353;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int random(int l, int r) { return uniform_int_distribution<int>(l, r)(rng); }

struct segment_tree {
    vector<int> mins;
    int n;

    segment_tree(int n) : n(n), mins(2 * n, 1e9) {}

    int get(int l, int r) {
        int mn = 1e9;
        for (l += n, r += n; l < r; l /= 2, r /= 2) {
            if (l & 1) mn = min(mn, mins[l++]);
            if (r & 1) mn = min(mn, mins[--r]);
        }
        return mn;
    }

    void set(int i, int x) {
        mins[i += n] = x;
        while (i > 0) {
            i /= 2;
            mins[i] = min(mins[2 * i], mins[2 * i + 1]);
        }
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> s(m), t(m);
    for (int i = 0; i < m; ++i) {
        cin >> s[i] >> t[i];
        --s[i];
    }
    vector<segment_tree> dp(m + 1, segment_tree(n));
    for (int i = 0; i < n; ++i) dp[0].set(i, 0);
    for (int j = 0; j < m; ++j) {
        for (int i = 0; i + t[j] - s[j] <= n; ++i) {
            int low = (j ? max(i - t[j - 1] + s[j - 1] + 1, 0) : 0);
            int high = (j ? max(i + t[j - 1] - s[j - 1], n) : n);
            dp[j + 1].set(i, abs(i - s[j]) + dp[j].get(low, high));
        }
    }
    cout << dp.back().get(0, n) << '\n';
}

/*

*/
signed main() {
    IO
    //freopen(".in" , "r" , stdin); freopen(".out" , "w" , stdout);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}