#include <algorithm>
#include <cmath>
#include <iostream>
#include <set>
#include <string>
#include <vector>

using namespace std;
using ll = long long;

int main() {
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);

  int n;
  cin >> n;
  vector<int> a(n), b(n);
  for (int i = 0; i < n; i++)
    cin >> a[i];
  for (int i = 0; i < n; i++)
    cin >> b[i];

  int f = a[0], cnt = 0;
  vector<int> d(n);
  d[0] = 1;

  for (int i = 1; i < n; i++) {
    int z1 = f ^ a[i];
    int z2 = f ^ b[i];
    if (z1 >= z2) {
      d[i] = 1;
      f = z1;
    } else {
      d[i] = 2;
      f = z2;
      cnt++;
    }
  }
  for (int i = 0; i < n; i++) {
    if (d[i] == 2) {
      swap(a[i], b[i]);
    }
  }
  int s1 = a[0], s2 = b[0];
  for (int i = 1; i < n; i++) {
    s1 ^= a[i];
  }
  for (int i = 1; i < n; i++) {
    s2 ^= b[i];
  }
  cout << s1 + s2 << " " << cnt << "\n";
  for (int i = 0; i < n; i++) {
    if (d[i] == 2) {
      cout << i + 1 << " ";
    }
  }
}