#include <algorithm>
#include <cmath>
#include <iostream>

using namespace std;
using ll = unsigned long long;

int main() {
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);

  ll a, b;
  cin >> a >> b;

  ll cnt = 0;
  for (ll i = (ll)sqrt(a); i <= (ll)sqrt(b); i++) {
    ll n = i * i;
    if (n % 10 == 0)
      continue;

    ll n1 = 0;
    while (n > 0) {
      n1 = n1 * 10 + n % 10;
      n /= 10;
    }

    ll sq = (ll)sqrt(n1);
    cnt += sq * sq == n1;
  }

  cout << cnt;
}