#include <algorithm>
#include <cmath>
#include <string>
#include <iostream>
#include <vector>

using namespace std;
using ll = unsigned long long;

int main() {
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);

  ll a, b;
  cin >> a >> b;

  vector<ll> memo;
  ll i = 1;
  while (i * i <= 1e11) {
    memo.push_back(i * i);
    i++;
  }

  ll cnt = 0;
  for (ll j = sqrt(a); j <= sqrt(b); j++) {
    ll s = j * j;

    string sr = to_string(s);
    ll sl = sr.length();

    if (sr[sl - 1] == '0')
      continue;
    reverse(sr.begin(), sr.end());

    ll s1 = stoi(sr);
    cnt += (find(memo.begin(), memo.end(), s1) != memo.end());
  }

  cout << cnt;
}