#include <algorithm>
#include <cmath>
#include <iostream>

using namespace std;
using ll = long long;

int main() {
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);

  ll a, b;
  cin >> a >> b;

  // floor - вниз, ceil - вверх
  ll lower = floor(sqrt(a));
  ll upper = ceil(sqrt(b));

  int ans = 0;
  for (ll i = lower; i <= upper; i++) {
    ll curr = i * i;
    if (curr < a || curr > b || curr % 10 == 0)
      continue;

    ll reversed = 0;
    while (curr > 0) {
      reversed = reversed * 10 + curr % 10;
      curr /= 10;
    }

    if (reversed < a || reversed > b)
      continue;

    ll root = static_cast<ll>(sqrt(reversed));
    ans += (root * root == reversed);
  }

  cout << ans;
}