﻿#include <iostream>
#include <map>
#include <vector>
#include <fstream>
#include <set>
#include <algorithm>
#include <iomanip>
#include <string>
#include <deque>
#include <math.h>
using namespace std;
#define int long long
typedef pair <int, int> ii;
typedef vector <int> vi;
typedef vector <ii> vii;
typedef vector<int> veci;
#define $ '\n'
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
inline void solve1();
typedef long double ld;

template <class T> istream& operator >> (istream& is, vector<T>& x) {
	for (T& i : x) is >> i;
	return is;
}
template <class T> ostream& operator << (ostream& o, const vector<T>& x) {
	for (T e : x) o << e << ' ';
	return o;
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t = 1;
	// cin >> t;
	solve1();
	cout.flush();

	return 0;
}

int INF = 2e9;

vi s;
vi l;

int f(int i, int j)
{
	return abs(s[i] - j);
}

inline void solve1() {
	int n, m;
	cin >> n >> m;
	swap(n, m);
	s.resize(n);
	l.resize(n);
	
	for (int i = 0; i < n; i++)
	{
		int s1, t;
		cin >> s1 >> t;
		s[i] = s1 - 1;
		l[i] = t - s1 + 1;
	}
	vector <vi> dp(n + 1, vi(m + 1, INF));

	for (int i = 0; i + l[0] <= m; i++)
	{
		dp[0][i] = f(0, i);
	}
	for (int i = 1; i < n; i++)
	{
		multiset <int> ms;
		for (int j = 0; j < l[i] - 1; j++)
		{
			ms.insert(dp[i - 1][j]);
		}
		for (int j = 0; j + l[i] <= m; j++)
		{
			ms.insert(dp[i - 1][j + l[i] - 1]);
			if (j - l[i - 1] >= 0)
			{
				ms.erase(ms.find(dp[i - 1][j - l[i - 1]]));
			}
			dp[i][j] = *(ms.begin()) + f(i, j);
		}
	}
	int ans = INF;
	for (auto i : dp[n - 1])
		ans = min(ans, i);
	

	cout << ans << endl;
	return;

}