﻿#include <iostream>
#include <map>
#include <vector>
#include <fstream>
#include <set>
#include <algorithm>
#include <iomanip>
#include <string>
#include <deque>
#include <math.h>
using namespace std;
#define int long long
typedef pair <int, int> ii;
typedef vector <int> vi;
typedef vector <ii> vii;
typedef vector<int> veci;
#define $ '\n'
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
inline void solve1();
inline void solve();
typedef long double ld;

template <class T> istream& operator >> (istream& is, vector<T>& x) {
	for (T& i : x) is >> i;
	return is;
}
template <class T> ostream& operator << (ostream& o, const vector<T>& x) {
	for (T e : x) o << e << ' ';
	return o;
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t = 1;
	// cin >> t;
	solve();
	cout.flush();

	return 0;
}


inline void solve1() {
	int n; cin >> n;
	veci s(n), v(n);
	for (int i = 0; i < n; i++) cin >> s[i] >> v[i];
	for (int a = 0; a < n; a++)
		for (int b = 0; b < n; b++)
			for (int i = 0; i < n; i++) {
				if (a == i || b == i) continue;

			}
}

struct cmp
{
	bool operator() (const ii& a, const ii& b) const
	{
		if (a.first == b.first)
			return a.second < b.second;
		return a.first > b.first;
	}
};

inline void solve()
{
	int n, m;
	cin >> n >> m;
	vector <vi> g(n);
	for (int i = 0; i < m; i++)
	{
		int a, b;
		cin >> a >> b;
		g[a - 1].push_back(b - 1);
		g[b - 1].push_back(a - 1);
	}
	int x;
	cin >> x;

	vi a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	if (a[0] >= x)
		x /= 2;
	vi d(n);
	d[0] = x;
	set <ii, cmp> s;
	s.insert({ x, 0 });
	vi used(n);

	while (!s.empty())
	{
		auto p = *(s.begin());
		s.erase(s.begin());
		int v = p.second;
		int val = p.first;
		if (used[v])
			continue;
		d[v] = val;
		used[v] = true;
		for (auto j : g[v])
		{
			if (used[j])
				continue;
			if (a[j] >= val)
			{
				s.insert({ val / 2, j });
			}
			else
			{
				s.insert({ val, j });
			}
		}
	}
	cout << d[n - 1] << endl;


	return;
}