﻿#pragma GCC target ("avx2")

#include <iostream>
#include <vector>
#include <list>
#include<algorithm>
#include<iterator>
#include<string>
#include<set>
#include <iomanip>
using namespace std;
long double t, x;
long double f(long double y) {
	return ((6 * y - t) * (100 - x) / t + x) * (t - y);
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> x >> t;
	cout << fixed << setprecision(20);
	if (x == 100) {
		cout << 500 * t / 6;
		return 0;
	}
	long double R = t / 3;
	long double L = t / 6;
	while (R - L > 0.00000001) {
		long double m1 = L + (R - L) / 3;
		long double m2 = R - (R - L) / 3;
		if (f(m1) < f(m2)) {
			L = m1;
		}
		else {
			R = m2;
		}
	}
	cout << max(5 * x * t / 6, f(L));
}