#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <utility>
#include <cmath>
#include <cstdlib>
#include <string>
using namespace std;

#define ins insert
#define int long long
#define VI vector<int>
#define VVI vector<VI>
#define foriab(i, a, b) for(int i=(a);i<(b);++i)
#define fori(i, n) foriab(i, 0, n)
#define foris(i, n) foriab(i, 0, n.sz())
#define sz size
#define PAR pair<int,int>
#define pb push_back
#define VSI vector<SI>
#define SI set<int>
#define SP set<PAR>
#define SV set<VI>
#define x first
#define y second
#define VPII vector<PII>
#define PII pair<int, int>



bool rmin(int& a, int b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<class T>
bool rmax(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<class T, class Y> ostream& operator<<(ostream& out, const pair<T, Y>& v) {
	return out<<v.x<<' '<<v.y<<endl;
}
template<class T, class Y> istream& operator>>(istream& input, pair<T, Y>& v) {
	input>>v.x;
	input>>v.y;
	return input;
}

template<class T> istream& operator>>(istream& input, vector<T>& v) {
	for (int i = 0; i < v.size(); ++i) {
		input >> v[i];
	}
	return input;
}
template<class T> ostream& operator<<(ostream& output, const vector<T>& v) {
	for (int i = 0; i < v.size(); ++i) {
		output << v[i] << ' ';
	}
	return output;
}

template<class T> T mabs(T x){
	return(x>0?x:-x);
}
int sgn(int x){
	return(x?(x>0?1:-1):0);
}
int gcd(int a, int b){
	a=mabs(a);
	b=mabs(b);
	if(b==0){
		return a;
	}
	if(a==0){
		return b;
	}
	return gcd(b%a, a);
}
int lcm(int a, int b){
	return a*b/gcd(a, b);
}
struct Norm{
	int a;
	int b;
	Norm(){
		a=0;
		b=1;
	}
	Norm(int aa){
		a=aa;
		b=1;
		cool();
	}
	Norm(int aa, int bb){
		a=aa;
		b=bb;
		assert(b);
		cool();
	}
	void cool(){
		int d=gcd(a, b);
		a/=d;
		b/=d;
		if(b<0){
			b=-b;
			a=-a;
		}
	}
	Norm& operator*=(const Norm& x){
		a*=x.a;
		b*=x.b;
		cool();
		return *this;
	}
	Norm operator-(){
		return Norm(-a, b);
	}
	Norm& operator/=(const Norm& x){
		assert(x.a);
		a*=x.b;
		b*=x.a;
		cool();
		return *this;
	}
	Norm& operator+=(Norm x){
		int l=lcm(b, x.b);
		x.a*=(l/x.b);
		a*=(l/b);
		a+=x.a;
		b=l;
		cool();
		return *this;
	}
	Norm& operator-=(Norm x){
		x.a=-x.a;
		(*this)+=x;
		return *this;
	}
};
Norm operator/(Norm a, Norm b){
	return a/=b;
}
bool operator==(const Norm& a, const Norm& b){
	return(a.a==b.a)&&(a.b==b.b);
}
bool operator!=(const Norm& a, const Norm& b){
	return !(a==b);
}
bool operator<(const Norm& a, const Norm& b){
	return (a.a*b.b)<(b.a*a.b);
}
bool operator>(const Norm& a, const Norm& b){
	return b<a;
}
bool operator<=(const Norm& a, const Norm& b){
	return (a<b)||(a==b);
}
bool operator>=(const Norm& a, const Norm& b){
	return (a>b)||(a==b);
}
#define ld long double
#define EPS 1e-13

bool eq(ld a){
	if(mabs(a)<EPS){
		return 1;
	}
	return 0;
}
bool eq(ld a, ld b){
	return eq(a-b);
}
bool lt(ld a, ld b){
	return (!eq(a, b))&&(a<b);
}
bool gt(ld a, ld b){
	return lt(b, a);
}
bool le(ld a, ld b){
	return (eq(a, b)||lt(a, b));
}
bool ge(ld a, ld b){
	return le(b, a);
}
struct Ure{
	ld a;
	ld k;
	Ure(ld aa){
		a=aa;
		k=0;
	}
	Ure(ld aa, ld kk){
		a=aa;
		k=kk;
	}
	Ure& operator+=(Ure b){
		a+=b.a;
		k+=b.k;
		return *this;
	}
	Ure& operator-=(Ure b){
		a-=b.a;
		k-=b.k;
		return *this;
	}
	Ure& operator*=(ld x){
		a*=x;
		k*=x;
		return *this;
	}
	Ure& operator/=(ld x){
		a/=x;
		k/=x;
		return *this;
	}
	ld solve(){
		if(eq(k)&&eq(a)){
			return -2;
		}
		if(k==0){
			return -1;
		}
		ld ans=-a/k;
		if(ans<0){
			return -1;
		}
		return ans;
	}
};
Ure operator/(Ure s, ld b){
	return s/=b;
}

int n;
VPII v;
int solve(int a, int b){
	map<int, int> m;
	//-3 we
	//-2 always
	//-1 never
	//else when
	int cnt=0;
	fori(i, n){
		if(a==i){
			continue;
		}
		if(b==i){
			continue;
		}
		Ure x(0, 0);
		x+=Ure(v[b].x-v[a].x, v[b].y-v[a].y)/(b-a);
		x-=Ure(v[i].x-v[a].x, v[i].y-v[a].y)/(i-a);
		ld ans=x.solve();
		if(eq(ans, -2)){
			++cnt;
		}
		if(eq(ans, -1)){
			continue;
		}
		++m[ans*1000000000000];
	}
	int ma=0;
	for(auto p:m){
		rmax(ma, p.y);
	}
	return ma+cnt;
}
signed main(){
	cin>>n;
	v.resize(n);
	cin>>v;
	if(n==1){
		cout<<1<<endl;
		return 0;
	}
	int ma=0;
	fori(i, n){
		foriab(j, i+1, n){
			rmax(ma, solve(i, j));
		}
	}
	cout<<(ma+2)<<endl;
	return 0;
}
