#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define x first
#define y second
#define ll long long
#define ld long double

#define int ll
#define double ld

using namespace std;

const int inf = 1e9;
const int INF = 1e18;

int depth = 0;
int cur = 0;

int gcd(int a, int b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

void solve() {
    int n;
    cin >> n;
    vector<int> s(n), v(n);
    for (int i = 0; i < n; ++i)
        cin >> s[i] >> v[i];

    int res = min(n, 2LL);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                int a = j - i, b = k - j;

                int t1 = a * (s[k] - s[j]) + b * (s[i] - s[j]);
                int d1 = a * (v[j] - v[k]) + b * (v[j] - v[i]);

                if (t1 * d1 < 0)
                    continue;

                if (d1 == 0) {
                    if (t1 != 0)
                        continue;
                    else {
                        map<pair<int, int>, int> cnt;
                        int ans = 0;
                        int stable = 3;
                        for (int p = k + 1; p < n; ++p) {
                            int m = p - j;
                            int t2 = a * (s[p] - s[j]) + m * (s[i] - s[j]);
                            int d2 = a * (v[j] - v[p]) + m * (v[j] - v[i]);

                            if (t2 != 0 and d2 == 0)
                                continue;

                            else if (t2 == 0 and d2 == 0)
                                ++stable;
                            else if (t2 == 0)
                                ans = max(ans, ++cnt[{0, 0}]);
                            else {
                                int g = gcd(t2, d2);
                                ans = max(ans, ++cnt[{t2 / g, d2 / g}]);
                            }
                        }

                        res = max(res, ans + stable);
                    }
                }
                else {
                    int ans = 3;
                    for (int p = k + 1; p < n; ++p) {
                        int m = p - j;
                        int t2 = a * (s[p] - s[j]) + m * (s[i] - s[j]);
                        int d2 = a * (v[j] - v[p]) + m * (v[j] - v[i]);

                        if (t2 != 0 and d2 == 0)
                            continue;
                        if (t1 * d2 == t2 * d1)
                            ++ans;

                    }
                    res = max(res, ans);
                }
            }
        }
    }

    cout << res << endl;
}

signed main() {

#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL

    cout.precision(16);

    solve();
}
