#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define x first
#define y second
#define ll long long
#define ld long double

#define int ll
#define double ld

using namespace std;

const int inf = 1e9;
const int INF = 1e18;

const int maxn = 1e5;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int & e : a)
        cin >> e;
    for (int & e : b)
        cin >> e;
    bitset<maxn> swapped;
    mt19937 rnd;

    int xa = 0, xb = 0;
    for (int i = 0; i < n; ++i) {
        int da = (xa ^ a[i]) - xa;
        int db = (xb ^ b[i]) - xb;

        int dsa = (xa ^ b[i]) - xa;
        int dsb = (xb ^ a[i]) - xb;

        if (da + db < dsa + dsb) {
            swap(a[i], b[i]);
            swapped[i] = true;
        }

        xb ^= b[i];
        xa ^= a[i];
    }

    for (int _ = 0; _ < 1e7; ++_) {
        int x = rnd() % n;

        if (((xa ^ a[x] ^ b[x]) + (xb ^ a[x] ^ b[x])) > xa + xb) {
            swapped[x] = !swapped[x];
            xa = xa ^ a[x] ^ b[x];
            xb = xb ^ a[x] ^ b[x];
            swap(a[x], b[x]);
        }
    }

    cout << xa + xb << " " << swapped.count() << endl;
    for (int i = 0; i < n; ++i)
        if (swapped[i])
            cout << i + 1 << " ";
    cout << endl;

}

signed main() {

#ifdef LOCAL
freopen("in.txt", "r", stdin);
#else
cin.tie(NULL);
cout.tie(NULL);
ios_base::sync_with_stdio(false);
#endif // LOCAL

    cout.precision(16);

    solve();
}
