#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
using namespace std;

double t, x;

double f(double m)
{
	if (m < (double)t / 6)
		return (t - m) * m * x / t * 6;
	return (x + (100 - x) * (6  * m - t) / t) * (t - m);
}

int main() {
	double m1, m2, l, r;
	cin >> x >> t;
	l = 0, r = t / 3;
	while (r - l > 1e-10)
	{
		m1 = (r - l) / 3 + l;
		m2 = m1 + (r - l) / 3;
		if (f(m1) < f(m2))
			l = m1;
		else if (f(m1) > f(m2))
			r = m2;
		else
			l = r = m1;

	}
	cout << setprecision(12);
	cout << f(r);
}