#include <iostream>
#include <cmath>

int64_t Reverse( int64_t a )
{
  int64_t sum =  0, aa = a;
  int st = 0, dop = (aa /= 10);

  while (dop != 0)
  {
    st++;
    dop = (aa /= 10);
  }

  for (int i = 0; i < st; i++)
  {    
    int dz = a % (int)pow(10, i + 1) / (int)pow(10, i);
    a -= dz;
    sum += dz * (int)pow(10, st - i);
  }

  sum += a / pow(10, st);

  return sum;
}

int IsPow2( int64_t a )
{
  int64_t Sqr = (int64_t)sqrt(a);

  if (Sqr * Sqr == a)
    return 1;

  return 0;
}

int main( void )
{
  int64_t a, b, Sqra, Sqrb;
  int full = 0;

  std::cin >> a >> b;

  Sqra = ceil(sqrt(a));
  Sqrb = (int64_t)sqrt(b);
  
  for (; Sqra <= Sqrb; Sqra++)
  {
    if (IsPow2(Reverse(Sqra * Sqra)) && ((Sqra % 10) != 0 || Sqra < 10))
      full++;
  }

  std::cout << full;

  return 0;
}