#include <bits/stdc++.h>
#define ll long long
using namespace std;
const int N = 1e6 + 5, oo = 1e9 + 10;
int main() {
   ios::sync_with_stdio(0); cin.tie(0);
   int n, m; cin >> n >> m;
   swap(n, m);
   vector<int> l(n + 1), r(n + 1);
   for (int i = 1; i <= n; ++i) {
      cin >> l[i] >> r[i];
   }
   vector<vector<int>> dp(n + 5, vector<int>(m + 5));
   for (int i = 1; i <= m; ++i) {
      dp[1][i] = abs(l[1] - i);
      if (i + r[1] - l[1] > m) {
         dp[1][i] = oo;
      }
   }
   for (int i = 2; i <= n; ++i) {
      int start = 1;
      deque<pair<int, int>> q;
      auto push = [&](pair<int, int> p) {
         while (!q.empty() && q.back().first >= p.first) q.pop_back();
         q.push_back(p);
      };
      auto erase = [&](int id) {
         while (!q.empty() && q.front().second < id) q.pop_front();
      };
      auto query = [&](int L, int R) -> int { 
         // int ans = oo;
         // for (int x = L; x <= R; ++x) {
         //    ans = min(ans, dp[i - 1][x]);
         // }
         // return ans;
         while (start <= R) {
            push({dp[i - 1][start], start});
            ++start;
         }
         erase(L);
         return q.front().first;
      };
      for (int j = 1; j <= m; ++j) {
         int A = r[i] - l[i] + 1;
         int B = r[i - 1] - l[i - 1] + 1;
         if (j + A - 1 > m) {
            dp[i][j] = oo;
            continue;
         }
         int L = max(j - B + 1, 1);
         int R = min(j + A - 1, m);
         dp[i][j] = query(L, R) + abs(l[i] - j);
      }
   }
   int ans = oo;
   for (int i = 1; i <= m; ++i) {
      ans = min(ans, dp[n][i]);
   }
   cout << ans << endl;
}
