#pragma GCC target("avx2")
#pragma GCC optimization("O3")
#pragma GCC optimization("unroll-loops")

#include <set>
#include <map>
#include <queue>
#include <deque>
#include <stack>
#include <ctime>
#include <random>
#include <cmath>
#include <vector>
#include <bitset>
#include <string>
#include <cstring>
#include <iomanip>
#include <assert.h>
#include <iostream>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define pf push_front
#define ppb pop_back
#define ppf pop_front
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define bpp __builtin_popcount
#define dbg(var) cout << endl << #var << "=" << var << endl;
#define show(vec) {cout << endl << sz(vec) << endl; for(int el : vec) cout << el << " "; cout << endl;}

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int,int> pii;

ll binpow(ll a,ll b){
    ll res = 1;
    while(b > 0){
        if(b & 1)
            res *= a;
        a *= a;
        b >>= 1;
    }
    return res;
}

ll powmod(ll a,ll b,ll m){
    ll res = 1;
    while(b > 0){
        if(b & 1)
            res = (res * a) % m;
        a = (a * a) % m;
        b >>= 1;
    }
    return res;
}

int GCD(int a,int b){
    return (b > 0 ? GCD(b,a % b) : a);
}

const int N = 2e5 + 5;
const int mod = 1e9 + 7;
const ll inf = 1e18 + 18;
const double pi = acos(-1.0);
const double eps = 1e-9;

int n,a[N],pref[N],ans;

map<int,int> q;

inline void solve(){
    cin >> n;
    for(int j = 1; j <= n; j++){
        string s,q = "";
        cin >> s;
        q += s[0];
        for(int i = 1; i < sz(s); i++){
            if(q[sz(q) - 1] == 'a' || q[sz(q) - 1] == 'e' || q[sz(q) - 1] == 'i' || q[sz(q) - 1] == 'o' || q[sz(q) - 1] == 'u'){
                if(s[i] != 'a' && s[i] != 'e' && s[i] != 'i' && s[i] != 'o' && s[i] != 'u'){
                    q += s[i];
                }
            }
            else{
                q += s[i];
            }
        }
        int kol = 0;
        for(int i = 0; i < sz(q); i++){
            if(q[i] == 'a' || q[i] == 'e' || q[i] == 'i' || q[i] == 'o' || q[i] == 'u'){
                kol++;
            }
        }
        a[j] = kol;
    }
    q[0] = 0;
    for(int i = 1; i <= n; i++){
        pref[i] = pref[i - 1] + a[i];
        //cout << pref[i] << endl;
        if(q.find(pref[i] - 17) != q.end()){
            int l = q[pref[i] - 17] + 1,r = i;
            int pos1 = -1;
            for(int j = l; j <= r; j++){
                if(pref[j] - pref[q[pref[i] - 17]] == 5){
                    pos1 = j;
                    break;
                }
            }
            if(pos1 != -1){
                int pos2 = -1;
                for(int j = pos1 + 1; j <= r; j++){
                    if(pref[j] - pref[pos1] == 7){
                        pos2 = j;
                        break;
                    }
                }
                if(pos2 != -1) ans++;
            }
        }
        q[pref[i]] = i;
    }    
    cout << ans;
}

signed main(){
	/*#ifndef ONLINE_JUDGE
		freopen("input.txt","r",stdin);
		freopen("output.txt","w",stdout);
	#endif*/
	ios_base::sync_with_stdio(0),cin.tie(0),cout.tie(0);
	int tt = 1;
	//cin >> tt;
	while(tt--) solve();
	return 0;
}