﻿#include <iostream>
#include <vector>

typedef __int128_t bigint;
using namespace std;
//#define bigint int64_t
int main() {

    long long a, b;
    cin >> a >> b;
    vector<pair<long long, long long>> ans;
    while (a != 0 && b != 0) {
        bigint ta = abs(a), tb = abs(b);
        if (ta > tb) {
            bigint tmp = ((a % b) + b) % b;
            long long k = (tmp - a) / b;
            a = a + b * k;
            ans.push_back({1, k});
        } else {
            bigint tmp = ((b % a) + a) % a;
            long long k = (tmp - b) / a;
            b = b + a * k;
            ans.push_back({2, k});
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.first << ' ' << i.second << '\n';
    }
    return 0;
}
