#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <cmath>
#include <ctime>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <limits>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
using namespace std;

typedef long long ll;
typedef long double ld;
#define ff first
#define ss second

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll N = 64;
ll n, k = 0, m, a, b;
ll cnt = 0; 

double T, X;
double yf(double x0)
{
	if (x0 > T / 3)
	{
		return 100;
	}
	if (x0 > T / 6)
	{
		return 2 * ((-3 * (X - 100) * x0) / T + X - 50);
	}
	return (6 * X * x0) / T;
}

int main() {
	cin >> X >> T;
	double l = 0, r = T, EPS = 0.0000000001;
	while (r - l > EPS) {
		double m1 = l + (r - l) / 3,
			m2 = r - (r - l) / 3;
		if (yf(m1) * (T - m1) < yf(m2) * (T - m2))
			l = m1;
		else
			r = m2;
	}
	cout << fixed << setprecision(6) << yf(l) * (T - l);
	return 0;
}