import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;

public class Main {
    public static void main(String[] args) throws IOException {
        BufferedReader r = new BufferedReader(new InputStreamReader(System.in));
        int n = Integer.parseInt(r.readLine());
        int[] in = new int[n];
        for (int i = 0; i < n; i++)
            in[i] = calcGls(r.readLine());
        int count = 0;
        for (int i = 0; i < in.length; i++) {
            int add = calcTo(in, i, 5, true);
            if (add == -1) continue;
            add = calcTo(in, add, 7, true);
            if (add == -1) continue;
            add = calcTo(in, add, 5, false);
            if (add != -1) count++;
        }
        System.out.println(count);
    }

    private static int calcTo(int[] in, int add, int req_len, boolean nock) {
        int len = 0;
        int i;
        for (i = add; i < in.length; i++) {
            len += in[i];
            if (len >= req_len) break;
        }
        if (len != req_len) return -1;
        i++;
        if (i >= in.length && nock) return -1;
        return i;
    }

    private static int calcGls(String r) {
        boolean t = false;
        int count = 0;
        for (int j = 0; j < r.length(); j++) {
            char c = r.charAt(j);
            if (c == 'a' || c == 'e' || c == 'i' || c == 'o' || c == 'u') {
                if (!t) {
                    count++;
                    t = true;
                }
            } else
                t = false;
        }
        return count;
    }
}
