#include <iostream>
#include <vector>
#include <set>
#define long long long

using namespace std;

int n;

bool check(char s, vector<char>& g) {
    for (int i = 0; i < (int)g.size(); i++) {
        if (g[i] == s)
            return true;
    }
    return false;
}

int binSearch(int i, vector<long>& pref, int val) {
    int l = i, r = n - 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if ((pref[m] - pref[i] >= val && i != -1) || (i == -1 && pref[m] >= val))
            r = m;
        else
            l = m;
    }
    return r;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    cin >> n;
    vector<char> g = {'a', 'e', 'i', 'o', 'u'};
    vector<int> a(n);
    vector<long> pref(n);
    for (int i = 0; i < n; i++) {
        string s; cin >> s;
        if (check(s[0], g))
            a[i]++;
        for (int j = 1; j < (int)s.size(); j++) {
            if (check(s[j], g) && !check(s[j - 1], g)) {
                a[i]++;                
            }
        }
    }
    pref[0] = a[0];
    for (int i = 1; i < n; i++) {
        pref[i] = pref[i - 1] + a[i];
    }
    int ans = 0;
    int r = binSearch(-1, pref, 17);
    int i1 = binSearch(-1, pref, 5);
    int i2 = binSearch(i1, pref, 7);
    if (pref[r] - pref[i2] == 5 && pref[i2] - pref[i1] == 7 && pref[i1] == 5)
        ans++;
    for (int i = 0; i < n; i++) {
        int r = binSearch(i, pref, 17);
        int i1 = binSearch(i, pref, 5);
        int i2 = binSearch(i1, pref, 7);
        if (pref[r] - pref[i2] == 5 && pref[i2] - pref[i1] == 7 && pref[i1] - pref[i] == 5)
            ans++;
    }
    cout << ans;
    return 0;
}
