#include <iostream>
#include <vector>

long long a, b;
std::vector<std::pair<long long, long long>> ans;

void gcd(long long a, long long b) {
    bool f = true;
    while (b) {
        ans.push_back({ (f ? 1 : 2), -a / b });
        a %= b;
        std::swap(a, b);
        f = !f;
    }
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    std::cin >> a >> b;
    gcd(a, b);
    std::cout << ans.size() << "\n";
    for (long long i = 0; i < ans.size(); i++)
        std::cout << ans[i].first << " " << ans[i].second << "\n";
    return 0;
}