﻿#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <bitset>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <cctype>
#include <cassert>
#include <climits>
#include <ctime>
#include <iostream>
#include <iomanip>
#include <functional>
#include <map>
#include <string>
#include <queue>
#include <stack>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <array>
#include <random>
#include <chrono>

//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,fma")
//#pragma GCC optimization ("O3")
//#pragma GCC optimization ("unroll-loops")
using namespace std;
using namespace std::chrono;

#define all(x) x.begin(), x.end()
#define int long long

template <class T>
istream& operator >>(istream& in, vector<T>& arr) {
	for (T& cnt : arr) {
		in >> cnt;
	}
	return in;
}

const int N = 2e5 + 1;
const int INF = 2e9;

int morgen(int l, int r) {
    return l + r * 100000;
}

void solve() {
    int n;
    cin >> n;
    vector<int> ans(n + 1, 0);
    vector<int> pr(n + 2, 0);
    unordered_set<int> bad;
    for (int i = 1; i <= n; ++i) {
        int l = i, r = i;
        while (bad.count(morgen(l, r))) {
            --l;
        }
        cout << "? " << l << " " << r << endl;
        int a, bad_l, bad_r;
        cin >> a >> bad_l >> bad_r;
        cout << endl;
        bad.insert(morgen(bad_l, bad_r));
        ans[i] = a - pr[i] + pr[l];
        pr[i + 1] = pr[i] + ans[i];
    }
    cout << "!\n";
    for (int i = 1; i <= n; ++i)
        cout << ans[i] << " ";
    cout << endl;
}


signed main() {
	//ios_base::sync_with_stdio(false);
	//cin.tie(0); cout.tie(0);
	//freopen("game.in", "r", stdin);
	//freopen("game.out", "w", stdout);
	int _t = 1; //cin >> _t;
	while (_t--) {
		solve();
		//gen();
	}
}