﻿#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <bitset>
#include <fstream>
#include <cstdlib>
#include <functional>
#include <climits>
#include <queue>
#include <time.h>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <cassert>

using namespace std;

#define magic_define cin.tie(NULL); ios_base::sync_with_stdio(false); cout << fixed; cout.precision(17);
#define ll long long
#define pii pair<int, int>
#define vi vector<int>

const int ONF = 1e9;

void solve() {
    int n, m; cin >> n >> m;
    vector<pair<int, int>> ez_suka(m);
    vector<int> dt(m);
    for (int i = 0; i < m; i++) {
        cin >> ez_suka[i].first >> ez_suka[i].second;
        ez_suka[i].first--; ez_suka[i].second--;
        dt[i] = ez_suka[i].second - ez_suka[i].first;
    }
    vector<vector<int>> dp(m, vector<int>(n, ONF));
    for (int i = 0; i < n - dt[0]; i++) {
        int d = abs(ez_suka[0].first - i);
        dp[0][i] = d;
    }
    for (int i = 1; i < m; i++) {
        multiset<int> pq;
        for (int j = 0; j < dt[i]; j++) {
            pq.insert(dp[i - 1][j]);
        }
        for (int j = 0; j < n - dt[i]; j++) {
            pq.insert(dp[i - 1][j + dt[i]]);
            int mn = *pq.begin();
            int d = abs(j - ez_suka[i].first);
            dp[i][j] = mn + d;
            if (j >= dt[i - 1]) {
                pq.erase(pq.find(dp[i - 1][j - dt[i - 1]]));
            }
        }
    }
    int ans = ONF;
    for (int i = 0; i < n; i++) {
        ans = min(ans, dp[m - 1][i]);
    }
    cout << ans << '\n';
}

int32_t main() {
    magic_define;
    solve();
    return 0;
}