#include <iostream>
#include <algorithm>
#include <random>
#include <utility>
#include <vector>
#include <string>
#include <cstdio>
#include <set>
#include <fstream>
#include <climits>
#include <cmath>
#include <deque>
#include <map>
#include <ctime>
#include <random>
#include <unordered_set>
#include <chrono>
#include <queue>
#include <unordered_map>
#include <cassert>
#include <bitset>
//#include <bits/stdc++.h>

using namespace std;

#define int ll
#define endl endl

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair <int , int> pii;
typedef pair <ll , ll> pll;
typedef pair <ld , ld> pld;
typedef vector<int> vi;
typedef vector<bool> vb;
typedef vector<vector<bool>> vvb;
typedef vector<vector<int>> vvi;
typedef vector<pair<int, int>> vpii;
typedef vector<vpii> vvpii;

#define ff first
#define ss second
#define pb push_back
#define pp pop_back

#define IO ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
std::mt19937 rng(std::chrono::steady_clock::now().time_since_epoch().count());
int random(int left, int right){return std::uniform_int_distribution<int>(left, right)(rng);}
#define out(a) cout << a << " ";
#define endss cout << endl;
#define here cout << "here" << endl;
#define smile cout << char(2);
#define print(x) { for (auto xxxxxxxxx : (x)) cout << xxxxxxxxx << ' '; cout << '\n'; }
#define printp(x) { for (auto &xxxxxxxxx : (x)) cout << xxxxxxxxx.ff << " " << xxxxxxxxx.ss << cout << '\n'; }
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

void solve() {
    IO
    int n, m;
    cin >> n >> m;
    vector <pair <int, int>> arr(m + 1);
    for (int i = 1; i <= m; i++) cin >> arr[i].ff >> arr[i].ss;
    vector <vector <int>> dp(n + 1, vector <int> (m + 1, -1));
    for (int j = 1; j <= m; j++) {
        for (int i = 1; i <= n; i++) {
            if (i >= arr[j].ff && i <= arr[j].ss) dp[i][j] = 0;
        }
        for (int i = arr[j].ff - 1; i >= 1; i--) dp[i][j] = dp[i + 1][j] + 1;
        for (int i = arr[j].ss + 1; i <= n; i++) dp[i][j] = dp[i - 1][j] + 1;
    }
    for (int j = 2; j <= m; j++) {
        multiset <int> otr;
        int l = arr[j].ff, r = arr[j].ss;
        for (int i = l; i <= r; i++) otr.insert(dp[i][j - 1]);
        for (int i = l; i <= r; i++) {
            dp[i][j] = *otr.begin();
        }
        int tmp = 1;
        for (int i = l - 1; i >= 1; i--) {
            otr.erase(otr.find(dp[i + (r - l) + 1][j - 1]));
            otr.insert(dp[i][j - 1]);
            dp[i][j] = tmp + *otr.begin();
            tmp++;
        }
        otr.clear();
        for (int i = l; i <= r; i++) otr.insert(dp[i][j - 1]);
        tmp = 1;
        for (int i = r + 1; i <= n; i++) {
            otr.erase(otr.find(dp[i - r + l - 1][j - 1]));
            otr.insert(dp[i][j - 1]);
            dp[i][j] = tmp + *otr.begin();
            tmp++;
        }
    }
    int res = LLONG_MAX;
    for (int i = 1; i <= n; i++) {
        if (dp[i][m] < res && dp[i][m] != -1) res =dp[i][m];
    }
    cout << res;
}


signed main(){
    //get();
    solve();
}