//@author: Kirkon

#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <stack>
#include <chrono>
#include <cstdio>
#include <cstdlib>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef float ff;
typedef double lf;
typedef long double llf;

const double eps = 1e-6;
const int int_inf = 2 * 1e9;
const ll ll_inf = 8 * 1e18;

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second
#define vi vector<int>
#define vii vector<pair<int, int>>
#define vvi vector<vi>
#define vvii vector<vii>
//#define int long long
//#pragma GCC target("sse, sse2, sse3, ssse3, sse4, popcnt, abm, mmx, avx, avx2, tune=native")
#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;

istream& operator >> (istream& in, pii& i) {
    in >> i.first >> i.second;
    return in;
}

template<class T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& i : a) {
        in >> i;
    }
    return in;
}

template<class T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto i : a) {
        out << i;
    }
    return out;
}

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
    return (ull)rng() % B;
}

ll binpow(ll a, int k){
    if(k == 0) return 1LL;
    if(k == 1) return a;
    ll x = binpow(a, k / 2);
    if(k % 2 == 0) return x * x;
    return x * x * a;
}

ll phin(ll n) { ll number = n; if (n % 2 == 0) { number /= 2; while (n % 2 == 0) n /= 2; } for (ll i = 3; i * i <= n; i += 2) { if (n % i == 0) { while (n % i == 0)n /= i; number = (number / i * (i - 1)); } } if (n > 1)number = (number / n * (n - 1)); return number; } //O(sqrt(N))

void solve(){
    int n;
    cin >> n;
    set<pii> q;
    vector<ll> pref(n + 1, 0);
    vector<int> a(n);
    cout << "? 1 1\n";
    int l, r, num;
    cin >> num >> l >> r;
    a[0] = num;
    pref[1] = num;
    q.insert({l, r});
    for(int i = 1; i < n; ++i){
        int l = 1, r = i + 1;
        while(q.find(make_pair(l, r)) != q.end()){
            ++l;
            if(l > r) {
                assert(false);
            }
        }
        cout << "? " << l << " " << r << '\n';
        --l; --r;
        ll number;
        int x, y;
        cin >> number >> x >> y;
        q.insert({x, y});
        ll real_num = number - (pref[r] - pref[l]);
        a[i] = real_num;
        pref[r + 1] = pref[r] + a[i];
    }
    cout << "!\n";
    for(auto i : a){
        cout << i << " ";
    }
    cout << '\n';
    return;
}


signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    
    int tt = 1;
    //cin >> tt;
    while(tt--){
        solve();
    }
    return 0;
}

