//@author: Kirkon

#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <stack>
#include <chrono>
#include <cstdio>
#include <cstdlib>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef float ff;
typedef double lf;
typedef long double llf;

const double eps = 1e-6;
const int int_inf = 2 * 1e9;
const ll ll_inf = 8 * 1e18;

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second
#define vi vector<int>
#define vii vector<pair<int, int>>
#define vvi vector<vi>
#define vvii vector<vii>
//#define int long long
//#pragma GCC target("sse, sse2, sse3, ssse3, sse4, popcnt, abm, mmx, avx, avx2, tune=native")
#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;

istream& operator >> (istream& in, pii& i) {
    in >> i.first >> i.second;
    return in;
}

template<class T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto& i : a) {
        in >> i;
    }
    return in;
}

template<class T>
ostream& operator << (ostream& out, vector<T>& a) {
    for (auto i : a) {
        out << i;
    }
    return out;
}

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
    return (ull)rng() % B;
}

ll binpow(ll a, int k){
    if(k == 0) return 1LL;
    if(k == 1) return a;
    ll x = binpow(a, k / 2);
    if(k % 2 == 0) return x * x;
    return x * x * a;
}

ll phin(ll n) { ll number = n; if (n % 2 == 0) { number /= 2; while (n % 2 == 0) n /= 2; } for (ll i = 3; i * i <= n; i += 2) { if (n % i == 0) { while (n % i == 0)n /= i; number = (number / i * (i - 1)); } } if (n > 1)number = (number / n * (n - 1)); return number; } //O(sqrt(N))

void solve(){
    int n, a, b;
    cin >> n >> a >> b;
    vector<int> A(n), B(n);
    vector<int> good(n, 0);
    ll ans = 0;
    for(int i = 0; i < n; ++i) cin >> A[i];
    for(int i = 0; i < n; ++i) cin >> B[i];
    int cnt_a = 0, cnt_b = 0;
    for(int cur = 0; cur < n; ++cur){
        if(A[cur] > B[cur]){
            ans += A[cur];
            good[cur] = 1;
            cnt_a++;
        }else{
            ans += B[cur];
            good[cur] = 2;
            cnt_b++;
        }
    }
    if(cnt_a >= a && cnt_b >= b){
        cout << ans;
        return;
    }
    if(cnt_a < a){
        vector<pair<int,int>> diffs(n);
        for(int i = 0; i < n; ++i){
            diffs[i] = {B[i] - A[i], i};
        }
        sort(all(diffs));
        int cur = 0;
        while(cnt_a < a){
            if(good[diffs[cur].se] == 1){
                ++cur;
                continue;
            }
            ans -= diffs[cur].fi;
            good[diffs[cur].se] = 1;
            ++cnt_a;
            ++cur;
        }
    }else{
        vector<pair<int,int>> diffs(n);
        for(int i = 0; i < n; ++i){
            diffs[i] = {A[i] - B[i], i};
        }
        sort(all(diffs));
        int cur = 0;
        while(cnt_b < b){
            if(good[diffs[cur].se] == 2){
                ++cur;
                continue;
            }
            ans -= diffs[cur].fi;
            good[diffs[cur].se] = 2;
            ++cnt_b;
            ++cur;
        }
    }
    cout << ans << '\n';
    for(int i = 0; i < n; ++i){
        cout << (good[i] == 2 ? "P " : "T ");
    }
    
    return;
}


signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    
    int tt = 1;
    //cin >> tt;
    while(tt--){
        solve();
    }
    return 0;
}


